/*
	TBase.h
	{Iȃf[^\̃T|[g
	Xg̍\ΏۂɂȂNX
	XgNX
	zNX
	[NX
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make :	1996.02.03	1.0			Takeshi Yoneki
			1996.02.19	1.0			Takeshi Yoneki	NXg
*/

#ifndef _CBASE_H_
#define _CBASE_H_

#define	OK			0
#define	NG			-1
#define	ON			1
#define	OFF			0

class TBase;
class TListBase;
class TArrayBase;
class TMemory;

/*
	TBase
	Xg̍\ΏۂɂȂNX
*/
class TBase {
	friend class TListBase;
private:
	TBase *m_next;
	TBase *m_prev;
public:
	TBase();
	virtual ~TBase();
	TBase *GetNext() {
		return m_next;
	}
	TBase *GetPrev() {
		return m_prev;
	}
};

/*
	TListBase
	XgNX
	0`n
	͂܂lĂȂ
	vf傫ȂƔ
	
		for (int i = 0; i < GetCount(); i++)
		{
			item = GetNth(i);
			.....
		}
	Ƃ悤ȍ\͍ňŁAƂ
		for (item = GetTop(); item != NULL; item = item->GetNext())
		{
			.....
		}
	ƏȂƁAʂɏH͂߂ɂȂ
*/
class TListBase : public TBase {
private:
	TBase *m_top;
	TBase *m_last;
	int m_count;
public:
	TListBase();
	~TListBase();
	TBase *GetTop() {
		return m_top;
	}
	TBase *GetLast() {
		return m_last;
	}
	int GetCount() {
		return m_count;
	}
	void ClearListBase();
	void CopyFromArray(TArrayBase& array);	/* TArrayBasẽRs[ */
	void Append(TBase *item);	/* Xg̍Ōɒǉ */
	void Insert(TBase *prev, TBase *item);	/* } */
	// prevNULLw肷Ɛ擪ɂȂ
	void Insert(int n, TBase *item);
	// n0w肷Ɛ擪ɂȂ
	Boolean LinkCheck(TBase *item);
	Boolean Remove(TBase *item);	/* Xg̍폜 */
	Boolean Remove(int n);
	void RemoveDelete(TBase *item);	/* Xg폜ăfXgNg */
	void RemoveDelete(int n);
	void RemoveAll();
	void RemoveDeleteAll();
	int GetOrder(TBase *item);	/* 𓾂 */
	void MoveToTop(TBase *item);	/* 擪Ɉړ */
	TBase *GetNth(int n);	/* ԍœ */
};

/*
	TArrayBase
	zNX
*/
typedef int (*FUNC_QSORT_COMPARE)(const void *elem1, const void *elem2);

class TArrayBase : public TBase {
private:
	TBase **m_array;
	int m_count;
	int m_expandCount;
public:
	TArrayBase();
	TArrayBase(int count);
	~TArrayBase();
	void CopyFromList(TListBase& list);	/* TListBasẽRs[ */
	void ChangeCount(int count);
	void SetNth(int n, TBase *item);
	TBase *GetNth(int n);
	int GetCount() {
		return m_count;
	}
	TBase *operator [](int n) {
		return GetNth(n);
	}
	int GetOrder(TBase *item);
	void qsort(FUNC_QSORT_COMPARE compFunc) {
		::qsort(m_array, m_count, sizeof (TBase *), compFunc);
	}
	void RemoveDeleteAll();
	/* g */
	void Expand(int count);
	void Append(TBase *item);
	void Remove(TBase *item);
private:
	void Initial();
};

/*
	TAppleObject
	OSAłObjectBaseClass
*/
/*
	NXCuTAppleObjectpׂȂ͉̂B
	lɈӖ̂NX
		lɈӖ̂NX́A{Iȍ\񋟂̂Ȃ̂ŁA
		AppleObjectƖ֌WȃNXpӂāAƂ͕ʂTAppleObject
		pNXpӂB
		ƂTAppleObjectTString𗼕pTStringObjectpӂB
		vpeBƂĎg邱Ƃ悤B
		K{z֐
			GetObjectType()
			OnAppleEvent()
		1996.08.08	͂TString͒TAppleObjectp
	CX^XɈӖ̂NX
		CX^XɈӖ̂NX́Ax傫A܂pIȍ\
		񋟂̂Ȃ̂ŁATAppleObjectpNXpӂB
		ƂTEditorTAppleObjectpB
		GgƂĎg꓾邩ȁB
*/
class TAppleObject : public TListBase {
public:
	Boolean m_isTemporary;
	TAppleObject *m_container;
	//	DescType m_desiredClass;	/* sɗvꂽNXi[ */
	TAppleObject();
	virtual OSErr CreateToken(DescType desiredClass, AEDesc *token);
	Boolean IsTemporary() {
		return m_isTemporary;
	}
	void BeTemporary(TAppleObject *container = NULL) {
		m_isTemporary = TRUE;
		SetContainer(container);
	}
	void SetContainer(TAppleObject *container) {
		if (container != NULL)
			m_container = container;
	}
	TAppleObject *GetContainer() {
		return m_container;
	}
	TAppleObject *GetNext() {
		return (TAppleObject *)TBase::GetNext();
	}
	TAppleObject *GetPrev() {
		return (TAppleObject *)TBase::GetPrev();
	}
	TAppleObject *GetTop() {
		return (TAppleObject *)TListBase::GetTop();
	}
	/**/
	/* TAppleObjectpNX͈ȉ̉z֐ */
	/* ԍł̃ANZX͂P`ƂȂ */
	/* eIuWFNg̎ʂ킷fXNv^^CvԂ */
	virtual DescType GetObjectType();
	/* eIuWFNg̖OԂ@ÔȂNX͂肦 */
	virtual CFStringRef GetObjectName();
	/* IuWFNgg̏Ԃ */
	virtual long GetObjectNumber();
	/* Cӂ̃IuWFNgԍ𓾂iJgӖĂ悢j */
	virtual long GetAnyContainedObjectNumber();
	/* ŊܗLIuWFNg𓾂 */
	virtual TAppleObject *GetContainedObjectByNumber(DescType desiredClass, int n);
	/* ܗLIuWFNgL[ň */
	virtual TAppleObject *GetContainedObject(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	/* vpeB𓾂 */
	virtual TAppleObject *GetObjectProperty(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	/* ܗLIuWFNg̐𓾂 */
	virtual long CountContainedObjects(DescType desiredClass);
	/* IuWFNg̔r */
	virtual Boolean CompareObjects(DescType oper, TAppleObject *obj);
	/* Cxg */
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	/* eւ̃CxgtbN */
	virtual OSErr OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result);
	/* IuWFNgXyVt@CA𓾂 */
	/* ̎ł͏ł̎wƂȂ */
	virtual OSErr GetObjSpecifier(DescType desiredClass, AEDesc *objSpec);
	/* GetObjSpecifierŒʂ蔲ƂɎg */
	OSErr ThroughObjSpecifier(DescType desiredClass, AEDesc *objSpec);
};

/*
	TAppleObjectArray
	XgԂ߂̃NX
	T^IԃNX
*/

class TAppleObjectArray : public TAppleObject {
public:
	TAppleObject **m_obj;
	int m_count;
	TAppleObjectArray(int n, TAppleObject *container);
	virtual ~TAppleObjectArray();
	TAppleObject *GetNthObj(int n);
	void SetNthObj(int n, TAppleObject *obj);
	virtual DescType GetObjectType() {
		return classAppleObjectArray;
	}
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual TAppleObject *GetContainedObject(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	virtual TAppleObject *GetObjectProperty(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	virtual OSErr OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result);
	virtual OSErr GetObjSpecifier(DescType desiredClass, AEDesc *objSpec) {
		return ThroughObjSpecifier(desiredClass, objSpec);
	}
};

/*
	TMemory
	NX
*/
class TMemory : public TBase {
private:
	char *m_data;
	long m_length;
public:
	TMemory();
	TMemory(long length);
	virtual ~TMemory();
	operator char *() const {
		return GetPtr();
	}
	void operator=(TString& cs);	/* TString̃Rs[ */
	void operator=(const TMemory& cs);	/* TMemorỹRs[ */
	char GetAt(int n);
	void SetAt(int n, char c);
	void ChangeLength(long length);
	void ExpandLength(long addLength);
	long GetLength() const {
		return m_length;
	}
	void memset(int fill = 0) {
		::memset(m_data, fill, m_length);
	}
	Ptr GetPtr() const;
private:
	void InitTMemory();
};

/*
	TTempMemory
	e|NX
*/
class TTempMemory : public TBase {
	Handle m_h;
public:
	Ptr m_p;
	size_t m_size;
	OSErr m_error;
	TTempMemory();
	TTempMemory(size_t sz);
	~TTempMemory();
	void Create(size_t sz);
	void Dispose();
	Ptr GetPtr() const;
	size_t GetSize() const {
		return m_size;
	}
	long GetLength() const {
		return m_size;
	}
	TTempMemory *GetNext() {
		return (TTempMemory *)TBase::GetNext();
	}
	void memset(int fill = 0) {
		::memset(GetPtr(), fill, GetLength());
	}
private:
	void InitTTempMemory();
};

#endif
