/*
	TControl.cpp
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.06.28	1.0			Takeshi Yoneki
		 : 1997.01.06	1.5			Takeshi Yoneki
*/

#include "csystem.h"

void TDataBrowserControl::AddColumn(long id, TString name, UInt16 width, DataBrowserPropertyType propertyType, DataBrowserPropertyFlags flags) {
	DataBrowserListViewColumnDesc columnDesc;
	columnDesc.headerBtnDesc.version = kDataBrowserListViewLatestHeaderDesc;
	columnDesc.headerBtnDesc.titleOffset = 0;
	columnDesc.headerBtnDesc.btnFontStyle.flags	= kControlUseFontMask | kControlUseJustMask;
	columnDesc.headerBtnDesc.btnContentInfo.contentType = kControlNoContent;
	columnDesc.headerBtnDesc.btnFontStyle.just = teFlushDefault;
	columnDesc.headerBtnDesc.btnFontStyle.font = kControlFontViewSystemFont;
	columnDesc.headerBtnDesc.btnFontStyle.style = normal;
	columnDesc.headerBtnDesc.titleString = name;
	columnDesc.headerBtnDesc.minimumWidth = 3;
	columnDesc.headerBtnDesc.maximumWidth = 500;
	columnDesc.propertyDesc.propertyType = propertyType;
	columnDesc.propertyDesc.propertyID = id;
	columnDesc.propertyDesc.propertyFlags = flags;
	//	(kDataBrowserListViewDefaultColumnFlags | kDataBrowserListViewSelectionColumn);
	AddDataBrowserListViewColumn(&columnDesc, kDataBrowserListViewAppendColumn);
	SetDataBrowserTableViewNamedColumnWidth(id, width);
}

OSStatus TDataBrowserControl::SetDataBrowserItemDataText(DataBrowserItemDataRef itemData, TCFString s) {
	return ::SetDataBrowserItemDataText(itemData, s);
	/*
		CFStringRef text = s;
		OSStatus result = ::SetDataBrowserItemDataText(itemData, text);
		::CFRelease(text);
		return result;
	*/
}

OSStatus TDataBrowserControl::GetDataBrowserItemDataText(DataBrowserItemDataRef itemData, TCFString& s) {
	CFStringRef text = NULL;
	OSStatus result = ::GetDataBrowserItemDataText(itemData, &text);
	if (result == noErr && text != NULL) {
		s = text;
		::CFRelease(text);
	}
	return result;
}

/*
	TScrapStuff
	XNbvX^btNX
*/

long TScrapStuff::GetScrapTextSize() {
	Size sz = 0;
	if (m_error == noErr) {
		m_error = GetScrapFlavorSize(m_scrapInfo, kScrapFlavorTypeText, &sz);
		if (m_error != noErr)
			sz = 0;
	}
	return sz > 0 ? sz : 0;
}

OSErr TScrapStuff::GetScrapText(TMemory *buff) {
	Size sz = GetScrapTextSize();
	if (sz == 0)
		return 0;
	buff->ChangeLength(sz);
	m_error = GetScrapFlavorData(m_scrapInfo, kScrapFlavorTypeText, &sz, (char *)*buff);
	return m_error;
}

/*
	TTextEdit̊gD&D̃Tv
*/

/*
 *	TEGetLine, given an offset and a TextEdit handle, returns the line number
 *	of the line that contains the offset.
 */
short TTextEdit::TEGetLine(short offset) {
	short line = 0;
	if (offset > (**m_te).teLength)
		return((**m_te).nLines);
	while ((**m_te).lineStarts[line] < offset)
		line++;
	return line;
}

/*
 *	DrawCaret draws a caret in a TextEdit field at the given offset. DrawCaret
 *	expects the port to be set to the port that the TextEdit field is in.
 *	DrawCaret inverts the image of the caret onto the screen.
 */
void TTextEdit::DrawCaret(short offset) {
	Point		loc;
	short		lineNum, lineHeight;

	/*
	 *	Get the coordinates and the line of the offset to draw the caret.
	 */

	loc  = TEGetPoint(offset);
	lineNum = TEGetLine(offset);

	/*
	 *	For some reason, TextEdit dosen't return the proper coordinates
	 *	of the last offset in the field if the last character in the record
	 *	is a carriage return. TEGetPoint returns a point that is one line
	 *	higher than expected. The following code fixes this problem.
	 */

	if ((offset == (**m_te).teLength) &&
	        (*((**m_te).hText))[(**m_te).teLength - 1] == 0x0D) {
		loc.v += TEGetHeight(lineNum, lineNum, m_te);
	}

	/*
	 *	Always invert the caret when drawing.
	 */

	PenMode(patXor);

	/*
	 *	Get the height of the line that the offset points to.
	 */

	lineHeight = TEGetHeight(lineNum, lineNum, m_te);

	/*
	 *	Draw the appropriate caret image.
	 */

	MoveTo(loc.h - 1, loc.v - 1);
	Line(0, 1 - lineHeight);

	PenNormal();
}

TListBox::TListBox() {
	m_lref = NULL;
}

TListBox::~TListBox() {
	//	if (m_lref != NULL && theSystem->systemVersion < 0x1000)
	LDispose();
}

#ifdef CONFIG_USE_HELPMESSAGE

/*
	o[wvbZ[WNX
*/

THelpMessage::THelpMessage(short resID, short index) {
	m_hm.hmmHelpType = khmmStringRes;
	m_hm.u.hmmStringRes.hmmResID = resID;
	m_hm.u.hmmStringRes.hmmIndex = index;
}

OSErr THelpMessage::HMShowBalloon(TRect r) {
	return noErr;
}

#endif

