/*
	TControl.h
	Rg[NX
	eLXgGfBbgNX
	XNbvX^bt
	Xg{bNXNX
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.02.12	1.0			Takeshi Yoneki
*/

#ifndef _CCONTROL_H_
#define _CCONTROL_H_

class TControl;
class TTextEdit;
class TScrapStuff;
class TListBox;
class THelpMessage;

/*
	TControl
	Rg[NX
*/
class TControl {
protected:
	ControlRef m_ctrl;
public:
	TControl() {
		m_ctrl = NULL;
	}
	TControl(ControlRef ctrl) {
		m_ctrl = ctrl;
	}
	operator ControlRef() {
		return m_ctrl;
	}
	Boolean IsNull() {
		return m_ctrl == NULL;
	}
	UInt16 GetControlHilite() {
#if ACCESSOR_CALLS_ARE_FUNCTIONS
		return ::GetControlHilite(m_ctrl);
#else

		return (**m_ctrl).contrlHilite;
#endif

	}
	void NewControl(WindowRef owner, const Rect *boundsRect, ConstStr255Param title, Boolean visible, SInt16 value, SInt16 min, SInt16 max, SInt16 procID, SInt32 refCon) {
		m_ctrl = ::NewControl(owner, boundsRect, title, visible, value, min, max, procID, refCon);
	}
	void GetNewControl(SInt16 controlID, WindowRef owner) {
		m_ctrl = ::GetNewControl(controlID, owner);
	}
	void DisposeControl() {
		::DisposeControl(m_ctrl);
	}
	void KillControls(WindowRef theWindow) {
		::KillControls(theWindow);
	}
	void ShowControl() {
		::ShowControl(m_ctrl);
	}
	void HideControl() {
		::HideControl(m_ctrl);
	}
	void DrawControls(WindowRef theWindow) {
		::DrawControls(theWindow);
	}
	void Draw1Control() {
		::Draw1Control(m_ctrl);
	}
	void UpdateControls(WindowRef theWindow, RgnHandle updateRegion) {
		::UpdateControls(theWindow, updateRegion);
	}
	void HiliteControl(ControlPartCode hiliteState) {
		::HiliteControl(m_ctrl, hiliteState);
	}
	ControlPartCode TrackControl(Point thePoint, ControlActionUPP actionProc) {
		return ::TrackControl(m_ctrl, thePoint, actionProc);
	}
	ControlPartCode HandleControlClick(Point inWhere, EventModifiers inModifiers, ControlActionUPP inAction) {
		return ::HandleControlClick(m_ctrl, inWhere, inModifiers, inAction);
	}
	ControlPartCode HandleControlKey(SInt16 inKeyCode, SInt16 inCharCode, EventModifiers inModifiers) {
		return ::HandleControlKey(m_ctrl, inKeyCode, inCharCode, inModifiers);
	}
	void DragControl(Point startPoint, const Rect *limitRect, const Rect *slopRect, DragConstraint axis) {
		::DragControl(m_ctrl, startPoint, limitRect, slopRect, axis);
	}
	ControlPartCode TestControl(Point thePoint) {
		return ::TestControl(m_ctrl, thePoint);
	}
	void MoveControl(SInt16 h, SInt16 v) {
		::MoveControl(m_ctrl, h, v);
	}
	void SizeControl(SInt16 w, SInt16 h) {
		::SizeControl(m_ctrl, w, h);
	}
	void SetControlTitle(ConstStr255Param title) {
		::SetControlTitle(m_ctrl, title);
	}
	SInt16 GetControlValue() {
		return ::GetControlValue(m_ctrl);
	}
	SInt32 GetControl32BitValue() {
		return ::GetControl32BitValue(m_ctrl);
	}
	void SetControlValue(SInt16 newValue) {
		::SetControlValue(m_ctrl, newValue);
	}
	void SetControl32BitValue(SInt32 newValue) {
		::SetControl32BitValue(m_ctrl, newValue);
	}
	SInt16 GetControlMinimum() {
		return ::GetControlMinimum(m_ctrl);
	}
	SInt32 GetControl32BitMinimum() {
		return ::GetControl32BitMinimum(m_ctrl);
	}
	void SetControlMinimum(SInt16 newMinimum) {
		::SetControlMinimum(m_ctrl, newMinimum);
	}
	void SetControl32BitMinimum(SInt32 newMinimum) {
		::SetControl32BitMinimum(m_ctrl, newMinimum);
	}
	SInt16 GetControlMaximum() {
		return ::GetControlMaximum(m_ctrl);
	}
	SInt32 GetControl32BitMaximum() {
		return ::GetControl32BitMaximum(m_ctrl);
	}
	void SetControlMaximum(SInt16 newMaximum) {
		::SetControlMaximum(m_ctrl, newMaximum);
	}
	void SetControl32BitMaximum(SInt32 newMaximum) {
		::SetControl32BitMaximum(m_ctrl, newMaximum);
	}
	void SetControlReference(SInt32 data) {
		::SetControlReference(m_ctrl, data);
	}
	void SetControlViewSize(SInt32 newViewSize) {
		::SetControlViewSize(m_ctrl, newViewSize);
	}
	SInt32 GetControlReference() {
		return ::GetControlReference(m_ctrl);
	}
	void SetControlAction(ControlActionUPP actionProc) {
		::SetControlAction(m_ctrl, actionProc);
	}
	OSErr SetControlData(ControlPartCode inPart, ResType inTagName, Size inSize, void * inData) {
		return ::SetControlData(m_ctrl, inPart, inTagName, inSize, inData);
	}
	OSErr GetControlData(ControlPartCode inPart, ResType inTagName, Size inBufferSize, void *inBuffer, Size *outActualSize) {
		return ::GetControlData(m_ctrl, inPart, inTagName, inBufferSize, inBuffer, outActualSize);
	}
	OSErr CreateRootControl(WindowRef owner) {
		return ::CreateRootControl(owner, &m_ctrl);
	}
	OSStatus SetAutomaticControlDragTrackingEnabledForWindow(WindowRef owner, Boolean tracks) {
		return ::SetAutomaticControlDragTrackingEnabledForWindow(owner, tracks);
	}
	void SetControlBounds(const Rect *bounds) {
		::SetControlBounds(m_ctrl, bounds);
	}
	OSErr SetControlFontStyle(const ControlFontStyleRec *inStyle) {
		return ::SetControlFontStyle(m_ctrl, inStyle);
	}
};

class TDataBrowserControl : public TControl {
public:
	TDataBrowserControl() {
	}
	TDataBrowserControl(ControlRef ctrl)
			: TControl(ctrl) {
	}
	OSStatus CreateDataBrowserControl(WindowRef window, const Rect *boundsRect, DataBrowserViewStyle style) {
		return ::CreateDataBrowserControl(window, boundsRect, style, &m_ctrl);
	}
	OSStatus GetDataBrowserViewStyle(DataBrowserViewStyle *style) {
		return ::GetDataBrowserViewStyle(m_ctrl, style);
	}
	OSStatus SetDataBrowserViewStyle(DataBrowserViewStyle style) {
		return ::SetDataBrowserViewStyle(m_ctrl, style);
	}
	OSStatus GetDataBrowserScrollBarInset(Rect *insetRect) {
		return ::GetDataBrowserScrollBarInset(m_ctrl, insetRect);
	}
	OSStatus SetDataBrowserScrollBarInset(Rect *insetRect) {
		return ::SetDataBrowserScrollBarInset(m_ctrl, insetRect);
	}
	OSStatus AddDataBrowserListViewColumn(DataBrowserListViewColumnDesc *columnDesc, DataBrowserTableViewColumnIndex position) {
		return ::AddDataBrowserListViewColumn(m_ctrl, columnDesc, position);
	}
	OSStatus SetDataBrowserListViewDisclosureColumn(DataBrowserTableViewColumnID column, Boolean expandableRows) {
		return ::SetDataBrowserListViewDisclosureColumn(m_ctrl, column, expandableRows);
	}
	OSStatus SetDataBrowserTableViewNamedColumnWidth(DataBrowserTableViewColumnID column, UInt16 width) {
		return ::SetDataBrowserTableViewNamedColumnWidth(m_ctrl, column, width);
	}
	OSStatus GetDataBrowserTableViewNamedColumnWidth(DataBrowserTableViewColumnID column, UInt16 *width) {
		return ::GetDataBrowserTableViewNamedColumnWidth(m_ctrl, column, width);
	}
	OSStatus AddDataBrowserItems(DataBrowserItemID container, UInt32 numItems, const DataBrowserItemID *items = NULL, DataBrowserPropertyID preSortProperty = kDataBrowserItemNoProperty) {
		return ::AddDataBrowserItems(m_ctrl, container, numItems, items, preSortProperty);
	}
	OSStatus SetDataBrowserCallbacks(const DataBrowserCallbacks *callbacks) {
		return ::SetDataBrowserCallbacks(m_ctrl, callbacks);
	}
	OSStatus UpdateDataBrowserItems(DataBrowserItemID container, UInt32 numItems, const DataBrowserItemID *items, DataBrowserPropertyID preSortProperty, DataBrowserPropertyID propertyID) {
		return ::UpdateDataBrowserItems(m_ctrl, container, numItems, items, preSortProperty, propertyID);
	}
	OSStatus SetDataBrowserSelectionFlags(DataBrowserSelectionFlags selectionFlags) {
		return ::SetDataBrowserSelectionFlags(m_ctrl, selectionFlags);
	}
	Boolean IsDataBrowserItemSelected(DataBrowserItemID item) {
		return ::IsDataBrowserItemSelected(m_ctrl,item);
	}
	OSStatus ForEachDataBrowserItem(DataBrowserItemID container, Boolean recurse, DataBrowserItemState state, DataBrowserItemUPP callback, void *clientData) {
		return ::ForEachDataBrowserItem(m_ctrl, container, recurse, state, callback, clientData);
	}
	OSStatus GetDataBrowserItems(DataBrowserItemID container, Boolean recurse, DataBrowserItemState state, Handle items) {
		return ::GetDataBrowserItems(m_ctrl, container, recurse, state, items);
	}
	OSStatus GetDataBrowserItemCount(DataBrowserItemID container, Boolean recurse, DataBrowserItemState state, UInt32 *numItems) {
		return ::GetDataBrowserItemCount(m_ctrl, container, recurse, state, numItems);
	}
	OSStatus GetDataBrowserSortOrder(DataBrowserSortOrder *order) {
		return ::GetDataBrowserSortOrder(m_ctrl, order);
	}
	OSStatus SetDataBrowserSortOrder(DataBrowserSortOrder order) {
		return ::SetDataBrowserSortOrder(m_ctrl, order);
	}
	OSStatus SetDataBrowserHasScrollBars(Boolean horiz, Boolean vert) {
		return ::SetDataBrowserHasScrollBars(m_ctrl, horiz, vert);
	}
	OSStatus GetDataBrowserTableViewItemRow(DataBrowserItemID item, DataBrowserTableViewRowIndex *row) {
		return ::GetDataBrowserTableViewItemRow(m_ctrl, item, row);
	}
	OSStatus GetDataBrowserTableViewColumnPosition(DataBrowserTableViewColumnID column, DataBrowserTableViewColumnIndex *position) {
		return ::GetDataBrowserTableViewColumnPosition(m_ctrl, column, position);
	}
	Boolean EnableDataBrowserEditCommand(DataBrowserEditCommand command) {
		return ::EnableDataBrowserEditCommand(m_ctrl, command);
	}
	OSStatus ExecuteDataBrowserEditCommand(DataBrowserEditCommand command) {
		return ::ExecuteDataBrowserEditCommand(m_ctrl, command);
	}
	/**/
	void AddColumn(long id, TString name, UInt16 width, DataBrowserPropertyType propertyType = kDataBrowserTextType, DataBrowserPropertyFlags flags = kDataBrowserListViewDefaultColumnFlags);
	/**/
	OSStatus SetDataBrowserItemDataText(DataBrowserItemDataRef itemData, TCFString s);
	OSStatus GetDataBrowserItemDataText(DataBrowserItemDataRef itemData, TCFString& s);
	OSStatus SetDataBrowserItemDataBooleanValue(DataBrowserItemDataRef itemData, Boolean data) {
		return ::SetDataBrowserItemDataBooleanValue(itemData, data);
	}
	OSStatus GetDataBrowserItemDataBooleanValue(DataBrowserItemDataRef itemData, Boolean *data) {
		return ::GetDataBrowserItemDataBooleanValue(itemData, data);
	}
	OSStatus SetDataBrowserItemDataIcon(DataBrowserItemDataRef itemData, IconRef data) {
		return ::SetDataBrowserItemDataIcon(itemData, data);
	}
	OSStatus SetDataBrowserItemDataButtonValue(DataBrowserItemDataRef itemData, ThemeButtonValue data) {
		return ::SetDataBrowserItemDataButtonValue(itemData, data);
	}
	OSStatus GetDataBrowserItemDataButtonValue(DataBrowserItemDataRef itemData, ThemeButtonValue *data) {
		return ::GetDataBrowserItemDataButtonValue(itemData, data);
	}
};


/*
	TTextEdit
	eLXgGfBbgNX
*/
class TTextEdit {
protected:
	TEHandle m_te;
public:
	TTextEdit() {
		m_te = NULL;
	}
	TTextEdit(const Rect *destRect, const Rect *viewRect) {
		TENew(destRect, viewRect);
	}
	~TTextEdit() {
		if (m_te != NULL)
			TEDispose();
	}
	operator TEHandle() {
		return m_te;
	}
	TRect GetDestRect() {
		return (**m_te).destRect;
	}
	TRect GetViewRect() {
		return (**m_te).viewRect;
	}
	void SetDestRect(TRect r) {
		(**m_te).destRect = r;
	}
	void SetViewRect(TRect r) {
		(**m_te).viewRect = r;
	}
	short GetLineHight() {
		return (**m_te).lineHeight;
	}
	void SetLineHight(short lineHeight) {
		(**m_te).lineHeight = lineHeight;
	}
	void SetFontAscent(short fontAscent) {
		(**m_te).fontAscent = fontAscent;
	}
	long GetLineNumber() {
		return (**m_te).nLines;
	}
	int GetLineStarts(int n) {
		return (**m_te).lineStarts[n];
	}
	long GetSelStart() {
		return (**m_te).selStart;
	}
	long GetSelEnd() {
		return (**m_te).selEnd;
	}
	long GetTextLength() {
		return (**m_te).teLength;
	}
	long GetSelectLength() {
		return GetSelEnd() - GetSelStart();
	}
	short GetFont() {
		return (**m_te).txFont;
	}
	void SetFont(short fontNum) {
		(**m_te).txFont = fontNum;
	}
	short GetFontSize() {
		return (**m_te).txSize;
	}
	void SetFontSize(short fontSize) {
		(**m_te).txSize = fontSize;
	}
	void SetWordWrap(short crOnly) {
		(**m_te).crOnly = crOnly;
	}
	short GetWordWrap() {
		return (**m_te).crOnly;
	}
	void TENew(const Rect *destRect, const Rect *viewRect) {
		m_te = ::TENew(destRect, viewRect);
	}
	void TEDispose() {
		::TEDispose(m_te);
	}
	void TESetText(const void *text, long length) {
		::TESetText(text, length, m_te);
	}
	CharsHandle TEGetText() {
		return ::TEGetText(m_te);
	}
	void TEIdle() {
		::TEIdle(m_te);
	}
	void TESetSelect(long selStart, long selEnd) {
		::TESetSelect(selStart, selEnd, m_te);
	}
	void TEActivate() {
		::TEActivate(m_te);
	}
	void TEDeactivate() {
		::TEDeactivate(m_te);
	}
	void TEActivate(Boolean act) {
		if (act)
			TEActivate();
		else
			TEDeactivate();
	}
	void TEKey(short key) {
		::TEKey(key, m_te);
	}
	void TECut() {
		::TECut(m_te);
	}
	void TECopy() {
		::TECopy(m_te);
	}
	void TEPaste() {
		::TEPaste(m_te);
	}
	void TEDelete() {
		::TEDelete(m_te);
	}
	void TEInsert(const void *text, long length) {
		::TEInsert(text, length, m_te);
	}
	void TESetAlignment(short just) {
		::TESetAlignment(just, m_te);
	}
	void TEUpdate(const Rect *rUpdate) {
		::TEUpdate(rUpdate, m_te);
	}
	void TEUpdate() {
		::TEUpdate(&(*m_te)->viewRect, m_te);
	}
	void TETextBox(const void *text, long length, const Rect *box, short just) {
		::TETextBox(text, length, box, just);
	}
	void TEScroll(short dh, short dv) {
		::TEScroll(dh, dv, m_te);
	}
	void TESelView() {
		::TESelView(m_te);
	}
	void TECalText() {
		::TECalText(m_te);
	}
	short TEGetOffset(Point pt) {
		return ::TEGetOffset(pt, m_te);
	}
	Point TEGetPoint(short offset) {
		return ::TEGetPoint(offset, m_te);
	}
	void TEClick(Point pt, Boolean fExtend) {
		::TEClick(pt, fExtend, m_te);
	}
	void TESetClickLoop(TEClickLoopUPP clikProc) {
		::TESetClickLoop(clikProc, m_te);
	}
	void TEAutoView(Boolean fAuto) {
		::TEAutoView(fAuto, m_te);
	}
	OSErr TEFromScrap() {
		return ::TEFromScrap();
	}
	OSErr TEToScrap() {
		return ::TEToScrap();
	}
	OSErr TEGetHiliteRgn(RgnHandle region) {
		return ::TEGetHiliteRgn(region, m_te);
	}
	short TEGetLine(short offset);
	void DrawCaret(short offset);
	GrafPtr GetInPort() {
		return (**m_te).inPort;
	}
	void SetInPort(GrafPtr port) {
		(**m_te).inPort = port;
	}
};

/*
	TScrapStuff
	XNbvX^btNX
*/
class TScrapStuff {
protected:
	OSErr m_error;
	ScrapRef m_scrapInfo;
public:
	TScrapStuff() {
		InfoScrap();
	}
	//	long GetScrapSize()
	//	{
	//		return m_scrapInfo->scrapSize;
	//	}
	void InfoScrap() {
		m_error = ::GetCurrentScrap(&m_scrapInfo);
	}
	long GetScrapTextSize();
	OSErr PutScrapText(Size flavorSize, const void *flavorData) {
		m_error = PutScrapFlavor(m_scrapInfo, kScrapFlavorTypeText, 0, flavorSize, flavorData);
		return m_error;
	}
	OSErr GetScrapText(TMemory *buff);
	void ZeroScrap() {
		::ClearCurrentScrap();
		InfoScrap();
	}
};

/*
	TCell
	ZNX
*/
typedef	TPoint	TCell;

/*
	TListBox
	Xg{bNXNX
*/
class TListBox {
protected:
	ListRef m_lref;
public:
	TListBox();
	~TListBox();
	Boolean IsNull() {
		return m_lref == NULL;
	}
	void LNew(const Rect *rView, const ListBounds *dataBounds, Point cSize, short theProc, WindowRef theWindow, Boolean drawIt, Boolean hasGrow, Boolean scrollHoriz, Boolean scrollVert) {
		m_lref = ::LNew(rView, dataBounds, cSize, theProc, theWindow, drawIt, hasGrow, scrollHoriz, scrollVert);
	}
	OSStatus CreateCustomList(const Rect *rView, const ListBounds *dataBounds, Point cellSize, const ListDefSpec *theSpec, WindowPtr theWindow, Boolean drawIt, Boolean hasGrow, Boolean scrollHoriz, Boolean scrollVert) {
		return ::CreateCustomList(rView, dataBounds, cellSize, theSpec, theWindow, drawIt, hasGrow, scrollHoriz, scrollVert, &m_lref);
	}
	void LDispose() {
		::LDispose(m_lref);
	}
	void SetSelFlags(SInt8 selFlags) {
		(**m_lref).selFlags = selFlags;
	}
	void LUpdate(RgnHandle theRgn) {
		::LUpdate(theRgn, m_lref);
	}
	void LActivate(Boolean act) {
		::LActivate(act, m_lref);
	}
	void LSize(short listWidth, short listHeight) {
		::LSize(listWidth, listHeight, m_lref);
	}
	short LAddRow(short count, short rowNum) {
		return ::LAddRow(count, rowNum, m_lref);
	}
	void LDelRow(short count, short rowNum) {
		::LDelRow(count, rowNum, m_lref);
	}
	void DeleteAllRow() {
		LDelRow(0, 0);
	}
	void LAddToCell(const void *dataPtr, short dataLen, Cell theCell) {
		::LAddToCell(dataPtr, dataLen, theCell, m_lref);
	}
	Boolean LClick(Point pt, short modifiers) {
		return ::LClick(pt, modifiers, m_lref);
	}
	void LCellSize(Point cSize) {
		::LCellSize(cSize, m_lref);
	}
	void LSetDrawingMode(Boolean drawIt)	/* LDoDraw */
	{
		::LSetDrawingMode(drawIt, m_lref);
	}
	void LSetSelect(Boolean setIt, Cell theCell) {
		::LSetSelect(setIt, theCell, m_lref);
	}
	void LDraw(Cell theCell) {
		::LDraw(theCell, m_lref);
	}
	Boolean LGetSelect(Boolean next, Cell *theCell) {
		return ::LGetSelect(next, theCell, m_lref);
	}
	void LScroll(short dCols, short dRows) {
		::LScroll(dCols, dRows, m_lref);
	}
	void LAutoScroll() {
		::LAutoScroll(m_lref);
	}
	void LSetCell(const void *dataPtr, short dataLen, Cell theCell) {
		::LSetCell(dataPtr, dataLen, theCell, m_lref);
	}
	void SetViewRect(Rect r) {
		(**m_lref).rView = r;
	}
	void DrawOff() {
		LSetDrawingMode(FALSE);
	}
	void DrawOn() {
		LSetDrawingMode(TRUE);
	}
};

#ifdef CONFIG_USE_HELPMESSAGE

/*
	THelpMessage
	o[wvbZ[WNX
*/
class THelpMessage {
public:
	HMMessageRecord m_hm;
	THelpMessage(short resID, short index);
	OSErr HMShowBalloon(TRect r);
};

#endif	// CONFIG_USE_HELPMESSAGE

#endif
