/*
	TDialog.h
	_CAONX
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.03.08	1.0			Takeshi Yoneki
*/

#ifndef	_CDIALOG_H_
#define	_CDIALOG_H_

#define	DEFAULT_OK_DITEM				1
#define	DEFAULT_SAVE_DITEM				DEFAULT_OK_DITEM
#define	DEFAULT_CANCEL_DITEM			2
#define	DEFAULT_DISCARD_DITEM			3

#define	ERR_EXIT_DLG					1002
#define	ERR_EXIT_MSG_DITEM				2

class TDialog;
class TSaveConfirmDlg;

/* OK/Cancel/EditBoxΉ_CAOtB^ */
pascal Boolean OkCancelEditDialogFilter(DialogRef dref, EventRecord *ev, short *itemHit);

/*
	TDialog
	_CAONX
*/
class TDialog : public TWindow {
public:
	Boolean m_created;
	CUPP_ModalFilter m_uppModalFilter;
	TDialog();
	~TDialog();
	TDialog(DialogPtr dlg);
	TDialog(short dialogID, TPoint position = TPoint(0, 0), WindowRef behind = (WindowRef)-1);
	TDialog *GetNext() {
		return (TDialog *)TBase::GetNext();
	}
	/* TWindow virtual Function */
	virtual void OnUpdate();
	virtual void Update(int message);	/* for other window */
	virtual void UpdateCallback();
	/* TDialog virtual function */
	virtual Boolean DialogFilter(DialogRef dref, EventRecord *ev, short *itemHit);
	virtual Boolean OnItemHit(short itemHit);
	/**/
	void OnCut();
	void OnCopy();
	void OnPaste();
	operator DialogRef() {
		return GetDialogFromWindow(m_port);
	}
	Boolean operator==(DialogRef dref) {
		return dref == (DialogRef)*this;
	}
	Boolean operator!=(DialogRef dref) {
		return !operator==(dref);
	}
	void NewDialog(const Rect *boundsRect, ConstStr255Param title, Boolean visible, short procID, WindowRef behind, Boolean goAwayFlag, long refCon, Handle itmLstHndl);
	void GetNewDialog(short dialogID, TPoint position = TPoint(0, 0), WindowRef behind = (WindowRef)-1);
	void DisposeDialog();
	void ParamText(ConstStr255Param param0, ConstStr255Param param1, ConstStr255Param param2, ConstStr255Param param3) {
		::ParamText(param0, param1, param2, param3);
	}
	short ModalDialog();
	void DrawDialog() {
		::DrawDialog(*this);
	}
	void UpdateDialog(RgnHandle updateRgn) {
		::UpdateDialog(*this, updateRgn);
	}
	Handle GetDialogItem(short itemNo);
	Handle GetDialogItem(short itemNo, short *itemType, Rect *box) {
		Handle item;
		::GetDialogItem(*this, itemNo, itemType, &item, box);
		return item;
	}
	ControlRef GetDialogItemAsControl(short itemNo) {
		ControlRef item;
		::GetDialogItemAsControl(*this, itemNo, &item);
		return item;
	}
	void SetDialogItem(short itemNo, short itemType, Handle item, const Rect *box) {
		::SetDialogItem(*this, itemNo, itemType, item, box);
	}
	void HideDialogItem(short itemNo) {
		::HideDialogItem(*this, itemNo);
	}
	void ShowDialogItem(short itemNo) {
		::ShowDialogItem(*this, itemNo);
	}
	void SelectDialogItemText(short itemNo, short strtSel = 0, short endSel = 32767) {
		::SelectDialogItemText(*this, itemNo, strtSel, endSel);
	}
	void GetDialogItemText(Handle item, Str255 text) {
		::GetDialogItemText(item, text);
	}
	void SetDialogItemText(Handle item, ConstStr255Param text) {
		::SetDialogItemText(item, text);
	}
	short FindDialogItem(Point thePt) {
		return ::FindDialogItem(*this, thePt);
	}
	void DialogCut() {
		::DialogCut(*this);
	}
	void DialogPaste() {
		::DialogPaste(*this);
	}
	void DialogCopy() {
		::DialogCopy(*this);
	}
	void DialogDelete() {
		::DialogDelete(*this);
	}
	void SetDialogFont(short value) {
		::SetDialogFont(value);
	}
	TRect GetDIRect(short itemNo) {
		short itemType;
		Rect box;
		GetDialogItem(itemNo, &itemType, &box);
		return box;
	}
	void SetDIHilite(short itemNumber, short itemValue);
	void SetDITitle(short itemNumber, TString itemText);
	short SetDIText(short itemNumber, TString itemText, Boolean useControl = FALSE);
	void SetDITextAndSelect(short itemNumber, TString itemText, Boolean useControl = FALSE);
	TString GetDIText(short itemNumber, Boolean useControl = FALSE);
	short SetDITextCFString(short itemNumber, TCFString itemText, Boolean dmy = FALSE);
	void SetDITextCFStringAndSelect(short itemNumber, TCFString itemText, Boolean dmy = FALSE);
	TCFString GetDITextCFString(short itemNumber, Boolean dmy = FALSE);
	short SetDINumber(short itemNumber, long itemValue);
	void SetDINumberAndSelect(short itemNumber, long itemValue);
	long GetDINumber(short itemNumber);
	void SetDIValue(short itemNumber, short value);
	short GetDIValue(short itemNumber);
	OSErr GetDIControlData(short itemNumber, ControlPartCode inPart, ResType inTagName, Size inBufferSize, Ptr inBuffer, Size *outActualSize);
	OSErr SetDIControlData(short itemNumber, ControlPartCode inPart, ResType inTagName, Size inBufferSize, Ptr inBuffer);
	short GetDIBevelButtonMenuValue(short itemNumber);
	void SetDIKeyboardFocus(short itemNumber);
	void DrawOKWaku(short itemNumber = DEFAULT_OK_DITEM);
private:
	void Initial();
	short SetDIControlText(short itemNumber, TString itemText);
	void SetDIControlTextAndSelect(short itemNumber, TString itemText);
	TString GetDIControlText(short itemNumber);
};

/* ۑmF_CAOtB^ */
pascal Boolean SaveConfirmDialogFilter(DialogRef dref, EventRecord *ev, short *itemHit);

/*
	TSaveConfirmDlg
	ۑmF_CAONX
*/
class TSaveConfirmDlg : public TDialog {
public:
	TSaveConfirmDlg(short dialogID, TPoint position = TPoint(0, 0), WindowRef behind = (WindowRef)-1)
			: TDialog(dialogID, position, behind) {
	}
	Boolean DialogFilter(DialogRef dref, EventRecord *ev, short *itemHit);
};

#endif
