/*
	TDrag.h
	hbOhbvNX
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1997.01.06	1.5			Takeshi Yoneki
*/

#ifndef	_CDRAG_H_
#define	_CDRAG_H_

class TDrag;
class TAutoOffScreen;

class TDrag {
public:
	DragReference m_drag;
	Boolean m_created;
	OSErr m_error;
	void Initial();
	TDrag();
	TDrag(DragReference drag);
	~TDrag();
	Boolean IsGood() {
		return m_error == noErr;
	}
	operator DragReference()	/* RgnHandleւ̃LXg */
	{
		return m_drag;
	}
	OSErr AddDragItemFlavor(ItemReference theItemRef, FlavorType theType, void *dataPtr, Size dataSize, FlavorFlags theFlags = 0) {
		return m_error = ::AddDragItemFlavor(m_drag, theItemRef, theType, dataPtr, dataSize, theFlags);
	}
	OSErr SetDragItemFlavorData(ItemReference theItemRef, FlavorType theType, const void *dataPtr, Size dataSize, unsigned long dataOffset = 0) {
		return m_error = ::SetDragItemFlavorData(m_drag, theItemRef, theType, dataPtr, dataSize, dataOffset);
	}
	/*
	extern pascal OSErr SetDragSendProc(DragReference theDragRef, DragSendDataProc sendProc, void *dragSendRefCon)
	extern pascal OSErr SetDragInputProc(DragReference theDragRef, DragInputProc inputProc, void *dragInputRefCon)
	extern pascal OSErr SetDragDrawingProc(DragReference theDragRef, DragDrawingProc drawingProc, void *dragDrawingRefCon)
	*/
	OSErr TrackDrag(const EventRecord *theEvent, RgnHandle theRegion) {
		return m_error = ::TrackDrag(m_drag, theEvent, theRegion);
	}
	unsigned short CountDragItems();
	ItemReference GetDragItemReferenceNumber(unsigned short index);
	unsigned short CountDragItemFlavors(ItemReference theItemRef);
	FlavorType GetFlavorType(ItemReference theItemRef, unsigned short index);
	FlavorFlags GetFlavorFlags(ItemReference theItemRef, FlavorType theType);
	Size GetFlavorDataSize(ItemReference theItemRef, FlavorType theType);
	OSErr GetFlavorData(ItemReference theItemRef, FlavorType theType, void *dataPtr, Size *dataSize, unsigned long dataOffset = 0) {
		return m_error = ::GetFlavorData(m_drag, theItemRef, theType, dataPtr, dataSize, dataOffset);
	}
	OSErr GetDragItemBounds(ItemReference theItemRef, Rect *itemBounds) {
		return m_error = ::GetDragItemBounds(m_drag, theItemRef, itemBounds);
	}
	/*
	extern pascal OSErr SetDragItemBounds(DragReference theDragRef, ItemReference theItemRef, const Rect *itemBounds)
	extern pascal OSErr GetDropLocation(DragReference theDragRef, AEDesc *dropLocation)
	extern pascal OSErr SetDropLocation(DragReference theDragRef, const AEDesc *dropLocation)
	*/
	DragAttributes GetDragAttributes();
	Point GetDragMouse(Point *pinnedMouse = NULL);

	/*
	extern pascal OSErr SetDragMouse(DragReference theDragRef, Point pinnedMouse)
	extern pascal OSErr GetDragOrigin(DragReference theDragRef, Point *initialMouse)
	*/
	OSErr GetDragModifiers(short *modifiers, short *mouseDownModifiers, short *mouseUpModifiers) {
		return m_error = ::GetDragModifiers(m_drag, modifiers, mouseDownModifiers, mouseUpModifiers);
	}
	OSErr ShowDragHilite(RgnHandle hiliteFrame, Boolean inside = TRUE) {
		return m_error = ::ShowDragHilite(m_drag, hiliteFrame, inside);
	}
	OSErr HideDragHilite() {
		return m_error = ::HideDragHilite(m_drag);
	}
	/*
	extern pascal OSErr DragPreScroll(DragReference theDragRef, short dH, short dV)
	extern pascal OSErr DragPostScroll(DragReference theDragRef)
	extern pascal OSErr UpdateDragHilite(DragReference theDragRef, RgnHandle updateRgn)
	extern pascal Boolean WaitMouseMoved(Point initialMouse)
	*/
	/*
	extern pascal OSErr ZoomRects(const Rect *fromRect, const Rect *toRect, short zoomSteps, ZoomAcceleration acceleration)
	extern pascal OSErr ZoomRegion(RgnHandle region, Point zoomDistance, short zoomSteps, ZoomAcceleration acceleration)
	*/
};

class TAutoOffScreen {
public:
	CGrafPtr m_port;
	GDHandle m_device;
	GWorldPtr m_world;
	GrafPtr m_savePort;
	Boolean m_good;
	RGBColor m_saveBgColor;
	RGBColor m_saveFgColor;
	TAutoOffScreen();
	~TAutoOffScreen();
	GrafPtr DrawOff(GrafPtr inPort);
	GrafPtr DrawOn();
	GrafPtr GetOffPort() {
		return (GrafPtr)m_world;
	}
	GrafPtr GetSavePort() {
		return (GrafPtr)m_savePort;
	}
};

#endif
