/*
	CDraw.h
	N^ONX
	|CgNX
	[WNX
	tHgNX
	tHgNX
	J[\NX
	J[\XgNX
	sN`[NX
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.02.12	1.0			Takeshi Yoneki
*/

#ifndef	_CDRAW_H_
#define	_CDRAW_H_

class TRect;
class TPoint;
class TRgn;
class TFontInfo;
class TFont;
class TCursor;
class TCursorList;
class TPicture;
class TIconSuite;
class TPixPat;

/*
	ۃIuWFNg^NX̓NX̎̂̂̂͂̒lɈӋ`B
	ۃIuWFNg^NX͂Ăȉ̃o֐B
		ƓNX̒lɂRXgN^
		̍\̂̒lɂRXgN^
		̑̒lɂRXgN^
		̍\̂ւ̃LXg
		ƓNX̒l̃Rs[
		̍\̂̒l̃Rs[
		ƓNX̒lƂ̔r
		̍\̂̒lƂ̔r
 
	ۃIuWFNg^NXꗗ
		TRect		N^O
		TPoint		|Cg
		TRgn		[W
		TFont		tHg
		TDirectory	fBNg
		TWorkDir	[LOfBNg
		TDateTime	tƎ
		TString		
 
	ۃIuWFNg^̃NX̂A\̂̂΂A̍\̂
	eNXƂČpB̓oƂČ̌^̒lێB
		TRectATPointATDateTime
*/

/*
	TRect
	N^ONX
*/
class TRect : public Rect {
public:
	TRect() {
		SetRect(0, 0, 0, 0);
	}
	TRect(const TRect& cr) {
		*(Rect *)this = *(Rect *)&cr;
	}
	TRect(Rect& r) {
		*(Rect *)this = r;
	}
	TRect(short ileft, short itop, short iright, short ibottom) {
		SetRect(ileft, itop, iright, ibottom);
	}
	operator Rect *()	/* Rect *ւ̃LXg */
	{
		return (Rect *)this;
	}
	operator Rect()	/* Rectւ̃LXg */
	{
		return *(Rect *)this;
	}
	void operator=(const TRect& cr)	/* TRect̃Rs[ */
	{
		*(Rect *)this = *(Rect *)&cr;
	}
	void operator=(Rect r)	/* Rect̃Rs[ */
	{
		*(Rect *)this = r;
	}
	Boolean operator==(TRect& cr) {
		return EqualRect(&cr);
	}
	Boolean operator!=(TRect& cr) {
		return !operator==(cr);
	}
	Boolean operator==(Rect& r) {
		return EqualRect(&r);
	}
	Boolean operator!=(Rect& r) {
		return !operator==(r);
	}
	void SetRect(short ileft, short itop, short iright, short ibottom) {
		::SetRect(this, ileft, itop, iright, ibottom);
	}
	void FrameRect() {
		::FrameRect(this);
	}
	TRect SectRect(TRect& cr);
	Boolean EmptyRect() {
		return ::EmptyRect(this);
	}
	void FrameRectOut();
	void FrameRectWithShadow();
	Boolean EqualRect(const Rect *cr) {
		return ::EqualRect(this, cr);
	}
	void EraseRect() {
		::EraseRect(this);
	}
	TRect GetInRect();
	void EraseRectIn();
	void InvalRect() {
		GrafPtr port;
		GetPort(&port);
		::InvalWindowRect(::GetWindowFromPort(port), this);
	}
	void InvalRectIn();
	void InvertRect(Boolean color = TRUE);
	void InvertRectIn(Boolean color = TRUE);
	Boolean PtInRect(Point pt) {
		return ::PtInRect(pt, this);
	}
	void Pt2Rect(Point pt1, Point pt2) {
		::Pt2Rect(pt1, pt2, this);
	}
	void FillRect(const Pattern *pat) {
		::FillRect(this, pat);
	}
	void PaintRect() {
		::PaintRect(this);
	}
	void ClipRect() {
		::ClipRect(this);
	}
	void FrameRoundRect(short ovalWidth, short ovalHeight) {
		::FrameRoundRect(this, ovalWidth, ovalHeight);
	}
	void OffsetRect(short dh, short dv) {
		::OffsetRect(this, dh, dv);
	}
	void InsetRect(short dh, short dv) {
		::InsetRect(this, dh, dv);
	}
	void LocalToGlobal();
	void GlobalToLocal();
	void SetWidth(short width) {
		right = left + width;
	}
	void SetHeight(short height) {
		bottom = top + height;
	}
	short GetWidth() {
		return right - left;
	}
	short GetHeight() {
		return bottom - top;
	}
	TPoint GetWidthHeight();
	TPoint GetLeftTop();
	TPoint GetRightBottom();
	void FillCRect(PixPatHandle ppat) {
		::FillCRect(this, ppat);
	}
	void FillCRect(PixPatHandle ppat, short ileft, short itop, short iright, short ibottom) {
		SetRect(ileft, itop, iright, ibottom);
		FillCRect(ppat);
	}
	void PaintGrayPanel(TWindow *win = NULL, Boolean vertical = FALSE);
};

/*
	TPoint
	|CgNX
*/
class TPoint : public Point {
public:
	TPoint() {
		SetPt(0, 0);
	}
	TPoint(const TPoint& cpt) {
		*(Point *)this = *(Point *)&cpt;
	}
	TPoint(Point pt) {
		*(Point *)this = pt;
	}
	TPoint(short ih, short iv) {
		SetPt(ih, iv);
	}
	operator Point()	/* Pointւ̃LXg */
	{
		return *(Point *)this;
	}
	operator Point *()	/* Point *ւ̃LXg */
	{
		return (Point *)this;
	}
	void operator=(TPoint& cpt)	/* TPoint̃Rs[ */
	{
		*(Point *)this = *(Point *)&cpt;
	}
	void operator=(Point pt)	/* Point̃Rs[ */
	{
		*(Point *)this = pt;
	}
	Boolean operator==(TPoint& cpt) {
		return EqualPt(cpt);
	}
	Boolean operator!=(TPoint& cpt) {
		return !operator==(cpt);
	}
	Boolean operator==(Point pt) {
		return EqualPt(pt);
	}
	Boolean operator!=(Point pt) {
		return !operator==(pt);
	}
	void SetPt(short ih, short iv) {
		::SetPt(this, ih, iv);
	}
	Boolean EqualPt(Point pt) {
		return ::EqualPt(*this, pt);
	}
	void GlobalToLocal() {
		::GlobalToLocal(this);
	}
	void LocalToGlobal() {
		::LocalToGlobal(this);
	}
	void GetMouse() {
		::GetMouse(this);
	}
	void MoveTo() {
		::MoveTo(h, v);
	}
};

/*
	TRgn
	[WNX
*/
class TRgn {
private:
	RgnHandle m_rgn;
public:
	TRgn();
	TRgn(const TRgn& crgn);
	TRgn(RgnHandle rgn);
	TRgn(Rect r);
	~TRgn();
	operator RgnHandle()	/* RgnHandleւ̃LXg */
	{
		return m_rgn;
	}
	void operator=(RgnHandle rgn)	/* RgnHandlẽRs[ */
	{
		CopyRgn(rgn);
	}
	void operator=(const TRgn& crgn)	/* TRgñRs[ */
	{
		CopyRgn(crgn.m_rgn);
	}
	void operator=(Rect r)	/* Rect̃Rs[ */
	{
		RectRgn(&r);
	}
	Boolean operator==(TRgn& crgn) {
		return EqualRgn(crgn);
	}
	Boolean operator!=(TRgn& crgn) {
		return !operator==(crgn);
	}
	Boolean operator==(RgnHandle rgn) {
		return EqualRgn(rgn);
	}
	Boolean operator!=(RgnHandle rgn) {
		return !operator==(rgn);
	}
	void NewRgn() {
		m_rgn = ::NewRgn();
	}
	void OpenRgn() {
		::OpenRgn();
	}
	void CloseRgn() {
		::CloseRgn(m_rgn);
	}
	void DisposeRgn() {
		::DisposeRgn(m_rgn);
	}
	Boolean EqualRgn(RgnHandle rgn) {
		return ::EqualRgn(m_rgn, rgn);
	}
	TRgn SectRgn(RgnHandle rgn);
	TRgn UnionRgn(RgnHandle rgn);
	void OffsetRgn(short dh, short dv) {
		::OffsetRgn(m_rgn, dh, dv);
	}
	void SetClip() {
		::SetClip(m_rgn);
	}
	void GetClip() {
		::GetClip(m_rgn);
	}
	void RectRgn(const Rect *r) {
		::RectRgn(m_rgn, r);
	}
	void CopyRgn(RgnHandle srcRgn) {
		::CopyRgn(srcRgn, m_rgn);
	}
	long DragGrayRgn(Point startPt, const Rect *limitRect, const Rect *slopRect, short axis, DragGrayRgnUPP actionProc) {
		return ::DragGrayRgn(m_rgn, startPt, limitRect, slopRect, axis, actionProc);
	}
	void InsetRgn(short dh, short dv) {
		::InsetRgn (m_rgn, dh, dv);
	}
	void DiffRgn (RgnHandle srcRgnA, RgnHandle srcRgnB) {
		::DiffRgn(srcRgnA, srcRgnB, m_rgn);
	}
	Boolean PtInRgn(Point pt) {
		return ::PtInRgn(pt, m_rgn);
	}
	void BeFrame();
	void LocalToGlobal();
	TRect GetBBox();
};

/*
	TFontInfo
	tHgNX
*/
class TFontInfo : public FontInfo {
public:
	TFontInfo() {
		GetFontInfo();
	}
	short GetHeight() {
		return ascent + descent + leading;
	}
	void GetFontInfo() {
		::GetFontInfo(this);
	}
};

/*
	TCursor
	J[\NX
*/
class TCursor : public TBase {
	friend class TCursorList;
private:
	CursHandle *m_cur;
	short m_cursorID;
	int m_count;
	long m_intervalTick;
	long m_prevTick;
	int m_current;
public:
	TCursor();
	TCursor(short cursorID, int count, int intervalTick);
	void GetCursor(short cursorID, int count, int intervalTick);
	void SetCursor();
	TCursor *GetNext() {
		return (TCursor *)TBase::GetNext();
	}
	int GetCount() {
		return m_count;
	}
private:
	void Initial();
};

#define	arrowCursor			0
#define	otherCursor			-1

/*
	TCursorList
	J[\XgNX
*/
class TCursorList : public TListBase {
private:
	short m_current;
public:
	TCursorList();
	void Load(short cursorID, int count = 1, int intervalTick = 0);
	void Set(short cursorID, Boolean force = FALSE);
	void Reset();
	TCursor *GetByID(short cursorID);
	TCursor *GetTop() {
		return (TCursor *)TListBase::GetTop();
	}
};

/*
	TFont
	tHgNX
*/
class TFont {
private:
	short m_fontNum;
public:
	TFont();
	TFont(TFont& font);
	TFont(short fontNum);
	TFont(TString name);
	operator short() {
		return m_fontNum;
	}
	void operator=(TFont& font) {
		m_fontNum = font.m_fontNum;
	}
	void operator=(short fontNum) {
		m_fontNum = fontNum;
	}
	Boolean operator==(TFont& font) {
		return m_fontNum == font.m_fontNum;
	}
	Boolean operator!=(TFont& font) {
		return !operator==(font);
	}
	Boolean operator==(short fontNum) {
		return m_fontNum == fontNum;
	}
	Boolean operator!=(short fontNum) {
		return !operator==(fontNum);
	}
	TString GetFontName();
	void GetFNum(ConstStr255Param name) {
		::GetFNum(name, &m_fontNum);
	}
	Boolean RealFont(short size) {
		return ::RealFont(m_fontNum, size);
	}
};

/*
	TPicture
	sN`[NX
*/
class TPicture {
private:
	PicHandle m_pic;
	Boolean m_isResource;
public:
	TPicture();
	~TPicture();
	void GetPicture(short pictureID);
	void DrawPicture(const Rect *dstRect) {
		::DrawPicture(m_pic, dstRect);
	}
	int GetPicSize() {
		return (**m_pic).picSize;
	}
	TRect GetPicFrame() {
		return (**m_pic).picFrame;
	}
	PicHandle GetPicHandle() {
		return m_pic;
	}
	void OpenPicture(Rect picFrame) {
		m_pic = ::OpenPicture(&picFrame);
	}
	void ClosePicture() {
		::ClosePicture();
	}
	Boolean IsNull() {
		return m_pic == NULL;
	}
};

/*
	TIconSuite
	ACRgNX
*/
class TIconSuite {
private:
	IconSuiteRef m_icon;
public:
	OSErr m_error;
	TIconSuite();
	~TIconSuite();
	operator IconSuiteRef() {
		return m_icon;
	}
	OSErr GetIconSuite(short resID, IconSelectorValue selector = svAllAvailableData) {
		return m_error = ::GetIconSuite(&m_icon, resID, selector);
	}
	OSErr PlotIconSuite(const Rect *r, IconAlignmentType align = atNone, IconTransformType transform = ttNone) {
		return m_error = ::PlotIconSuite(r, align, transform, m_icon);
	}
};

class TIconRef {
private:
	IconRef m_ref;
	SInt16 m_label;
	OSType m_creator;
	OSType m_iconType;
public:
	TIconRef();
	~TIconRef();
	operator IconRef() {
		return m_ref;
	}
	OSErr GetIconRefFromFile(const FSSpec *spec) {
		return ::GetIconRefFromFile(spec, &m_ref, &m_label);
	}
	OSErr RegisterIconRefFromIconFamily(OSType creator, OSType iconType, IconFamilyHandle iconFamily) {
		return ::RegisterIconRefFromIconFamily(creator, iconType, iconFamily, &m_ref);
	}
	OSErr GetFromResource(short resID, OSType creator, OSType iconType);
};

/*
	TPixPat
	J[sNZp^[
*/
class TPixPat {
private:
	PixPatHandle m_ppat;
public:
	void InitAndMake(const RGBColor *myColor);
	TPixPat(const RGBColor *myColor) {
		InitAndMake(myColor);
	}
	TPixPat(unsigned int red, unsigned int green, unsigned int blue) {
		RGBColor myColor = {red, green, blue};
		InitAndMake(&myColor);
	}
	TPixPat(short patID) {
		GetPixPat(patID);
	}
	~TPixPat();
	void NewPixPat();
	void GetPixPat(short patID);
	operator PixPatHandle() {
		return m_ppat;
	}
	void MakeRGBPat(const RGBColor *myColor) {
		::MakeRGBPat(m_ppat, myColor);
	}
};

class TLongPoint {
public:
	long h;
	long v;
	void Initial();
	TLongPoint();
	TLongPoint(long x, long y);
	void operator=(const TPoint& r);
	operator TPoint() const;
	void SetPt(long x, long y);
};

class TLongRect {
public:
	long left;
	long top;
	long right;
	long bottom;
	void Initial();
	TLongRect();
	TLongRect(const TRect& r);
	void operator=(const TRect& r);
	operator TRect() const;
	void SetRect(long l, long t, long r, long b);
	void OffsetRect(long dh, long dv);
	Boolean PtInRect(TLongPoint pt);
};

#endif
