/*
	TEditor.cpp
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.03.02	1.0			Takeshi Yoneki
*/

#include "csystem.h"

/*
	A_[o[NX
*/

short TUnderBar::OnChangeSize(short dmy) {
	TRect winRect = m_parent->GetPortRect();
	short top = winRect.bottom - SCROLL_BAR_WIDTH + 1;
	m_panelRect.SetRect(-1, top + 1, winRect.GetWidth() - SCROLL_BAR_WIDTH + 2, top + SCROLL_BAR_WIDTH);
	m_boxRect.SetRect(-1, top, winRect.GetWidth() - SCROLL_BAR_WIDTH + 2, top + SCROLL_BAR_WIDTH + 1);
	m_bgRect.SetRect(-1, top, winRect.right + 1, top + SCROLL_BAR_WIDTH + 1);
	m_bgRect.InvalRect();
	return m_boxRect.GetHeight();
}

void TUnderBar::OnUpdate() {
	m_boxRect.FillCRect(theSystem->systemVersion >= 0x1000 ? *theSystem->grayPixPat : *theSystem->blackPixPat);
	m_panelRect.PaintGrayPanel(m_parent);
	//	m_boxRect.FrameRect();
}

#ifdef CONFIG_USE_CEDITOR

pascal void TScrollBar_HandleScroll(ControlRef ctrl, short part);
pascal Boolean TEditor_AutoScroll(TEPtr pTE);
pascal void TEditor_AutoScroll_68K();

/*
	XN[o[NX
*/

TScrollBar::TScrollBar() {
	m_isVertical = TRUE;
	m_uppControlAction = NULL;
}

/*
	XN[o[Vp
	refConɃNX̃|C^ZbĝőS
*/
void TScrollBar::NewScrollBar() {
	NewControl(*m_parent, m_boxRect, "\p", TRUE, 0, 0, 0, theSystem->hasAppearance ? kControlScrollBarLiveProc : scrollBarProc, 0L);
	SetControlReference((long)this);
	m_uppControlAction.SetUPP(TScrollBar_HandleScroll);
}

/*
	Abvf[g
	KvTCYȉ̏ꍇErase
	ʏ͏ɕ\݂
*/
void TScrollBar::OnUpdate() {
	if (m_boxRect.GetWidth() == 0 && m_bgRect.GetHeight() > 0) {
		m_bgRect.EraseRectIn();
		m_bgRect.FrameRect();
	}
}

Boolean TScrollBar::IsInside(TPoint mousePt) {
	return m_boxRect.PtInRect(mousePt);
}

void TScrollBar::OnActivate(Boolean act) {
	HiliteControl(act ? kControlNoPart : kControlInactivePart);
}

/*
	XN[o[̃N^O̍Đݒ
	EBhETCYύX̏
	ǂCodeWarrior̃GfB^͎኱oOĂ
*/
short TScrollBar::OnChangeSize(short top) {
	TRect winRect = m_parent->GetPortRect();
	TRect sr;
	Boolean tooSmall = FALSE;
	top -= 1;
	if (m_isVertical) {
		sr.SetRect(winRect.right - SCROLL_BAR_WIDTH + 1, top, winRect.right + 1, winRect.bottom - SCROLL_BAR_WIDTH + 2);
		tooSmall = sr.GetHeight() < SCROLL_BAR_WIDTH * 2 + 1;
	}
	else {
		sr.SetRect(-1, top, winRect.right + 1, top + SCROLL_BAR_WIDTH);
		tooSmall = sr.GetWidth() < SCROLL_BAR_WIDTH * 2 + 1;
	}
	m_bgRect = sr;
	if (m_bgRect.GetHeight() < 0)
		m_bgRect.SetHeight(0);
	if (m_bgRect.GetWidth() < 0)
		m_bgRect.SetWidth(0);
	if (tooSmall) {
		sr.SetWidth(0);
		sr.SetHeight(0);
		m_bgRect.InvalRect();
	}
	if (IsNull() == FALSE) {
		SizeControl(sr.GetWidth(), sr.GetHeight());
		MoveControl(sr.left, sr.top);
	}
	m_boxRect = sr;

	return m_bgRect.GetHeight();
}

pascal void TScrollBar_HandleScroll(ControlRef ctrl, short part) {
	TScrollBar *bar = (TScrollBar *)GetControlReference(ctrl);
	bar->HandleScroll(part);
}

void TScrollBar::HandleScroll(short part) {
}

/*
	XN[o[NbNꂽ
*/
void TScrollBar::OnContent(EventRecord *ev) {
	TPoint mousePt = ev->where;
	mousePt.GlobalToLocal();
	if (TestControl(mousePt) > 128 && theSystem->hasAppearance == FALSE) {
		short part = TrackControl(mousePt, (ControlActionUPP)-1);
		if (part != 0)
			HandleScroll(part);
	}
	else {
		TrackControl(mousePt, (ControlActionUPP)m_uppControlAction.GetUPP());
	}
}

/*
	TextEditXN[o[
*/

/*
	GfB^NXƂ̊֘At
	֘AtNewScrollBar()悾čs
	eEBhEƂ̊֘AtSetParentWindow()
*/
void TEditScrollBar::SetRelateToEditor(TEditor *editor) {
	m_editor = editor;
}

/*
	XN[o[NbNĂԂ̓
	o[̓ɍ킹ăeLXgXN[
	R[obN[`
	HandleScroll handles mouse-downs in the up-line, down-line, up-page, or down-page
	regions of the horizontal or vertical scroll bar. We must first determine which scroll bar
	the mouse was clicked in so that the proper page size is used. The value of the associated
	control is then updated and the text is scrolled if necessary. This procedure is the same as
	the actionProc "MyAction" which is described in the Control Manager section of "Inside
	Macintosh".																									}
	̊֐܂މpɂRĝ邢̊֐͂THINK Pascalɕt
	TṽGfB^̃\[XRłB炩ʉecĂxłǂˁB
*/
void TEditScrollBar::HandleScroll(short part) {
	short delta = 0;
	short pageSize = m_editor->m_viewLines - 1;
	switch (part) {
	case kControlUpButtonPart:
		delta = -1;
		break;
	case kControlDownButtonPart:
		delta = 1;
		break;
	case kControlPageUpPart:
		delta = -pageSize;
		break;
	case kControlPageDownPart:
		delta = pageSize;
		break;
	}
	short oldValue = GetControlValue();
	short newValue = oldValue + delta;
	SetControlValue(newValue);
	m_editor->AdjustText();
}

/*
	GfB^NX
*/

/*
	TEditor_AutoScrollƂ̂܂ȂR[obN[`
	͍̂̂ŁAȃO[oϐpӂāAJg̃NX
	w肵ȂȂȂB
*/
TEditor *currentTEditorForAutoScroll;

/*
	eLXgNbNĂԂ̃eLXg̃XN[
	R[obN[`
	AutoScroll is the "ClikLoop" routine which is described in the TextEdit Programmer's
	Guide in Inside Macintosh. It is installed in all Edit windows opened by the editor. It is
	called repeatedly from the ToolBox, for as long as the user holds down the mouse button,
	when the mouse was first clicked in the text of some window. The text in the window is
	scrolled up or down depending upon whether the mouse is above or below the text.
*/
pascal Boolean TEditor_AutoScroll(TEPtr pTE) {
	TEditor *editor = currentTEditorForAutoScroll;
	if (editor == NULL)
		return FALSE;
	TSaveClipRgn saveRgn(editor->m_parent);
	editor->m_parent->GetPortRect().ClipRect();
	TPoint mousePt;
	mousePt.GetMouse();
	TRect vr = editor->GetViewRect();
	if (mousePt.v < vr.top) {
		TScrollBar_HandleScroll(*editor->m_scrollBar, kControlUpButtonPart);
	}
	else if (mousePt.v > vr.bottom) {
		TScrollBar_HandleScroll(*editor->m_scrollBar, kControlDownButtonPart);
	}
	return TRUE;
}

pascal void TEditor_AutoScroll_68K() {
	TEditor_AutoScroll(NULL);
}

TEditor::TEditor() {
}

TEditor::~TEditor() {
	if (m_undo->m_target == this)
		m_undo->Reset();
	if (m_useTSM)
		m_tsm.DeleteTSMDocument();
}

OSErr TEditor::DragReceiveHandler(WindowPtr wp, void *refCon, DragReference dragRef) {
	//theDebug->Log("DragReceiveHandler");
	TSavePort savePort(m_parent);
	TDrag drag(dragRef);
	if (m_dragSelPoint == -1 || m_dragCanAccept == FALSE)
		return dragNotAcceptedErr;

	DrawCaret(m_dragSelPoint);	/* Lbg̏ */

	DragAttributes attr = drag.GetDragAttributes();
	if (attr & kDragHasLeftSenderWindow && m_dragInContent) {
		drag.HideDragHilite();
		m_dragInContent = FALSE;
	}

	if (attr & kDragInsideSenderWindow) {
		short mdown, mup;
		drag.GetDragModifiers(0, &mdown, &mup);
		Boolean option = (mdown & optionKey) != 0 || (mup & optionKey) != 0;
		if (GetSelStart() < m_dragSelPoint && GetSelEnd() > m_dragSelPoint)
			return noErr;
		if (option == FALSE) {
			if (GetSelectLength() > 0 && m_dragSelPoint >= GetSelEnd())
				m_dragSelPoint -= GetSelectLength();

			OnDragMove(m_dragSelPoint);
			m_dragSelPoint = -1;
			m_dirty = TRUE;
			return noErr;
		}
	}

	unsigned short numItems, i, numFlavors, j;
	numItems = drag.CountDragItems();

	TListBase dataList;
	TMemory *buffer;

	long lengthSum = 0;

	for (i = 1; i <= numItems; i++) {
		ItemReference item = drag.GetDragItemReferenceNumber(i);
		long length;
		FlavorType tp = '    ';
		numFlavors = drag.CountDragItemFlavors(item);
		for (j = 1; j <= numFlavors; j++) {
			tp = drag.GetFlavorType(item, j);
			if (tp == 'hfs ' || tp == 'TEXT')
				break;
		}
		if (tp == 'hfs ') {
			long sz = sizeof(HFSFlavor);
			HFSFlavor hfsf;
			drag.GetFlavorData(item, 'hfs ', &hfsf, &sz, 0);
			if (drag.IsGood() == FALSE)
				continue;
			if (hfsf.fileType != 'TEXT')
				continue;
			TFSSpec spec(hfsf.fileSpec);
			TFileIO file((TFilePath)spec);
			if (file.IsGood() == FALSE)
				continue;
			length = file.GetEOF();
			if (m_bufferCount + GetTextLength() + lengthSum + length > MAX_TEXT_LENGTH) {
				SysBeep(0);
				break;
			}
			buffer = new TMemory(length);
			file.Read(length, (char *)*buffer);
			if (file.IsGood() == FALSE) {
				delete buffer;
				continue;
			}
		}
		else if (tp == 'TEXT') {
			length = drag.GetFlavorDataSize(item, 'TEXT');
			if (drag.IsGood() == FALSE || length <= 0)
				continue;
			if (m_bufferCount + GetTextLength() + lengthSum + length > MAX_TEXT_LENGTH) {
				SysBeep(0);
				break;
			}
			buffer = new TMemory(length);
			drag.GetFlavorData(item, 'TEXT', (char *)*buffer, &length, 0);
			if (drag.IsGood() == FALSE) {
				delete buffer;
				continue;
			}
		}
		else {
			continue;
		}

		dataList.Append((TBase *)buffer);
		lengthSum += length;
	}

	TMemory allData(lengthSum);
	char *p = (char *)allData;
	for (buffer = (TMemory *)dataList.GetTop(); buffer != NULL; buffer = (TMemory *)buffer->GetNext()) {
		memcpy(p, (char *)*buffer, buffer->GetLength());
		p += buffer->GetLength();
	}

	TESetSelect(m_dragSelPoint, m_dragSelPoint);
	m_undo->SetCaretMove(this);
	InsertText((char *)allData, lengthSum);
	TESetSelect(m_dragSelPoint, m_dragSelPoint + lengthSum);
	m_undo->SetCaretMove(this);
	ShowSelect();

	m_dragSelPoint = -1;
	dataList.RemoveDeleteAll();
	m_dirty = TRUE;

	return noErr;
}


OSErr TEditor::DragTrackingHandler(DragTrackingMessage message, WindowPtr wp, void *refCon, DragReference dragRef) {
	TSavePort savePort(m_parent);
	TDrag drag(dragRef);

	/* handlerɓ */
	if (message == kDragTrackingEnterHandler)	/* drag has entered window */
	{
	}
	/* windowɓ */
	else if (message == kDragTrackingEnterWindow) {
		m_dragCanAccept = FALSE;
		m_dragInContent = FALSE;
		m_dragSelPoint = -1;
		unsigned short numItems, i, numFlavors, j;
		numItems = drag.CountDragItems();
		for (i = 1; i <= numItems; i++) {
			ItemReference item;
			item = drag.GetDragItemReferenceNumber(i);
			FlavorType tp = '    ';
			numFlavors = drag.CountDragItemFlavors(item);
			for (j = 1; j <= numFlavors; j++) {
				tp = drag.GetFlavorType(item, j);
				if (tp == 'hfs ' || tp == 'TEXT') {
					m_dragCanAccept = TRUE;
					break;
				}
			}
			if (m_dragCanAccept)
				break;
		}
	}
	/* windowŃhbO */
	else if (message == kDragTrackingInWindow)	/* drag is moving within window */
	{
		if (m_dragCanAccept == FALSE)
			return noErr;

		DragAttributes attr;
		attr = drag.GetDragAttributes();
		TPoint mousePt = drag.GetDragMouse();
		mousePt.GlobalToLocal();

		if ((attr & kDragHasLeftSenderWindow) != 0) {
			if (IsInside(mousePt)) {
				if (m_dragInContent == FALSE) {
					TRgn rgn(m_bgRect);
					drag.ShowDragHilite(rgn);
					m_dragInContent = TRUE;
				}
			}
			else {
				if (m_dragInContent) {
					drag.HideDragHilite();
					m_dragInContent = FALSE;
				}
			}
		}

		if (IsInside(mousePt)) {
			int n = TEGetOffset(mousePt);
			if (n != m_dragSelPoint) {
				if (m_dragSelPoint != -1)
					DrawCaret(m_dragSelPoint);	/*  */
				m_dragSelPoint = n;
				if (attr & kDragInsideSenderWindow)
					if (GetSelStart() < m_dragSelPoint && GetSelEnd() > m_dragSelPoint)
						m_dragSelPoint = -1;
				if (m_dragSelPoint != -1)
					DrawCaret(m_dragSelPoint);
			}
		}
	}
	/* windowOꂽ */
	else if (message == kDragTrackingLeaveWindow)	/* drag has exited window */
	{
		if (m_dragSelPoint != -1)
			DrawCaret(m_dragSelPoint);
		if (m_dragInContent)
			drag.HideDragHilite();
		m_dragCanAccept = FALSE;
		m_dragInContent = FALSE;
		m_dragSelPoint = -1;
	}
	/* handlerOꂽ */
	else if (message == kDragTrackingLeaveHandler) {
	}

	return noErr;
}

/*
	GfBbg̈NbNꂽ
*/
void TEditor::OnContent(EventRecord *ev) {
	BufferFlush();
	TPoint mousePt = ev->where;
	mousePt.GlobalToLocal();

	/* D&D */
	long length = GetSelectLength();
	int n = TEGetOffset(mousePt);
	if (theSystem->hasDragMgr && GetSelStart() <= n && GetSelEnd() >= n && length > 0) {
		if (WaitMouseMoved(ev->where) == TRUE) {
			TDrag drag;
			if (drag.IsGood() == FALSE)
				return;
			TMemory buffer(length);
			CopyTo((char *)buffer, GetSelStart(), length);
			drag.AddDragItemFlavor(1, 'TEXT', (char *)buffer, length, 0);

			TRgn rgn;
			TEGetHiliteRgn(rgn);
			rgn.LocalToGlobal();
			rgn.BeFrame();

			drag.TrackDrag(ev, rgn);
			return;
		}
	}

	Boolean extend = (ev->modifiers & shiftKey) != 0;
	currentTEditorForAutoScroll = this;
	TEClick(mousePt, extend);
	m_undo->SetCaretMove(this);
	m_shiftStartPos = GetSelStart();
}

void TEditor::OnDragMove(long moveTo) {
	/* m_dragSelPointɈړ̈ʒuĕ̈ړ */
	m_dragSelPoint = moveTo;
	m_undo->SetUndo(this, UNDO_CMD_MOVE);
	long length = GetSelectLength();
	TMemory text(length);
	CopyTo(text, GetSelStart(), length);

	TRgn srcRgn;
	TEGetHiliteRgn(srcRgn);
	TRect srcRect(srcRgn.GetBBox());
	srcRect.LocalToGlobal();

	TAutoOffScreen offscreen;
	SetInPort(offscreen.DrawOff(GetInPort()));

	TEDelete();
	TESetSelect(m_dragSelPoint, m_dragSelPoint);
	TEInsert((char *)text, text.GetLength());
	TESetSelect(m_dragSelPoint, m_dragSelPoint + length);

	TRgn dstRgn;
	TEGetHiliteRgn(dstRgn);
	TRect destRect(dstRgn.GetBBox());
	SetPort(offscreen.GetSavePort());
	destRect.LocalToGlobal();

	ZoomRects(srcRect, destRect, 12, kZoomDecelerate);

	SetInPort(offscreen.DrawOn());

	ShowSelect();
	m_shiftStartPos = GetSelStart();
}

/*
	VKTextEditGfB^ɗp
*/
void TEditor::NewEditor(TEditorUndo *undo, Boolean useTSM, int lineSpacing) {
	m_undo = undo;
	TENew(m_boxRect, m_boxRect);
	m_uppTEClickLoop.SetUPP(TEditor_AutoScroll);
	TESetClickLoop((TEClickLoopUPP)m_uppTEClickLoop.GetUPP());
	m_bufferCount = 0;
	m_dirty = FALSE;
	m_caretMovedTick = 0;
	m_shiftStartPos = 0;
	m_useTSM = FALSE;
	m_textList = NULL;
	m_lineSpacing = lineSpacing;
	if (theSystem->hasTSMTE) {
		m_useTSM = m_tsm.NewTSMDocument(this) == noErr;
		m_tsm.UseInputWindow(!useTSM);
	}
}

/*
	XN[o[NXƂ̊֘At
	֘AtNewEditor()悾čs
	eEBhEƂ̊֘AtSetParentWindow()
*/
void TEditor::SetRelateToScrollBar(TEditScrollBar *scrollBar) {
	m_scrollBar = scrollBar;
}

/*
	destRectviewRect̃Zbg
	eLXg̍ŏ̕ʂɕ\悤ɂȂ
*/
void TEditor::ResetRects() {
	SetDestRect(m_boxRect);
	SetViewRect(m_boxRect);	/* TEɓnN^O͗dest */
}

/*
	XN[o[̒lɃeLXgXN[
	AdjText scrolls the text horizontally and vertically if necessary to reflect the current
	"value" of either scroll bar. The scroll bar values are set elsewhere.
*/
void TEditor::AdjustText() {
	short oldScroll = GetViewRect().top - GetDestRect().top;
	short newScroll = m_scrollBar->GetControlValue() * GetLineHight();
	short delta = oldScroll - newScroll;
	if (delta != 0)
		TEScroll(0, delta);
}

/*
	\ȂĂ͂ȂȂPos𓾂
*/
long TEditor::GetPosMustShow() {
	if (GetSelectLength() > 0 && m_shiftStartPos == GetSelStart())
		return GetSelEnd();
	else
		return GetSelStart();
}

/*
	݂̃ZNgʒusԍœāAꂪʂɕ\悤ɃXN[B
	DoShow adjusts the scroll bar "value" so that the start of the selection, or current
	insertion point becomes the top line in the window, or at least appears in the window.
*/
void TEditor::Show() {
	long selLine = 0;
	long pos = GetPosMustShow();
	for (; pos > (**m_te).lineStarts[selLine];)
		selLine += 1;
	short oldValue = m_scrollBar->GetControlValue();
	short newValue;
	if (oldValue - 1 == selLine)
		newValue = selLine;
	else if (oldValue + m_viewLines == selLine)
		newValue = selLine - m_viewLines + 1;
	else
		newValue = selLine - m_viewLines / 2;
	m_scrollBar->SetControlValue(newValue);
	AdjustText();
}

/*
	݂̃ZNgʊOǂAʊÔ΂̓XN[
	ShowSelect adjusts the vertical scroll bar, and forces the insertion point, or top of the
	current text selection to be displayed in the window. This routine is typically called after
	inserting a character into the text, or after an edit.
*/
void TEditor::ShowSelect() {
	AdjustScrollBar();
	short topLine = m_scrollBar->GetControlValue();
	short topNum = (**m_te).lineStarts[topLine];
	short bottomNum = (**m_te).lineStarts[topLine + m_viewLines];	/* 1992.04.01 */
	long pos = GetPosMustShow();
	if (pos < topNum)
		Show();
	else if (pos >= bottomNum && bottomNum > 0)
		Show();
	else
		AdjustText();
}

/*
	XN[o[MaximumlTextEdit̎eLXg̍sɍ킹
	save == FALSE XN[o[̈ʒu0ɂ
	(save == TRUE  XN[o[̈ʒuɕύX͉Ȃ)
	save == TRUE  XN[o[̈ʒu̓eLXg̃XN[TCYɏ
*/
void TEditor::AdjustScrollBar(Boolean save) {
	int max = m_viewLines > GetLineNumber() ? 0 : GetLineNumber();
	m_scrollBar->SetControlMaximum(max);
	if (save == FALSE) {
		m_scrollBar->SetControlValue(0);
	}
	else {
		long diff = GetViewRect().top - GetDestRect().top;
		long value = diff == 0 ? 0 : diff / GetLineHight();
		if (value != m_scrollBar->GetControlValue())
			m_scrollBar->SetControlValue(value);
	}
}

/*
	eLXgSꊷ
*/
void TEditor::SetText(char *data, long count) {
	TSavePort savePort(m_parent);
	TEDeactivate();
	ResetRects();
	TESetText(data, count);
	AdjustScrollBar(FALSE);
	CaretToTop();
	TEActivate();
	m_dirty = TRUE;
	if (m_undo->m_target == this)
		m_undo->Reset();
	m_bgRect.InvalRect();
}

void TEditor::CaretToTop() {
	TESetSelect(0, 0);
	ShowSelect();
	m_undo->SetCaretMove(this);
}
void TEditor::CaretToBottom() {
	TESetSelect(GetTextLength(), GetTextLength());
	ShowSelect();
	m_undo->SetCaretMove(this);
}

/*
	eNjJm[gɋLڂĂǂ̍sLbgm
	ɂ鏈Ȃ񂾂ǂǂǂȂŎĝ
*/
void TEditor::CaretOnLeft() {
	if (m_caretMovedTick == 0 || TickCount() < m_caretMovedTick + 10)
		return;
	if (GetSelStart() != GetSelEnd())
		return;
	if ((**m_te).clikStuff == 255)	/* 1996.07.04 */
		return;
	TEDeactivate();
	(**m_te).clikStuff = 255;
	TESetSelect(GetSelStart(), GetSelEnd());
	TEActivate();
	m_caretMovedTick = 0;
}

/*
	GfBbg{bNX̃Abvf[g
*/
void TEditor::OnUpdate() {
	m_bgRect.EraseRectIn();
	m_bgRect.FrameRect();
	TEUpdate();
}

void TEditor::OnActivate(Boolean act) {
	if (m_useTSM) {
		if (act == FALSE)
			m_tsm.FixTSMDocument();
		m_tsm.ActivateTSMDocument(act);
	}
	TEActivate(act);
}

Boolean TEditor::IsInside(TPoint mousePt) {
	return m_bgRect.PtInRect(mousePt);
}

/*
	GfB^̃N^O̍Đݒ
	EBhETCYύX̏
*/

TPoint TEditor::OnChangeSize(TPoint pt) {
	TFontInfo fInfo;
	short lineHight = fInfo.GetHeight() + m_lineSpacing;
	TRect winRect = m_parent->GetPortRect();
	TRect vr(pt.h - 1, pt.v - 1, winRect.right - SCROLL_BAR_WIDTH + 2, winRect.bottom - SCROLL_BAR_WIDTH + 2);
	if (vr.GetHeight() - 6 < lineHight) {
		m_viewLines = 1;
		m_boxRect.SetRect(0, 0, 100, 0);
		if (vr.GetHeight() < 0)
			vr.SetRect(0, 0, 0, 0);
	}
	else {
		m_viewLines = (vr.GetHeight() - 6) / lineHight;
		m_boxRect.SetRect(vr.left + 8, vr.top + 4, vr.right - 5, vr.bottom);
		m_boxRect.SetHeight(m_viewLines * lineHight);
	}
	if (m_te != NULL) {
		SetFont(m_parent->GetFont());
		SetFontSize(m_parent->GetFontSize());
		SetLineHight(lineHight);
		SetFontAscent(fInfo.ascent);
		ResetRects();
		TECalText();
		AdjustScrollBar(FALSE);
		vr.InvalRect();
	}
	m_bgRect = vr;
	return TPoint(vr.GetWidth() - 1, vr.GetHeight());
}

void TEditor::InsertText(char *text, long length) {
	if (m_bufferCount + GetTextLength() - GetSelectLength() > MAX_TEXT_LENGTH) {
		SysBeep(0);
		return;
	}
	if (m_undo->CanContinueUndoType(this) == FALSE)
		m_undo->SetUndo(this, UNDO_CMD_TYPE);
	TEDelete();
	TEInsert(text, length);
	m_undo->SetTypePos(this, GetSelEnd());
	m_dirty = TRUE;
	if (GetSelectLength() == 0)
		m_shiftStartPos = GetSelStart();
	ShowSelect();
}

void TEditor::InsertFile(TFilePath& filePath) {
	TFileIO file(filePath);
	if (file.IsGood() == FALSE)
		return;
	long count = file.GetEOF();
	if (count > MAX_TEXT_LENGTH)
		count = MAX_TEXT_LENGTH;
	TMemory data(count + 16);
	file.Read(count, (char *)data);
	InsertText((char *)data, count);
}

/*
	͂̍̂߂̃obt@ÕtbV
	{̓CCłȂFEP̑ʂ̓͂Cɔ邽߁A
	obt@OʓIBč̃GfB^ׂ͂ĂȂ
	̂B܁A܂B
*/
void TEditor::BufferFlush() {
	if (m_bufferCount > 0) {
		InsertText(m_buffer, m_bufferCount);
		m_bufferCount = 0;
	}
}

/*
	ɂȂ炨ł
	tbV
*/
void TEditor::OnTask() {
	BufferFlush();
	CaretOnLeft();
	TEIdle();
}

void TEditor::OnMouseCursor(TPoint mousePt) {
	//	TPoint mousePt;
	//	GetMouse(mousePt);
	//	mousePt.GlobalToLocal();
	int n = TEGetOffset(mousePt);
	if (GetSelStart() <= n && GetSelEnd() >= n)
		theCursor->Reset();
	else
		theCursor->Set(iBeamCursor);
}

void TEditor::ArrowKey(int data) {
	if (GetSelectLength() > 0 && data == 0x1C)
		TESetSelect(GetSelStart(), GetSelStart());
	else if (GetSelectLength() > 0 && data == 0x1D)
		TESetSelect(GetSelEnd(), GetSelEnd());
	else
		TEKey(data);
}

void TEditor::ShiftArrowKey(int data) {
	long sel;
	if (GetSelStart() < m_shiftStartPos)
		sel = GetSelStart();
	else
		sel = GetSelEnd();
	TESetSelect(sel, sel);
	TEKey(data);
	sel = GetSelEnd();
	if (m_shiftStartPos < sel)
		TESetSelect(m_shiftStartPos, sel);
	else
		TESetSelect(sel, m_shiftStartPos);
}

/*
	L[
*/
void TEditor::OnKey(EventRecord *ev) {
	Boolean shift = (ev->modifiers & shiftKey) != 0;
	int data = (ev->message & charCodeMask);
	if (m_bufferCount == 256)
		BufferFlush();

	if (data >= 0x1C && data <= 0x1F)	/* Arrow */
	{
		BufferFlush();
		if (shift)
			ShiftArrowKey(data);
		else
			ArrowKey(data);
		ShowSelect();
		m_undo->SetCaretMove(this);
		m_caretMovedTick = TickCount();
	}
	else if (data == 0x08)	/* BS */
	{
		BufferFlush();
		m_undo->SetUndoBackSpace(this);
		TEKey(data);
		m_undo->SetTypePos(this, GetSelEnd());
		ShowSelect();
		m_dirty = TRUE;
	}
	else if (data == 0x09 || data == 0x0D || data == 0x20)	/* TAB CR SPASE */
	{
		BufferFlush();
		if (1 + GetTextLength() - GetSelectLength() > MAX_TEXT_LENGTH) {
			theDebug->Log("TEditor::OnKey Too Long Text");
			SysBeep(0);
		}
		else {
			if (m_undo->CanContinueUndoType(this) == FALSE)
				m_undo->SetUndo(this, UNDO_CMD_TYPE);
			TEKey(data);
			m_undo->SetTypePos(this, GetSelEnd());
			m_dirty = TRUE;
		}
		ShowSelect();
	}
	else if (data < 0x20 || data == 0x7F) {
		/*  */
	}
	else {
		m_buffer[m_bufferCount] = (char)data;
		m_bufferCount += 1;
	}
	if (GetSelectLength() == 0)
		m_shiftStartPos = GetSelStart();
	ObscureCursor();
}

void TEditor::OnUndo() {
	BufferFlush();
	if (m_undo->m_redo == FALSE)
		m_undo->OnUndo(this);
	else
		m_undo->OnRedo(this);
	m_shiftStartPos = GetSelStart();
}

void TEditor::OnCut() {
	BufferFlush();
	m_undo->SetUndo(this, UNDO_CMD_CUT);
	TECut();
	ClearCurrentScrap();
	TEToScrap();
	ShowSelect();
	m_dirty = TRUE;
	m_shiftStartPos = GetSelStart();
}

void TEditor::OnCopy() {
	BufferFlush();
	m_undo->SetUndo(this, UNDO_CMD_COPY);
	TECopy();
	ClearCurrentScrap();
	TEToScrap();
	ShowSelect();
	m_shiftStartPos = GetSelStart();
}

void TEditor::OnPaste() {
	BufferFlush();
	TScrapStuff scrapInfo;
	if (scrapInfo.GetScrapTextSize() + GetTextLength() - GetSelectLength() > MAX_TEXT_LENGTH) {
		theDebug->Log("TEditor::OnPaste");
		SysBeep(0);
		return;
	}
	m_undo->SetUndo(this, UNDO_CMD_PASTE);
	TEFromScrap();
	TEPaste();
	ShowSelect();
	m_dirty = TRUE;
	m_shiftStartPos = GetSelStart();
}

void TEditor::OnClear() {
	BufferFlush();
	m_undo->SetUndo(this, UNDO_CMD_CLEAR);
	TEDelete();
	ShowSelect();
	m_dirty = TRUE;
	m_shiftStartPos = GetSelStart();
}

void TEditor::OnSelectAll() {
	BufferFlush();
	TESetSelect(0, GetTextLength());
	ShowSelect();
	m_shiftStartPos = GetSelStart();
	m_undo->SetCaretMove(this);
}

void TEditor::OnFixDocument() {
	if (m_useTSM)
		m_tsm.FixTSMDocument();
}

short TEditor::GetPageMoveLines() {
	return m_viewLines == 0 ? 0 : m_viewLines - 1;
}

short TEditor::PageMove(int direct) {
	BufferFlush();
	short pageSize = GetPageMoveLines();
	short oldValue = m_scrollBar->GetControlValue();
	short newValue = oldValue + (direct == NEXT_PAGE ? pageSize : -pageSize);
	m_scrollBar->SetControlValue(newValue);
	newValue = m_scrollBar->GetControlValue();
	AdjustText();
	return newValue - oldValue;
}

short TEditor::NextPage() {
	return PageMove(NEXT_PAGE);
}

short TEditor::PrevPage() {
	return PageMove(PREV_PAGE);
}

Boolean TEditor::CopyTo(char *dst, long start, long length) {
	if (length == 0)
		return TRUE;
	CharsHandle h = TEGetText();
	if (h == NULL)
		return FALSE;
	TLockHandle lockHandle(h);
	char *p = *h + start;
	memcpy(dst, p, length);
	return TRUE;
}

class TEditorSelectionObject : public TAppleObject {
public:
	TEditor *m_editor;
	TEditorSelectionObject(TEditor *editor) {
		m_editor = editor;
		m_container = editor;
	}
	virtual DescType GetObjectType() {
		return 'STxt';	/* 'TEXT' */
	}
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
};

OSErr TEditorSelectionObject::OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result) {
	TAppleEvent ae(aev);
	Boolean sw = FALSE;
	if (eventID == kAEGetData) {
		CharsHandle h = m_editor->TEGetText();
		long length = m_editor->GetTextLength();
		TLockHandle lockHandle(h);
		char *p = *h;
		if (m_editor->GetSelStart() <= m_editor->GetSelEnd()) {
			p += m_editor->GetSelStart();
			length = m_editor->GetSelEnd() - m_editor->GetSelStart();
		}
		result->PutDataWithKeyword(keyAEResult, typeChar, p, length);
		return noErr;
	}
	else if (eventID == kAESetData) {
		TAEDesc textData;
		ae.AEGetParamDesc(keyAEData, typeChar, textData);
		if (ae.IsGood() == FALSE)
			return errAEParamMissed;
		Size length = textData.GetLength();
		TMemory buffer(length + 1);
		textData.GetData((char *)buffer, length);
		m_editor->InsertText((char *)buffer, length);
		//		m_editor->InsertText((char *)textData.HLock(), textData.GetLength());
		//		textData.HUnlock();
		return noErr;
	}
	return errAEEventNotHandled;
}

void TEditor::AttachTextList() {
	if (m_textList != NULL)
		DetachTextList();
	m_textList = new TStringList;
	m_textList->m_container = this;
	m_textList->CopyFromEditor(this);
}

void TEditor::DetachTextList(Boolean reflect) {
	if (m_textList == NULL)
		return;
	if (reflect) {
		m_textList->CopyToEditor(this);
		m_dirty = TRUE;
	}
	delete m_textList;
	m_textList = NULL;
}

/*
int TEditor::GetSelectText(TMemory *buffer)
{
	if (buffer == NULL)
		return 0;
	long length = GetSelectLength();
	buffer->ChangeLength(length);
	if (length > 0)
	{
		CharsHandle h = TEGetText();
		TLockHandle lockHandle(h);
		char *p = *h + GetSelStart();
		memcpy((char *)buffer, p, length);
	}
	return length;
}
*/

TAppleObject *TEditor::GetObjectProperty(DescType desiredClass, DescType keyForm, const AEDesc *keyData) {
	TAppleObject *obj = NULL;
	if (desiredClass == propLineCount) {
		TStringList textList;
		textList.CopyFromEditor(this);
		obj = new TInteger(textList.GetCount());
	}
	else if (desiredClass == propModified)
		return &m_dirty;
	else if (desiredClass == pContents) {
		AttachTextList();
		return m_textList;
	}
	else if (desiredClass == pSelection)
		obj = new TEditorSelectionObject(this);
	if (obj != NULL)
		obj->BeTemporary();
	return obj;
}

TAppleObject *TEditor::GetContainedObject(DescType desiredClass, DescType keyForm, const AEDesc *keyData) {
	if (desiredClass == classLine) {
		AttachTextList();
		return m_textList->GetContainedObject(desiredClass, keyForm, keyData);
	}
	return NULL;
}

OSErr TEditor::OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result) {
	if (token->GetObjectDesiredClass() == classLine ||
	        token->GetObjectDesiredClass() == pContents) {
		if (eventID == kAEDelete && m_textList != NULL) {
			//			TString *s = (TString *)token->GetAppleObject();
			TString *s = (TString *)token->PurgeObject();
			m_textList->RemoveDelete(s);
		}
		DetachTextList(eventID == kAESetData || eventID == kAEDelete);
	}
	return noErr;
}

OSErr TEditor::OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result) {
	TAppleEvent ae(aev);
	if (eventID == methodAdd || eventID == methodInsert) {
		if (eventID == methodAdd)
			CaretToBottom();
		TString s = ae.GetParamString();
		if (ae.IsGood() == FALSE) {
			TFSSpec spec = ae.GetParamFSSpec(keyAEFile);
			if (ae.IsGood() == FALSE)
				return errAEEventNotHandled;
			InsertFile(spec);
		}
		else
			InsertText(s);
		return noErr;
	}
	else if (eventID == methodAddLine) {
		CaretToBottom();
		InsertText(ae.GetParamString());
		InsertText("\r");
		return noErr;
	}
	else if (eventID == methodMakeLine || eventID == methodInsertLine) {
		long onNumber;
		onNumber = ae.GetParamInteger(keywordOn, typeLongInteger);
		AttachTextList();
		TString *line = new TString(ae.GetParamString());
		line->SetContainer(m_textList);
		if (onNumber >= 1 && onNumber <= m_textList->GetCount())
			m_textList->Insert(onNumber - 1, line);
		else
			m_textList->Append(line);
		TAEDesc objSpec;
		line->GetObjSpecifier(classLine, objSpec);
		DetachTextList(TRUE);
		result->PutDescWithKeyword(keyDirectObject, objSpec);
		return noErr;
	}
	return errAEEventNotHandled;
}

/*
	TEditorUndo
*/

void TEditorUndo::Reset() {
	m_target = NULL;
	m_command = UNDO_CMD_NON;
	m_redo = FALSE;
	m_selStart = 0;
	m_selEnd = 0;
	m_caretMove = TRUE;
	m_typeTop = 0;
	m_typePos = 0;
}

TEditorUndo::TEditorUndo() {
	Reset();
}

TEditorUndo::~TEditorUndo() {
}

void TEditorUndo::SetUndo(TEditor *target, int command) {
	TScrapStuff scrapInfo;
	m_target = target;
	m_command = command;
	m_redo = OFF;
	m_caretMove = FALSE;
	m_text.ChangeLength(0);
	m_redoText.ChangeLength(0);

	m_selStart = m_target->GetSelStart();
	m_selEnd = m_target->GetSelEnd();

	if (command == UNDO_CMD_CUT || command == UNDO_CMD_COPY) {
	}
	else if (command == UNDO_CMD_TYPE || command == UNDO_CMD_PASTE || command == UNDO_CMD_CLEAR) {
		long length = target->GetSelectLength();
		m_text.ChangeLength(length);
		if (m_target->CopyTo(m_text, m_selStart, length) == FALSE)
			m_text.ChangeLength(0);
		m_typeTop = m_selStart;
		m_typePos = m_typeTop;
	}
	else if (command == UNDO_CMD_MOVE) {
		m_typeTop = target->m_dragSelPoint;		/* ړ̈ʒu */
	}
	else {
		m_command = UNDO_CMD_NON;
	}
}

void TEditorUndo::OnUndo(TEditor *target) {
	TScrapStuff scrapInfo;
	if (target != m_target || m_target == NULL)
		return;
	if (m_command == UNDO_CMD_COPY) {
		scrapInfo.ZeroScrap();
		scrapInfo.PutScrapText(m_text.GetLength(), (char *)m_text);
		m_target->TESetSelect(m_selStart, m_selEnd);
	}
	else if (m_command == UNDO_CMD_CUT) {
		m_target->TESetSelect(m_selStart, m_selStart);
		m_target->TEFromScrap();
		m_target->TEPaste();
		m_target->TESetSelect(m_selStart, m_selEnd);
		scrapInfo.ZeroScrap();
		scrapInfo.PutScrapText(m_text.GetLength(), (char *)m_text);
	}
	else if (m_command == UNDO_CMD_PASTE) {
		m_target->TESetSelect(m_selStart, m_selStart + scrapInfo.GetScrapTextSize());
		m_target->TECut();
		scrapInfo.ZeroScrap();
		m_target->TEToScrap();
		m_target->TEDelete();
		m_target->TEInsert((char *)m_text, m_text.GetLength());
		m_target->TESetSelect(m_selStart, m_selEnd);
	}
	else if (m_command == UNDO_CMD_CLEAR) {
		m_target->TESetSelect(m_selStart, m_selStart);
		m_target->TEInsert((char *)m_text, m_text.GetLength());
		m_target->TESetSelect(m_selStart, m_selEnd);
	}
	else if (m_command == UNDO_CMD_TYPE) {
		long redoLength = m_typePos - m_typeTop;
		m_redoText.ChangeLength(redoLength);
		m_target->CopyTo(m_redoText, m_typeTop, redoLength);
		m_target->TESetSelect(m_typeTop, m_typePos);
		m_target->TEDelete();
		m_target->TEInsert((char *)m_text, m_text.GetLength());
		m_target->TESetSelect(m_selStart, m_selEnd);
	}
	else if (m_command == UNDO_CMD_MOVE) {
		long length = m_selEnd - m_selStart;
		m_text.ChangeLength(length);
		m_target->CopyTo(m_text, m_typeTop, length);
		m_target->TESetSelect(m_typeTop, m_typeTop + length);
		m_target->TEDelete();
		m_target->TESetSelect(m_selStart, m_selStart);
		m_target->TEInsert((char *)m_text, m_text.GetLength());
		m_target->TESetSelect(m_selStart, m_selEnd);
	}
	m_redo = TRUE;
	m_caretMove = TRUE;
	m_target->m_dirty = TRUE;
	m_target->ShowSelect();
}

void TEditorUndo::OnRedo(TEditor *target) {
	if (m_target != target)
		return;
	if (m_command != UNDO_CMD_TYPE)
		m_target->TESetSelect(m_selStart, m_selEnd);

	if (m_command == UNDO_CMD_COPY) {
		m_target->OnCopy();
	}
	else if (m_command == UNDO_CMD_CUT) {
		m_target->OnCut();
	}
	else if (m_command == UNDO_CMD_PASTE) {
		m_target->OnPaste();
	}
	else if (m_command == UNDO_CMD_CLEAR) {
		m_target->OnClear();
	}
	else if (m_command == UNDO_CMD_TYPE) {
		m_target->TESetSelect(m_typeTop, m_typeTop + m_text.GetLength());
		m_target->TEDelete();
		m_target->TEInsert((char *)m_redoText, m_redoText.GetLength());
		m_target->TESetSelect(m_typeTop + m_redoText.GetLength(), m_typeTop + m_redoText.GetLength());
	}
	else if (m_command == UNDO_CMD_MOVE) {
		m_target->OnDragMove(m_typeTop);
	}

	m_redo = FALSE;
	m_caretMove = TRUE;
	m_target->m_dirty = TRUE;
}

Boolean TEditorUndo::CanContinueUndoType(TEditor *target) {
	if (target != m_target || m_command != UNDO_CMD_TYPE || m_caretMove)
		return FALSE;
	return TRUE;
}

void TEditorUndo::SetUndoBackSpace(TEditor *target) {
	if (target->GetSelectLength() > 0) {
		SetUndo(target, UNDO_CMD_TYPE);
	}
	else if (target->GetSelStart() > 0) {
		if (CanContinueUndoType(target) == FALSE)
			SetUndo(target, UNDO_CMD_TYPE);
		if (m_typeTop == target->GetSelStart()) {
			long saveSel = target->GetSelStart();
			target->TEKey(0x1C);	/* left */
			long prevSel = target->GetSelStart();
			long length = saveSel - prevSel;
			char tmp[16];
			target->CopyTo(tmp, prevSel, length);
			target->TESetSelect(saveSel, saveSel);
			TMemory buffer(m_text.GetLength());
			memcpy((char *)buffer, (char *)m_text, m_text.GetLength());
			m_text.ChangeLength(m_text.GetLength() + length);
			memcpy((char *)m_text, tmp, length);
			memcpy((char *)m_text + length, (char *)buffer, buffer.GetLength());
			m_typeTop = prevSel;
		}
	}
}

void TEditorUndo::SetCaretMove(TEditor *target, Boolean sw) {
	if (m_target == target)
		m_caretMove = sw;
}

void TEditorUndo::SetTypePos(TEditor *target, long typePos) {
	if (m_target == target)
		m_typePos = typePos;
}

/*
	CTextService
*/

pascal void PreUpdateProcForTSMTE(TEHandle te, long refCon);
pascal void PostUpdateProcForTSMTE(TEHandle te, long fixLen, long inputAreaStart, long inputAreaEnd, long pinStart, long pinEnd, long refCon);

pascal void PreUpdateProcForTSMTE(TEHandle te, long refCon) {
	TEditor *editor = (TEditor *)refCon;
	if (editor->m_undo->CanContinueUndoType(editor) == FALSE)
		editor->m_undo->SetUndo(editor, UNDO_CMD_TYPE);
}

pascal void PostUpdateProcForTSMTE(TEHandle te, long fixLen, long inputAreaStart, long inputAreaEnd, long pinStart, long pinEnd, long refCon) {
	TEditor *editor = (TEditor *)refCon;
	if (fixLen > 0) {
		editor->m_dirty = TRUE;
		ObscureCursor();
		editor->ShowSelect();
		if (editor->m_undo->CanContinueUndoType(editor))
			editor->m_undo->SetTypePos(editor, editor->GetSelEnd());
		else
			editor->m_undo->SetUndo(editor, UNDO_CMD_NON);
		if (editor->GetSelectLength() == 0)
			editor->m_shiftStartPos = editor->GetSelStart();
	}
	if (editor->GetTextLength() > MAX_TEXT_LENGTH - 100) {
		theDebug->Log("PostUpdateProcForTSMTE");
		for (int i = 0; i < 5; i++)
			SysBeep(0);
	}
	if (editor->GetSelectLength() == 0)
		editor->m_shiftStartPos = editor->GetSelStart();
}

TTSMTE::TTSMTE() {
	m_docID = NULL;
	m_tsmte = NULL;
}

TTSMTE::~TTSMTE() {
	if (m_docID != NULL)
		DeleteTSMDocument();
}

OSErr TTSMTE::NewTSMDocument(TEditor *editor) {
	InterfaceTypeList itList;
	itList[0] = kTSMTEInterfaceType;
	OSErr err = NewTSMDocument(1, itList, (long)&m_tsmte);
	if (err != noErr || m_tsmte == NULL)
		m_docID = NULL;
	(**m_tsmte).textH = (TEHandle)*editor;
	m_uppPreUpdate.SetUPP(PreUpdateProcForTSMTE);
	m_uppPostUpdate.SetUPP(PostUpdateProcForTSMTE);
	(**m_tsmte).preUpdateProc = (TSMTEPreUpdateUPP)m_uppPreUpdate.GetUPP();
	(**m_tsmte).postUpdateProc = (TSMTEPostUpdateUPP)m_uppPostUpdate.GetUPP();
	/* TSMTE1.0͎XN[LɂƂȂƂȓ̂ŎgȂ *//* 1998.02.03 Takeshi Yoneki */
	(**m_tsmte).updateFlag = theSystem->tsmteVersion <= gestaltTSMTE1 ? 0 : kTSMTEAutoScroll;
	(**m_tsmte).refCon = (long)editor;
	return err;
}

#endif	// CONFIG_USE_CEDITOR
