/*
	TEditor.h
	GfB^֘A
	XN[o[NX
	A_[o[NX
	TSMTENX
	GfB^NX
	GfB^UndoNX
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.03.02	1.0			Takeshi Yoneki
*/

#ifndef	_CEDITOR_H_
#define	_CEDITOR_H_

class TUnderBar;
/*
	TUnderBar
	A_[o[NX
*/
class TUnderBar : public TControlBase {
protected:
	TRect m_bgRect;
	TRect m_boxRect;
	TRect m_panelRect;
public:
	/* TControlBasẻz֐ */
	void OnUpdate();
	short OnChangeSize(short dmy);
};

#ifdef CONFIG_USE_CEDITOR

#define	MAX_TEXT_LENGTH			32700
#define	NEXT_PAGE				0
#define	PREV_PAGE				1

#define	UNDO_CMD_NON			0
#define	UNDO_CMD_TYPE			1
#define	UNDO_CMD_CUT			2
#define	UNDO_CMD_COPY			3
#define	UNDO_CMD_PASTE			4
#define	UNDO_CMD_CLEAR			5
#define	UNDO_CMD_MOVE			6

#define SCRLLBAR_VERTICAL		TRUE
#define SCRLLBAR_HORIZONTAL		FALSE

class TScrollBar;
class TTSMTE;
class TEditor;
class TEditorUndo;

/*
	TScrollBar
	XN[o[NX
*/
class TScrollBar : public TControl, public TControlBase {
protected:
	TRect m_boxRect;
	TRect m_bgRect;
	CUPP_ControlAction m_uppControlAction;
public:
	Boolean m_isVertical;
	TScrollBar();
	void NewScrollBar();
	TRect GetRect() {
		return m_bgRect;
	}
	virtual void HandleScroll(short part);
	/* TControlBasẻz֐ */
	virtual void OnContent(EventRecord *ev);
	virtual void OnUpdate();
	virtual Boolean IsInside(TPoint mousePt);
	virtual void OnActivate(Boolean act);
	virtual short OnChangeSize(short top);
	/**/
	friend pascal void TScrollBar_HandleScroll(ControlRef ctrl, short part);
};

class TEditScrollBar : public TScrollBar {
protected:
	TEditor *m_editor;
public:
	virtual void HandleScroll(short part);
	void SetRelateToEditor(TEditor *editor);
};

/*
	TTSMTE
	TSMTENX
*/
class TTSMTE {
protected:
	TSMDocumentID	m_docID;
	TSMTERecHandle	m_tsmte;
	CUPP_TSMTEPreUpdate m_uppPreUpdate;
	CUPP_TSMTEPostUpdate m_uppPostUpdate;
public:
	TTSMTE();
	~TTSMTE();
	OSErr NewTSMDocument(TEditor *editor);
	OSErr NewTSMDocument(short numOfInterface, InterfaceTypeList supportedInterfaceTypes, long refcon) {
		return ::NewTSMDocument(numOfInterface, supportedInterfaceTypes, &m_docID, refcon);
	}
	OSErr DeleteTSMDocument() {
		return ::DeleteTSMDocument(m_docID);
	}
	OSErr ActivateTSMDocument(Boolean act) {
		return act ? ActivateTSMDocument() : DeactivateTSMDocument();
	}
	OSErr ActivateTSMDocument() {
		return ::ActivateTSMDocument(m_docID);
	}
	OSErr DeactivateTSMDocument() {
		return ::DeactivateTSMDocument(m_docID);
	}
	OSErr FixTSMDocument() {
		return ::FixTSMDocument(m_docID);
	}
	OSErr UseInputWindow(Boolean useWindow) {
		return ::UseInputWindow(m_docID, useWindow);
	}
};

/*
	TEditor
	GfB^NX
*/
class TEditor : public TTextEdit, public TControlBase, public TAppleObject {
public:
	TRect m_boxRect;
	TRect m_bgRect;
	int m_viewLines;
	int m_lineSpacing;
	TEditScrollBar *m_scrollBar;
	char m_buffer[256];
	long m_bufferCount;
	TBoolean m_dirty;
	long m_caretMovedTick;
	long m_shiftStartPos;
	Boolean m_useTSM;
	TTSMTE m_tsm;
	TStringList *m_textList;	/* AppleScriptŎgp */
	CUPP_TEClickLoop m_uppTEClickLoop;
	Boolean m_dragCanAccept;	/* D&D */
	Boolean m_dragInContent;
	int m_dragSelPoint;
	TEditorUndo *m_undo;
	TEditor();
	~TEditor();
	void NewEditor(TEditorUndo *undo, Boolean useTSM = TRUE, int lineSpacing = 0);
	void SetRelateToScrollBar(TEditScrollBar *scrollBar);
	void ResetRects();
	void AdjustText();
	long GetPosMustShow();
	void Show();
	void ShowSelect();
	void AdjustScrollBar(Boolean save = TRUE);
	void SetText(char *data, long count);
	void SetText(TString s) {
		SetText(s, s.GetLength());
	}
	void CaretToTop();
	void CaretToBottom();
	void CaretOnLeft();
	void InsertText(char *text, long length);
	void InsertText(TString s) {
		InsertText(s, s.GetLength());
	}
	void InsertFile(TFilePath& filePath);
	void InsertFile(TFSSpec& spec) {
		TFilePath filePath(spec);
		InsertFile(filePath);
	}
	void BufferFlush();
	void ArrowKey(int data);
	void ShiftArrowKey(int data);
	short GetPageMoveLines();
	short PageMove(int direct);
	short NextPage();
	short PrevPage();
	Boolean CopyTo(char *dst, long start, long length);
	void AttachTextList();
	void DetachTextList(Boolean reflect = FALSE);
	/* TControlBasẻz֐ */
	void OnContent(EventRecord *ev);
	void OnUpdate();
	void OnActivate(Boolean act);
	Boolean IsInside(TPoint mousePt);
	virtual TPoint OnChangeSize(TPoint pt);
	void OnTask();
	void OnMouseCursor(TPoint mousePt);
	/* D&D */
	virtual OSErr DragReceiveHandler(WindowPtr wp, void *refCon, DragReference dragRef);
	virtual OSErr DragTrackingHandler(DragTrackingMessage message, WindowPtr wp, void *refCon, DragReference dragRef);
	void OnDragMove(long moveTo);
	/* CxgΉ */
	void OnKey(EventRecord *ev);
	void OnUndo();
	void OnCut();
	void OnCopy();
	void OnPaste();
	void OnClear();
	void OnSelectAll();
	void OnFixDocument();
	/**/
	friend pascal Boolean TEditor_AutoScroll(TEPtr pTE);
	/* for AppleScript */
	virtual DescType GetObjectType() {
		return classTextEditor;
	}
	virtual TAppleObject *GetObjectProperty(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	virtual TAppleObject *GetContainedObject(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	virtual OSErr OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result);
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual OSErr GetObjSpecifier(DescType desiredClass, AEDesc *objSpec) {
		return ThroughObjSpecifier(desiredClass, objSpec);
	}
};

/*
	TEditorUndo
	GfB^UndoNX
*/
class TEditorUndo {
public:
	TEditor *m_target;
	int m_command;
	Boolean m_redo;
	long m_selStart;
	long m_selEnd;
	TMemory m_text;
	Boolean m_caretMove;
	long m_typeTop;
	long m_typePos;
	TMemory m_redoText;
	TEditorUndo();
	~TEditorUndo();
	void SetUndo(TEditor *target, int command);
	void OnUndo(TEditor *target);
	void OnRedo(TEditor *target);
	void SetCaretMove(TEditor *target, Boolean sw = TRUE);
	void SetTypePos(TEditor *target, long typePos);
	Boolean CanContinueUndoType(TEditor *target);
	void Reset();
	void SetUndoBackSpace(TEditor *target);
};

#endif	// CONFIG_USE_CEDITOR

#endif	/* _CEDITOR_H_ */
