/*
	CFile.h
	fBNgNX
	t@CpXNX
	[LOfBNgJ^ÕNX
	t@CXybNNX
	t@CNX
	tNX
	\[Xt@CNX
	\[XNX
	nhbNNX
	Wt@CpbP[WNX
	fBXNƃfBNgۑNX
	fobONX
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.02.12	1.0			Takeshi Yoneki
	TDirectory
		 : 1996.04.13	1.1			Takeshi Yoneki
*/

#ifndef	_CFILE_H_
#define	_CFILE_H_

class TDirectory;
class TFilePath;
class TFinderInfo;
class TWorkDir;
class TFSSpec;
class TFileIO;
class TDateTime;
class TDate;
class TTime;
class TResourceFile;
class TResource;
class TLockHandle;
class TStandardFile;
class TSaveDiskDir;
class TDebug;

/* XNvgΉ̃fXNv^^Cv */
enum {
    classDate = 'Date',
    classTime = 'Time',

    typeDateTime = 'DtTm'
};

#define	FILEIO_OPEN_RESOURCE		(TRUE)
#define	FILEIO_OPEN_DATA			(FALSE)

/*
	TDirectory
	fBNgNX
*/
class TDirectory : public TAppleObject {
public:
	short m_volume;
	long m_dirID;
	OSErr m_error;
	TDirectory();
	TDirectory(const TDirectory& dir);
	TDirectory(const TDirectory& dir, const TCFString dirName);
	TDirectory(const TString volumeName, long dirID);
	TDirectory(short volume, long dirID);
	TDirectory(short volume, long dirID, TCFString dirName);
	TDirectory(const TFSSpec& spec, Boolean useName = FALSE);
	TDirectory(const TFSRef& fsRef);
	TDirectory(const TCFString& fullPath);
	void operator=(const TDirectory& dir);
	void operator=(const TFSSpec& spec);
	void operator=(const TFSRef& fsRef);
	void operator=(const TCFString& fullPath);
	Boolean operator==(const TDirectory& dir) {
		return m_dirID == dir.m_dirID && m_volume == dir.m_volume;
	}
	Boolean operator!=(const TDirectory& dir) {
		return !operator==(dir);
	}
	TDirectory *GetNext() {
		return (TDirectory *)TBase::GetNext();
	}
	Boolean IsGood() {
		return m_error == noErr;
	}
	Boolean IsNull() {
		return m_volume == 0 && m_dirID == 0;
	}
	short GetCatFileNum();
	TDirectory GetParent();
	Boolean IsRoot() {
		return m_dirID == 2;
	}
	Boolean GetPermissions(UInt32 *permissions);	/* permissions[4] */
	Boolean GetCatInfoByName(TCFString name, CInfoPBRec *pcb = NULL);
	//	Boolean GetCatInfoByLongName(CUniString name, FSCatalogInfo *catInfo = NULL);
	TCFString GetCatInfoByDirIndex(short dirIndex, CInfoPBRec *cb);
	TCFString GetCatInfoByDirIndex(short dirIndex, long *attrib, long *fFlags, long *dirID);
	TCFString GetFInfoByDirIndex(short dirIndex, FInfo *info);
	OSErr GetFInfoByName(TCFString fileName, FInfo *info);
	OSErr FlushVol(TString volName = "") {
		return ::FlushVol(volName.IsEmpty() ? NULL : (StringPtr)(ConstStr255Param)volName, m_volume);
	}
	OSErr DeleteFile(TCFString fileName);
	OSErr RenameFile(TCFString oldName, TCFString newName);
	// 2006.01.27 TCFStringx[Xɉׂ
	OSErr RenameDirectory(TCFString newName);
	TDirectory CreateDir(TCFString dirName);
	void BeEmptyDir();
	// pXΉ
	TString PathToDirectory(TString path, TDirectory parent);
	TString GetVolumeName();
	TString StripPath(TString path);
	TString StripPathVol(TString path);
	Boolean IsVolumeNameOnly(TString path);
	//
	TCFString GetFullPath();
	TCFString GetLastToken();
	TCFString GetDirName() {
		return GetLastToken();
	}
	Boolean IsReal() const;
	void GetVol() {
		m_error = ::HGetVol(NULL, &m_volume, &m_dirID);
	}
	TString GetVInfo(short drvNum);
	Boolean HasSubDirectory(Boolean ignoreInvisible = TRUE);
	/* for AppleScript */
	virtual DescType GetObjectType() {
		return classDirectory/*typeFSS*/;
	}
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual Boolean CompareObjects(DescType oper, TAppleObject *obj);
private:
	void Init();
};

class TFilePath/* : public TAppleObject*/
{
public:
	TDirectory m_dir;
	//TString m_fileName;
	TCFString m_fileName;
	OSErr m_error;
	TFilePath();
	TFilePath(const TFilePath& filePath);
	TFilePath(const TCFString fileName, const TDirectory& dir);
	TFilePath(const TFSSpec& spec);
	void operator=(const TFilePath& filePath);
	void operator=(const TFSSpec& spec);
	Boolean operator==(const TFilePath& filePath);
	Boolean operator!=(const TFilePath& filePath) {
		return !operator==(filePath);
	}
	Boolean IsGood() {
		return m_error == noErr;
	}
	OSErr GetFInfo(FInfo *info) {
		return m_error = m_dir.GetFInfoByName(m_fileName, info);
	}
	OSErr DeleteFile() {
		return m_dir.DeleteFile(m_fileName);
	}
	OSErr RenameFile(TCFString newName) {
		return m_dir.RenameFile(m_fileName, newName);
	}
	//OSErr RenameFileLongName(const CUniString &newLongName);
	TFinderInfo GetFinderInfo();
	OSErr SetFinderInfo(TFinderInfo info);
	Boolean GetPermissions(UInt32 *permissions);	/* permissions[4] */
	Boolean SetPermissions(UInt32 *permissions);
	//CUniString GetLongName();
	Boolean IsLocked();
	TCFString GetFullPath();
	TString GetRealShortName() const;
	Boolean IsReal() const;
private:
	void Init();
};

/*
	TFinderInfo
*/

class TFinderInfo {
public:
	FInfo m_info;
	unsigned long m_ioFlCrDat;
	unsigned long m_ioFlMdDat;
	unsigned long m_ioFlLgLen;
	unsigned long m_ioFlRLgLen;
	int m_ioFlAttrib;
	TFinderInfo();
};

/*
	TFSSpec
	t@CXybNNX
*/
class TFSSpec : public TAppleObject {
public:
	FSSpec m_spec;
	//	FSRef m_ref;
	OSErr m_error;
	TFSSpec();
	TFSSpec(const TFSSpec& spec);
	TFSSpec(const FSSpec& spec);
	TFSSpec(const TDirectory& dir);
	TFSSpec(const TDirectory& dir, const TString &shortName);
	TFSSpec(const TFilePath& filePath);
	TFSSpec(short vRefNum, long dirID, ConstStr255Param shortName);
	TFSSpec(const TFSRef& fsRef);
	operator const FSSpec *() const;
	void operator=(const TFSSpec& spec);
	void operator=(const FSSpec& spec);
	void operator=(const TDirectory& dir);
	void operator=(const TFilePath& filePath);
	void operator=(const TFSRef &fsRef);
	const FSSpec *GetFSSpecPtr() const;
	Boolean operator==(TFSSpec& spec);
	Boolean IsGood();
	short GetVRefNum() const;
	long GetParID() const;
	TString GetName() const;
	//	CUniString GetLongName();
	OSErr FSMakeFSSpec(short vRefNum, long dirID, ConstStr255Param fileName);
	OSErr FSpGetFInfo(FInfo *fndrInfo);
	TDirectory GetDirectory() const;
	Boolean FindApplication(OSType creator);
	/* for AppleScript */
	virtual DescType GetObjectType() {
		return classFSSpec/*typeFSS*/;		/* 'fss ' */
	}
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual Boolean CompareObjects(DescType oper, TAppleObject *obj);
private:
	Boolean FindApplicationOneVolume(short volume, OSType creator);
	void Init();
};

class TCatInfo {
public:
	CInfoPBRec m_cb;
	Str63 m_fName;
	FSCatalogInfo m_ci;
	HFSUniStr255 m_longName;
	OSErr m_error;
	TCatInfo();
	void Init();
	Boolean GetCatInfoByShortName(TString shortName, TDirectory dir);
};

/*
	TFileIO
	t@CNX
*/
class TFileIO {
public:
	short m_fRefNum;
	OSErr m_error;
	TDirectory m_dir;
	Boolean m_noFlush;
	Boolean m_needFlush;
	/* obt@tI/O */
	int m_openMode;
#define	CFILEIO_OPEN_MODE_NORMAL		0
#define	CFILEIO_OPEN_MODE_READ			1
#define	CFILEIO_OPEN_MODE_WRITE			2

	Byte *m_buffer;
	long m_fileSize;
	long m_bufferSize;
	long m_filePos;
	long m_pos;
	long m_bfTop;
	long m_readSize;
	Boolean m_readEnd;
	Boolean m_noCache;
	/**/
#define	CFILEIO_NO_FLUSH				TRUE
#define	CFILEIO_FLUSH_IF_WRITE			FALSE

	TFileIO(Boolean noFlush = CFILEIO_FLUSH_IF_WRITE);
	TFileIO(TFilePath &filePath, OSType creator = '    ', OSType fileType = '    ', Boolean noFlush = CFILEIO_FLUSH_IF_WRITE);
	~TFileIO();
	Boolean IsGood() {
		return m_error == noErr;
	}
	OSErr OpenOrCreate(TFilePath &filePath, OSType creator = '    ', OSType fileType = '    ', Boolean noFlush = CFILEIO_FLUSH_IF_WRITE);
	OSErr Create(TFilePath &filePath, OSType creator = '    ', OSType fileType = '    ', Boolean noFlush = CFILEIO_FLUSH_IF_WRITE);
	OSErr Open(TFilePath &filePath, SInt8 permssn = 0, Boolean rf = FALSE, Boolean noCache = FALSE);
	void Close();
	long Read(long count, void *buffPtr);
	long Write(long count, void *buffPtr);
	long Write(TString s) {
		return Write(s.GetLength(), (char *)s);
	}
	long GetFileSize() {
		return GetEOF();
	}
	OSErr SetEOF(long logEOF);
	OSErr BeEmpty() {
		return SetEOF(0);
	}
	OSErr GetFPos(long *filePos) {
		return m_error = ::GetFPos(m_fRefNum, filePos);
	}
	OSErr SetFPos(short posMode, long posOff) {
		return m_error = ::SetFPos(m_fRefNum, posMode, posOff);
	}
protected:
	void Init();
	OSErr HOpen(TFilePath &filePath, SInt8 permssn, Boolean rf, Boolean noCache);
	OSErr HCreate(TFilePath &filePath, OSType creator, OSType fileType);
	//	OSErr FSOpen(TFilePath &filePath, SInt8 permssn, Boolean rf, Boolean noCache);
	OSErr FSCreate(TFilePath &filePath, OSType creator, OSType fileType);
	OSErr FSClose();
	OSErr FSRead(long *count, void *buffPtr);
	OSErr FSWrite(long *count, void *buffPtr);
	OSErr GetEOF(long *logEOF);
	long GetEOF();
};

/* obt@tI/O */

class TFileReader : public TFileIO {
public:
	TFileReader(Boolean noFlush = CFILEIO_FLUSH_IF_WRITE);
	TFileReader(TFilePath &filePath, Boolean rf = FALSE, long bufferSize = 1024L * 16L);
	OSErr OpenForGet(TFilePath &filePath, Boolean rf = FALSE, long bufferSize = 1024L * 16L);
	int GetC();
	void GetP(void *p, long length);
	long Seek(short posMode, long posOff);	/* get mode only */
	long Tell();	/* get mode only */
	long GetFileSize() {
		return m_fileSize;
	}
};

class TFileWriter : public TFileIO {
public:
	TFileWriter(Boolean noFlush = CFILEIO_FLUSH_IF_WRITE);
	TFileWriter(TFilePath &filePath, OSType creator, OSType fileType, Boolean rf = FALSE, long bufferSize = 1024L * 16L, Boolean noFlush = CFILEIO_FLUSH_IF_WRITE);
	OSErr OpenForPut(TFilePath &filePath, OSType creator, OSType fileType, Boolean rf = FALSE, long bufferSize = 1024L * 16L);
	void PutC(int data);
	void PutP(void *p, long length);
};

/*
	TDateTime
	tNX
*/
class TDateTime : public DateTimeRec, public TAppleObject {
public:
	TDateTime() {
		SecondsToDate(GetDateTime());
	}
	TDateTime(unsigned long secs) {
		SecondsToDate(secs);
	}
	TDateTime(DateTimeRec& date) {
		*(DateTimeRec *)this = date;
	}
	operator unsigned long()	/* unsigned longւ̃LXg */
	{
		return DateToSeconds();
	}
	operator DateTimeRec()	/* DateTimeւ̃LXg */
	{
		return *(DateTimeRec *)this;
	}
	void operator=(unsigned long secs)	/* unsigned long̃Rs[ */
	{
		SecondsToDate(secs);
	}
	void operator=(DateTimeRec& date)	/* DateTimeRec̃Rs[ */
	{
		*(DateTimeRec *)this = date;
	}
	void operator=(TDateTime& cdate)	/* TDateTimẽRs[ */
	{
		*(DateTimeRec *)this = *(DateTimeRec *)&cdate;
	}
	Boolean operator==(unsigned long secs) {
		return DateToSeconds() == secs;
	}
	Boolean operator!=(unsigned long secs) {
		return !operator==(secs);
	}
	Boolean operator==(DateTimeRec& date) {
		TDateTime d(date);
		return DateToSeconds() == d.DateToSeconds();
	}
	Boolean operator!=(DateTimeRec& date) {
		return !operator==(date);
	}
	Boolean operator==(TDateTime& cdate) {
		return DateToSeconds() == cdate.DateToSeconds();
	}
	Boolean operator!=(TDateTime& cdate) {
		return !operator==(cdate);
	}
	unsigned long GetDateTime();
	TString IUDateString(DateForm longFlag);
	TString IUTimeString(Boolean wantSeconds);
	unsigned long DateToSeconds();
	void SecondsToDate(unsigned long secs) {
		::SecondsToDate(secs, this);
	}
	/* for AppleScropt */
	virtual DescType GetObjectType() {
		return typeDateTime;		/* Localɐ錾 */
	}
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
};

class TDate : public TDateTime {
public:
	TDate(DateTimeRec& date, TAppleObject *container) {
		*(DateTimeRec *)this = date;
		m_container = container;
	}
	virtual DescType GetObjectType() {
		return classDate;
	}
};

class TTime : public TDateTime {
public:
	TTime(DateTimeRec& date, TAppleObject *container) {
		*(DateTimeRec *)this = date;
		m_container = container;
	}
	virtual DescType GetObjectType() {
		return classTime;
	}
};

/*
	TResourceFile
	\[Xt@CNX
	\[Xt@C͕ɊJȂ̂ŋC
*/
class TResourceFile {
public:
	TFilePath m_filePath;
	short m_fRefNum;
	TResourceFile(TFilePath filePath, Boolean create = FALSE);
	~TResourceFile();
	void OpenResFile();
	void CreateResFile();
	void CloseResFile();
	Boolean IsGood() {
		return m_fRefNum != -1;
	}
private:
	void Init();
};

/*
	TResource
	\[XNX
*/
class TResource {
public:
	Handle m_h;
	Boolean m_detached;
	long m_size;
	TResource();
	TResource(OSType sig, short id);	/* w肵\[X̓ǂݍ */
	TResource(long sz);	/* VK\[X */
	~TResource();
	void Get1Resource(OSType sig, short id);
	void DetachResource();
	void AddResource(OSType sig, short id, ConstStr255Param name);
	void ChangedResource() {
		::ChangedResource(m_h);
	}
	void *HLock();
	void HUnlock();
	void NewHandle(long sz);
	void DisposeHandle();
	Boolean IsNull() {
		return m_h == NULL;
	}
	operator Handle() {
		return m_h;
	}
	long GetResourceSizeOnDisk() {
		return ::GetResourceSizeOnDisk(m_h);
	}
	void SetHandleSize(long sz);
	long GetHandleSize() {
		return ::GetHandleSize(m_h);
	}
};

/*
	TLockHandle
	nhbNNX
	֐̐擪TLockHandle lockHandle(h);ƋLqƂ̊֐̒ł
	nhh̓bNB
	֐IɃAbNB
*/
class TLockHandle {
public:
	Handle m_h;
	TLockHandle(Handle h);
	~TLockHandle();
	void *GetPtr();
};

#pragma options align=mac68k

typedef struct {
	short fontSize;
	char fontName[32];
	short spaceWidth;
	short tabSize;
	Rect zoomOutRect;
	Rect zoomInRect;
	unsigned long date;
	long selStart;
	long selEnd;
	long viewCharPos;
	char autoIndent;
	char showInvisibles;
}
MPSR1005Rec;

#pragma options align=reset

class CMPSR1005 : public TResource {
public:
	CMPSR1005(OSType sig, short id)
			: TResource(sig, id) {
	}
	void SetSelStart(long selStart) {
		TLockHandle lockHandle(m_h);
		(**(MPSR1005Rec **)m_h).selStart = selStart;
	}
	void SetSelEnd(long selEnd) {
		TLockHandle lockHandle(m_h);
		(**(MPSR1005Rec **)m_h).selEnd = selEnd;
	}
	void SetViewCharPos(long viewCharPos) {
		TLockHandle lockHandle(m_h);
		(**(MPSR1005Rec **)m_h).viewCharPos = viewCharPos;
	}
};

/*
*/

class TStandardFileFilterItemInfo {
public:
	Boolean m_isFolder;
	Boolean m_visible;
	OSType m_fdCreator;
	OSType m_fdType;
	TDirectory m_dir;
	//	TString m_name;
	TCFString m_name;
	TStandardFileFilterItemInfo() :
	m_isFolder(FALSE), m_visible(TRUE), m_fdCreator('    '), m_fdType('    ') {
	}
};

class TStandardFileReply : public TBase {
public:
	OSType m_fType;
	OSType m_fCreator;
	TDirectory m_dir;
	//	TString m_fName;
	TCFString m_fName;
	//CUniString m_fLongName;
	Boolean m_isFolder;
	Boolean m_isVolume;
	TStandardFileReply();
	TStandardFileReply *GetNext() {
		return (TStandardFileReply *)TBase::GetNext();
	}
};

class TStandardFileReplyList : public TListBase {
public:
	TStandardFileReply *GetTop() {
		return (TStandardFileReply *)TListBase::GetTop();
	}
	TStandardFileReply *GetNth(int n) {
		return (TStandardFileReply *)TListBase::GetNth(n);
	}
	void AppendFile(TFSSpec &spec);
	void AppendFile(OSType fType, TDirectory dir, TCFString fName, Boolean isFolder = FALSE, Boolean isVolume = FALSE);
};

/*
	TStandardFile
	Wt@CpbP[WNX
*/
class TStandardFile : public TStandardFileReplyList {
public:
	/* param */
	TDirectory m_firstDir;
	Boolean m_selectFolder;
	/**/
	NavReplyRecord m_replyNav;
	CUPP_NavObjectFilter m_uppFileFilterNav;
	CUPP_NavEvent m_uppEventNav;
	Boolean m_good;
	OSType m_fType;
	OSType m_fCreator;
	Boolean m_firstCall;
	int m_dlgID;
	TString m_title;
	Boolean m_multi;
	TStandardFile();
	TStandardFile(TDirectory dir);
	~TStandardFile();
	/* virtual function */
	virtual Boolean Filter(TStandardFileFilterItemInfo& info);	/* TRUEŕ\ */
	virtual void Update(int message);
	virtual short DlgHook(short item, DialogPtr dlg);
	virtual Boolean ModalFilter(DialogPtr dlg, EventRecord *ev, short *itemHit);
	/**/
	void GetFile(TString prompt = "", Boolean multi = FALSE);
	void PutFile(TString prompt, TString orgName);
	Boolean IsGood() {
		return m_good;
	}
	OSType GetFType(int n = 0);
	TDirectory GetDirectory(int n = 0);
	TCFString GetFName(int n = 0);
	//	CUniString GetFLongName(int n = 0);
	TFilePath GetFilePath(int n = 0);
	Boolean IsFolder(int n = 0);
	Boolean IsVolume(int n = 0);
	TStandardFileReply *GetNth(int n) {
		return (TStandardFileReply *)TListBase::GetNth(n);
	}
private:
	void Init();
	void GetFileNav1(TString prompt = "", Boolean multi = FALSE);
	void GetFileNav2(TString prompt = "", Boolean multi = FALSE);
	void PutFileNav1(TString prompt, TString orgName);
	void PutFileNav2(TString prompt, TString orgName);
};

class TStandardFileDirectory : public TStandardFile {
public:
	TStandardFileDirectory()
			: TStandardFile() {
		Init();
	}
	TStandardFileDirectory(TDirectory dir)
			: TStandardFile(dir) {
		Init();
	}
	/* TStandardFile's virtual function */
	virtual Boolean Filter(TStandardFileFilterItemInfo& info);	/* TRUEŕ\ */
	//	virtual Boolean Filter(CInfoPBPtr pb);
	virtual short DlgHook(short item, DialogPtr dlg);
	virtual Boolean ModalFilter(DialogPtr dlg, EventRecord *ev, short *itemHit);
private:
	TString m_savedDirName;
	void Init();
};

class CSaveFinderInfo {
public:
	Str63 m_name;
	short m_volume;
	long m_dirID;
	FInfo m_info;
	unsigned long m_ioFlCrDat;
	unsigned long m_ioFlMdDat;
	OSErr m_error;
	CSaveFinderInfo(TFilePath& filePath);
	~CSaveFinderInfo();
};

/*
	TDebug
	fobONX
	Ot@CɃbZ[WL^
*/
class TDebug {
public:
	TFilePath m_filePath;
	Boolean m_create;
	TDebug(TFilePath& filePath);
	void Log(TString s);
	void LogAlertExit(TString s);
};

extern "C" void DebugLog(char *s);

#endif
