#ifndef	_CKANJI_H_
#define	_CKANJI_H_

/*
	
	Ten Tool Class Library
	Copyright (C) 1996-1998 Takeshi Yoneki, OSTRACISM CO.
*/

#define CHAR_KIND_CTRL			0
#define CHAR_KIND_ANK			1
#define CHAR_KIND_KANA			2
#define CHAR_KIND_KANJI			3
#define CHAR_KIND_MIS			4
#define CHAR_KIND_EXT			5
#define	JIS7_STATUS_ASCII		1
#define	JIS7_STATUS_0201L		2
#define	JIS7_STATUS_0201K		3
#define	JIS7_STATUS_KANJI		4
#define	JIS7_STATUS_ESC			0x1B
#define	BOM_LITTLE				0xFFFE
#define	BOM_BIG					0xFEFF

class TUnicodeTextEncodingInfo {
public:
	TextEncoding m_textEncoding;
	TextEncoding m_unicodeEncoding;
	TextEncoding m_utf8Encoding;
	UnicodeToTextInfo m_unicodeToTextInfo;
	TextToUnicodeInfo m_textToUnicodeInfo;
	UnicodeToTextInfo m_utf8ToTextInfo;
	TextToUnicodeInfo m_textToUTF8Info;
	char m_charByteData[256];
	OSStatus m_error;
	TUnicodeTextEncodingInfo();
	TUnicodeTextEncodingInfo(TextEncodingBase encodingBase);
	~TUnicodeTextEncodingInfo();
	void Init();
	OSStatus Create(TextEncodingBase encodingBase = ::IntlScript());
	void Dispose();
	OSStatus ConvertFromUnicodeToText(ByteCount iUnicodeLen, const UniChar *iUnicodeStr, ByteCount iOutputBufLen, ByteCount *oOutputLen, LogicalAddress oOutputStr);
	OSStatus ConvertFromTextToUnicode(ByteCount iSourceLen, ConstLogicalAddress iSourceStr, ByteCount iOutputBufLen, ByteCount *oUnicodeLen, UniChar oUnicodeStr[]);
	OSStatus ConvertFromUTF8ToText(ByteCount iUnicodeLen, const UniChar iUnicodeStr[], ByteCount iOutputBufLen, ByteCount *oOutputLen, LogicalAddress oOutputStr);
	OSStatus ConvertFromTextToUTF8(ByteCount iSourceLen, ConstLogicalAddress iSourceStr, ByteCount iOutputBufLen, ByteCount *oUnicodeLen, UniChar oUnicodeStr[]);
	TString HFSUniStrToText(HFSUniStr255 *uniText);
	int UnicodeToTextChar(UInt16 bom, char *srcPtr, char *dstPtr, int *srcBytes, int *dstBytes);
	void TextToUnicodeChar(UInt16 bom, char *srcPtr, char *dstPtr, int *srcBytes, int *dstBytes);
	TString UnicodeToText(char *uniText, int bytes);
	void TextToUnicode(UInt16 bom, TMemory *outUni, const TString &inStr);
	TString UTF8ToText(TString &inStr);
	TString TextToUTF8(TString &inStr);
	int GetCharSize(unsigned char ch) {
		return m_charByteData[ch];
	}
};

void Kanji_ToJIS7(char *srcPtr, char *dstPtr);
void Kanji_ToEUC(char *srcPtr, char *dstPtr);
void Kanji_ToSJIS(char *srcPtr, char *dstPtr);
int Kanji_EUCToSJISChar(char *srcPtr, char *dstPtr, int *srcBytes, int *dstBytes);
int Kanji_JIS7ToSJISChar(char *srcPtr, char *dstPtr,int *srcBytes, int *dstBytes, int *status);
int Kanji_SJISToSJISChar(char *srcPtr, char *dstPtr, int *srcBytes, int *dstBytes);
int Kanji_ASCIIToASCIIChar(char *srcPtr, char *dstPtr, int *srcBytes, int *dstBytes);
//int Kanji_UNICODEToSJISChar(TUnicodeTextEncodingInfo &encodeInfo, UInt16 bom, char *srcPtr, char *dstPtr, int *srcBytes, int *dstBytes);
int Kanji_SJISToUNICODEChar(UInt16 bom, char *srcPtr, char *dstPtr, int *srcBytes, int *dstBytes);
UInt16 MakeBOM(char *p);

#endif
