/*
	TMenu.h
	j[NX
	j[o[NX
	j[R}hx[XNX
	L[}bvNX
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.02.12	1.0			Takeshi Yoneki
*/

#ifndef _CMENU_H_
#define _CMENU_H_

#define	CMENU_GET	0
#define	CMENU_NEW	1

class TMenu;
class TMenuBar;
class TMenuCommandBase;
class TKeyMap;

/*
	TMenu
	j[NX
*/
class TMenu : public TBase {
	friend class TMenuBar;
private:
public:
	MenuRef m_mref;
	short m_id;
	int m_sw;
public:
	TMenuCommandBase *m_command;
	TMenu();
	~TMenu();
	TMenu(short resourceID);
	TMenu(short menuID, ConstStr255Param menuTitle);
	void SetRelateToCommand(TMenuCommandBase *command);
	TMenu *GetNext() {
		return (TMenu *)TBase::GetNext();
	}
	void GetMenu(short resourceID);
	void NewMenu(short menuID, ConstStr255Param menuTitle);
	void AppendMenu(ConstStr255Param data) {
		::AppendMenu(m_mref, data);
	}
	void AppendResMenu(ResType theType) {
		::AppendResMenu(m_mref, theType);
	}
	void InsertMenu(short beforeID = 0) {
		::InsertMenu(m_mref, beforeID);
	}
	void InsertMenuHier() {
		InsertMenu(hierMenu);
	}
	void DeleteMenu() {
		::DeleteMenu(m_id);
	}
	void SetMenuItemText(short item, ConstStr255Param itemString) {
		::SetMenuItemText(m_mref, item, itemString);
	}
	void SetMenuItemTextCFString(MenuItemIndex item, TCFString inString) {
		::SetMenuItemTextWithCFString(m_mref, item, inString);
	}
	TString GetMenuItemText(short item);
	TCFString GetMenuItemTextCFString(MenuItemIndex item);
	void DisableItem(short item) {
		::DisableMenuItem(m_mref, item);
	}
	void EnableItem(short item) {
		::EnableMenuItem(m_mref, item);
	}
	void EnableMenuItemByList(char *newList, char *oldList);
	long PopUpMenuSelect(short top, short left, short popUpItem) {
		return ::PopUpMenuSelect(m_mref, top, left, popUpItem);
	}
	short CountMItems() {
		return ::CountMenuItems(m_mref);
	}
	void InsertMenuItem(ConstStr255Param itemString, short afterItem) {
		::InsertMenuItem(m_mref,itemString, afterItem);
	}
	void InsertMenuItemToTop(ConstStr255Param itemString) {
		InsertMenuItem(itemString, 0);
	}
	void DeleteMenuItem(short item) {
		::DeleteMenuItem(m_mref, item);
	}
	void CheckItem(short item, Boolean checked) {
		::CheckMenuItem(m_mref, item, checked);
	}
	void SetItemStyle(short item, short chStyle) {
		::SetItemStyle(m_mref, item, chStyle);
	}
	void SetItemCmd(short item, short cmdChar) {
		::SetItemCmd(m_mref, item, cmdChar);
	}
	void GetItemCmd(short item, short *cmdChar) {
		::GetItemCmd(m_mref, item, cmdChar);
	}
	void SetItemIcon(short item, short iconIndex) {
		::SetItemIcon(m_mref, item, iconIndex);
	}
	void GetItemIcon(short item, short *iconIndex) {
		::GetItemIcon(m_mref, item, iconIndex);
	}
private:
	void Initial();
};

/*
	TMenuBar
	j[o[NX
*/
class TMenuBar : public TListBase {
public:
	void DrawMenuBar() {
		::DrawMenuBar();
	}
	void HiliteMenuOff() {
		::HiliteMenu(0);
	}
	long MenuKey(short ch) {
		return ::MenuKey(ch);
	}
	TMenu *GetByID(short id);
	TMenu *GetTop() {
		return (TMenu *)TListBase::GetTop();
	}
	TMenuCommandBase *GetCommandByID(short id);
	void AppendResMenu(short id, ResType rt);
};

/*
	TMenuCommandBase
	j[R}hx[XNX
*/
class TMenuCommandBase : public TAppleObject {
	friend class TMenu;
protected:
	TMenu *m_menu;
public:
	virtual void FixMenu();
	virtual void Command(short item);
};

/*
	TKeyMap
	L[}bvNX
*/
class TKeyMap {
public:
	unsigned char m_keymap[16];
	TKeyMap() {
		GetKeys();
	}
	void GetKeys();
	Boolean IsPressed(unsigned short key);
};

/*
	CEvent
	CxgNX
*/
class CEvent : public EventRecord {
public:
	operator EventRecord *() {
		return (EventRecord *)this;
	}
	Boolean GetNextEvent(EventMask eventMask = everyEvent) {
		return ::GetNextEvent(eventMask, this);
	}
	Boolean WaitNextEvent(EventMask eventMask, UInt32 sleep, RgnHandle mouseRgn = NULL) {
		return ::WaitNextEvent(eventMask, this, sleep, mouseRgn);
	}
	Boolean IsDialogEvent() {
		return ::IsDialogEvent(this);
	}
	Boolean DialogSelect(DialogRef *theDialog, short *itemHit) {
		return ::DialogSelect(this, theDialog, itemHit);
	}
	Boolean TSMEvent() {
		return FALSE;
	}
};

/*
	TPopup
*/

class TPopup : TListBase {
public:
	TMenu *m_menu;
	int m_value;
	TPopup(short id);
	~TPopup();
	int GetValue() {
		return m_value;
	}
	void SetValue(int n) {
		m_value = n;
	}
	Boolean TrackPopup(TRect& box);
	TString GetItemText(short item) {
		return m_menu->GetMenuItemText(item);
	}
};

#endif
