/*
	COSA.cpp
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.07.15	1.5			Takeshi Yoneki
*/

#include "csystem.h"

/*
	TToken
	TokenNX
*/

TToken::TToken() {
}

TToken::~TToken() {
	TAppleObject *obj = GetAppleObject();
	if (m_created && obj != NULL && obj->IsTemporary()) {
		delete obj;
		**(TAppleObject ***)dataHandle = NULL;
	}
}

/*
	̃ReiꎞITTokenɂă\bhg߂̃RXgN^
	ANbZbTŐeReiTTokenɂĎg
	̏ꍇAfXgN^ł̃IuWFNg̍폜͂Ȃ
*/
TToken::TToken(const AEDesc *container)
		: TAEDesc() {
	TAppleObject *obj = NULL;
	TAEDesc desc(container);
	/* f[^̃fXNv^͈ꎞIȃIuWFNg̎̂ */
	if (container->descriptorType == typeChar)
		obj = new TString(desc.GetString());
	else if (container->descriptorType == typeLongInteger)
		obj = new TInteger(desc.GetInteger());
	else if (container->descriptorType == typeBoolean)
		obj = new TBoolean(desc.GetBoolean());
	else if (container->descriptorType == typeFSS)
		obj = new TFSSpec(desc.GetFSSpec());
	if (obj != NULL) {
		obj->BeTemporary();
		AObjRecord aobj;
		aobj.m_obj = obj;
		aobj.m_desiredClass = obj->GetObjectType();
		::AECreateDesc(classAppleObject, &aobj, sizeof (AObjRecord), *this);
		//		::AECreateDesc(obj->GetObjectType(), &obj, sizeof (TAppleObject *), *this);
	}
	else
		*(AEDesc *)this = *container;
}

/*
	TokenɊi[ĂTAppleObject𓾂
*/
TAppleObject *TToken::GetAppleObject() {
	if (descriptorType == classAppleObject) {
		AObjRecord *aobj = *(AObjRecord **)dataHandle;
		return aobj->m_obj;
	}
	return NULL;
}

DescType TToken::GetObjectDesiredClass() {
	if (descriptorType == classAppleObject) {
		AObjRecord *aobj = *(AObjRecord **)dataHandle;
		return aobj->m_desiredClass;
	}
	return typeNull;
}

TAppleObject *TToken::PurgeObject() {
	TAppleObject *obj = NULL;
	if (descriptorType == classAppleObject) {
		AObjRecord *aobj = *(AObjRecord **)dataHandle;
		obj = aobj->m_obj;
		aobj->m_desiredClass = typeNull;
		aobj->m_obj = NULL;
	}
	return obj;
}

/*
	TInteger
*/

OSErr TInteger::OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result) {
	TAppleEvent ae(aev);
	if (eventID == kAEGetData) {
		result->PutDataWithKeyword(keyAEResult, typeLongInteger, (Ptr)&m_data, sizeof m_data);
		return noErr;
	}
	else if (eventID == kAESetData) {
		*this = ae.GetParamInteger();
		return noErr;
	}
	return errAEEventNotHandled;
}

Boolean TInteger::CompareObjects(DescType oper, TAppleObject *obj) {
	if (obj == NULL)
		return FALSE;
	if (obj->GetObjectType() != classInteger)
		return FALSE;
	long n1 = *this;
	long n2 = *(TInteger *)obj;
	if (oper == kAEGreaterThan)
		return n1 > n2;
	else if (oper == kAEGreaterThanEquals)
		return n1 >= n2;
	else if (oper == kAEEquals)
		return n1 == n2;
	else if (oper == kAELessThan)
		return n1 < n2;
	else if (oper == kAELessThanEquals)
		return n1 <= n2;
	else
		return FALSE;
}

/*
	TBoolean
*/

OSErr TBoolean::OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result) {
	TAppleEvent ae(aev);
	if (eventID == kAEGetData) {
		result->PutDataWithKeyword(keyAEResult, typeBoolean, (Ptr)&m_data, sizeof m_data);
		return noErr;
	}
	else if (eventID == kAESetData) {
		*this = ae.GetParamBoolean();
		return noErr;
	}
	return errAEEventNotHandled;
}

Boolean TBoolean::CompareObjects(DescType oper, TAppleObject *obj) {
	if (obj == NULL)
		return FALSE;
	if (obj->GetObjectType() != classBoolean)
		return FALSE;
	Boolean n1 = *this;
	Boolean n2 = *(TBoolean *)obj;
	if (oper == kAEEquals)
		return n1 == n2;
	else
		return FALSE;
}

/*
	TAppleScript
*/

TAppleScript::TAppleScript() {
	m_scriptID = 0;
	m_error = noErr;
	m_loaded = FALSE;
}

TAppleScript::~TAppleScript() {
}

void TAppleScript::Load(TFilePath& filePath) {
	if (m_loaded == FALSE) {
		// MacOS 9̓\[XɃRpCꂽXNvgĂ
		TResourceFile file(filePath);
		if (file.IsGood()) {
			TResource scpt(kOSAScriptResourceType, 128);
			if (scpt.IsNull() == FALSE) {
				TAEDesc scriptData;
				long length = scpt.GetHandleSize();
				scriptData.AECreateDesc(typeOSAGenericStorage, scpt.HLock(), length);
				scpt.HUnlock();
				m_loaded = OSALoad(scriptData) == noErr;
				return;
			}
		}
		m_error = -1;
	}

	if (m_loaded == FALSE) {
		// MacOS X̓f[^tH[NɃRpCꂽXNvgĂ
		TFileIO file(filePath);
		if (file.IsGood()) {
			long length = file.GetFileSize();
			if (length > 0) {
				TMemory buffer(length);
				file.Read(length, buffer.GetPtr());
				if (file.IsGood()) {
					TAEDesc scriptData;
					scriptData.AECreateDesc(typeOSAGenericStorage, buffer.GetPtr(), length);
					m_loaded = OSALoad(scriptData) == noErr;
					return;
				}
			}
		}
		m_error = -1;
	}
	return;
}

OSAError TAppleScript::OSALoad(const AEDesc *scriptData, long modeFlags) {
	return m_error = ::OSALoad(theSystem->m_scriptingComponent, scriptData, modeFlags, &m_scriptID);
}

OSAError TAppleScript::Execute(OSAID contextID, long modeFlags) {
	OSAID sid;
	return m_error = ::OSAExecute(theSystem->m_scriptingComponent, m_scriptID, contextID, modeFlags, &sid);
}
