/*
	COSA.h
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.07.15	1.5			Takeshi Yoneki
*/

#ifndef	_COSA_H_
#define	_COSA_H_

class TToken;
class TInteger;
class TBoolean;
class TAppleScript;

/*
	Object Accessor肷Token
	TTokendescriptorType̓IuWFNg̃^CvłANXł͂Ȃ
	Ȃ킿uOtH_vłȂut@CXybNvƂȂ
	^CvƃNẌv̂
*/

#pragma options align=mac68k

struct AObjRecord {
public:
	TAppleObject *m_obj;
	DescType m_desiredClass;
};

#pragma options align=reset

class TToken : public TAEDesc {
public:
	TToken();
	TToken(const AEDesc *container);
	~TToken();
	TAppleObject *GetAppleObject();
	DescType GetObjectDesiredClass();
	TAppleObject *PurgeObject();
};

/*
	TInteger
	IuWFNg
*/
class TInteger : public TAppleObject {
public:
	long m_data;
	TInteger() {
		m_data = 0;
	}
	TInteger(long n, TAppleObject *container = NULL) {
		m_data = n;
		m_container = container;
	}
	operator long() {
		return m_data;
	}
	void operator=(long n) {
		m_data = n;
	}
	Boolean operator==(long n) {
		return Equal(n);
	}
	Boolean operator!=(long n) {
		return !Equal(n);
	}
	Boolean Equal(long n) {
		return m_data == n;
	}
	virtual DescType GetObjectType() {
		return classInteger/*typeLongInteger*/;
	}
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual Boolean CompareObjects(DescType oper, TAppleObject *obj);
};

/*
	TBoolean
	_lIuWFNg
*/
class TBoolean : public TAppleObject {
public:
	Boolean m_data;
	TBoolean() {
		m_data = FALSE;
	}
	TBoolean(Boolean n) {
		m_data = n;
	}
	operator Boolean() {
		return m_data;
	}
	void operator=(Boolean n) {
		m_data = n;
	}
	Boolean operator==(Boolean n) {
		return Equal(n);
	}
	Boolean operator!=(Boolean n) {
		return !Equal(n);
	}
	Boolean Equal(Boolean n) {
		return m_data == n;
	}
	virtual DescType GetObjectType() {
		return classBoolean/*typeBoolean*/;
	}
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual Boolean CompareObjects(DescType oper, TAppleObject *obj);
};

class TAppleScript {
public:
	OSAID m_scriptID;
	OSAError m_error;
	Boolean m_loaded;
	TAppleScript();
	~TAppleScript();
	void Load(TFilePath& filePath);
	OSAError OSALoad(const AEDesc *scriptData, long modeFlags = kOSAModeNull);
	OSAError Execute(OSAID contextID = kOSANullScript, long modeFlags = kOSAModeNull);
};

#endif
