/*
	TProcess.h
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.04.15	1.0			Takeshi Yoneki
*/

#ifndef	_CPROCESS_H_
#define	_CPROCESS_H_

class TLocalPingEvent;
class TAEDesc;
class TAEDescList;
class TAppleEvent;
class TProcess;

/*
	Apple Event
*/

class TAEDesc : public AEDesc {
public:
	OSErr m_error;
	Boolean m_created;
	TAEDesc();
	TAEDesc(const AEDesc *desc);
	~TAEDesc();
	Boolean IsGood() {
		return m_error == noErr;
	}
	operator AEDesc *() {
		return (AEDesc *)this;
	}
	OSErr AECreateDesc(DescType typeCode, const void *dataPtr, Size dataSize);
	OSErr AEDisposeDesc() {
		return m_error = ::AEDisposeDesc(this);
	}
	OSErr AEDuplicateDesc(const AEDesc *theAEDesc) {
		return m_error = ::AEDuplicateDesc(theAEDesc, this);
	}
	OSErr AEResolve(short callbackFlags, TAEDesc& token);

	OSErr CreateObjSpecifier(DescType desiredClass, AEDesc *theContainer, DescType keyForm, AEDesc *keyData, Boolean disposeInputs);
	AEDataStorage GetHandle() {
		return dataHandle;
	}
	Size GetLength();
	void GetData(void *dataPtr, Size maximumSize);

	/* fXNv^̒g𓾂igɊmMꍇɎgƁj */
	/* AppleScript̎Ɏgp */
	long GetInteger();
	Boolean GetBoolean();
	DescType GetDescType();
	TString GetString();
	TFSSpec GetFSSpec();
	TFSRef GetFSRef();
	/**/
	void Initial();
};

class TAEDescList : public TAEDesc {
public:
	TAEDescList();
	TAEDescList(const AEDescList *descList);
	operator AEDescList *() {
		return (AEDescList *)this;
	}
	OSErr AECreateList(const void *factoringPtr = NULL, Size factoredSize = 0, Boolean isRecord = FALSE);
	OSErr AECountItems(long *theCount) {
		return m_error = ::AECountItems(this, theCount);
	}
	long CountItems() {
		long count;
		AECountItems(&count);
		return count;
	}
	long GetCount() {
		return CountItems();
	}
	OSErr AEPutPtr(long index, DescType typeCode, const void *dataPtr, Size dataSize) {
		return m_error = ::AEPutPtr(this, index, typeCode, dataPtr, dataSize);
	}
	OSErr AEPutDesc(long index, const AEDesc *theAEDesc) {
		return m_error = ::AEPutDesc(this, index, theAEDesc);
	}
	OSErr AEGetNthPtr(long index, DescType desiredType, AEKeyword *theAEKeyword, DescType *typeCode, void *dataPtr, Size maximumSize, Size *actualSize) {
		return m_error = ::AEGetNthPtr(this, index, desiredType, theAEKeyword, typeCode, dataPtr, maximumSize, actualSize);
	}
};

class TAppleEvent : public TAEDesc {
public:
	TAppleEvent();
	TAppleEvent(const AppleEvent *aev);
	operator AppleEvent *() {
		return (AppleEvent *)this;
	}
	OSErr AECreateAppleEvent(AEEventClass theAEEventClass, AEEventID theAEEventID, const AEAddressDesc *target, short returnID = kAutoGenerateReturnID, long transactionID = kAnyTransactionID);
	OSErr AESend(TAppleEvent& reply, AESendMode sendMode, AESendPriority sendPriority = kAENormalPriority, long timeOutInTicks = kAEDefaultTimeout, AEIdleUPP idleProc = NULL, AEFilterUPP filterProc = NULL);
	OSErr AEPutParamPtr(AEKeyword theAEKeyword, DescType typeCode, const void *dataPtr, Size dataSize) {
		return m_error = ::AEPutParamPtr(this, theAEKeyword, typeCode, dataPtr, dataSize);
	}
	OSErr AEPutParamDesc(AEKeyword theAEKeyword, const AEDesc *theAEDesc) {
		return m_error = ::AEPutParamDesc(this, theAEKeyword, theAEDesc);
	}
	OSErr AEGetParamPtr(AEKeyword theAEKeyword, DescType desiredType, DescType *typeCode, void *dataPtr, Size maximumSize, Size *actualSize) {
		return m_error = ::AEGetParamPtr(this, theAEKeyword, desiredType, typeCode, dataPtr, maximumSize, actualSize);
	}
	OSErr AEGetParamDesc(AEKeyword theAEKeyword, DescType desiredType, TAEDesc& result);
	OSErr AESizeOfParam(AEKeyword theAEKeyword, DescType *typeCode, Size *dataSize) {
		return m_error = ::AESizeOfParam(this, theAEKeyword, typeCode, dataSize);
	}
	OSErr AEDeleteParam(AppleEvent *theAppleEvent, AEKeyword theAEKeyword) {
		return m_error = ::AEDeleteParam(this, theAEKeyword);
	}
	OSErr AEInteractWithUser(long timeOutInTicks = kAEDefaultTimeout, NMRecPtr nmReqPtr = NULL, AEIdleUPP idleProc = NULL) {
		return m_error = ::AEInteractWithUser(timeOutInTicks, nmReqPtr, idleProc);
	}
	OSErr AEGetAttributePtr(AEKeyword theAEKeyword, DescType desiredType, DescType *typeCode, void *dataPtr, Size maximumSize, Size *actualSize) {
		return m_error = ::AEGetAttributePtr(this, theAEKeyword, desiredType, typeCode, dataPtr, maximumSize, actualSize);
	}
	TString GetParamString(AEKeyword theAEKeyword = keyAEData, DescType desiredType = typeChar);
	long GetParamInteger(AEKeyword theAEKeyword = keyAEData, DescType desiredType = typeLongInteger);
	Boolean GetParamBoolean(AEKeyword theAEKeyword = keyAEData, DescType desiredType = typeBoolean);
	TFSSpec GetParamFSSpec(AEKeyword theAEKeyword = keyAEData, DescType desiredType = typeFSS);
	DescType GetParamDescType(AEKeyword theAEKeyword = keyAEData, DescType desiredType = typeType);
private:
	void Initial();
};

/*
	OnAppleEventł̖߂li[NX
*/
class TAEResult : public TAEDesc {
public:
	AEKeyword m_keyword;
	TAEResult();
	OSErr PutDataWithKeyword(AEKeyword theAEKeyword, DescType typeCode, const void *dataPtr, Size dataSize);
	OSErr PutDescWithKeyword(AEKeyword theAEKeyword, const AEDesc *theAEDesc);
};

/*
	TProcess
*/
class TProcess : public ProcessSerialNumber {
private:
	ProcessInfoRec m_pInfo;
public:
	OSErr m_error;
	TProcess();
	TProcess(ProcessSerialNumber& psn);
	Boolean IsGood() {
		return m_error == noErr;
	}
	operator ProcessSerialNumber *() {
		return (ProcessSerialNumber *)this;
	}
	void operator=(ProcessSerialNumber& psn) {
		*(ProcessSerialNumber *)this = psn;
	}
	OSErr SetFrontProcess() {
		return m_error = ::SetFrontProcess(this);
	}
	OSErr GetNextProcess() {
		return m_error = ::GetNextProcess(this);
	}
	OSErr GetProcessInformation() {
		return m_error = ::GetProcessInformation(this, &m_pInfo);
	}
	Boolean IsApplHere(OSType creator);
	OSErr LaunchApplication(const FSSpec *spec, AppParameters *ap, int flag = launchContinue + launchNoFileFlags);
	Boolean SendOpenDocument(OSType target, TFilePath& filePath, long selStart = -1, long selEnd = -1);
private:
	void Initial();
};

class CNotification {
public:
	NMRec m_nm;
	OSErr m_error;
	TString m_text;
	Boolean m_bInstalled;
	CNotification();
	CNotification(TString s);
	~CNotification();
	void Init();
	void SetText(TString s);
	OSErr Install();
	void Remove();
};

/*
	Ping
*/
class TLocalPingEvent : public AppParameters {
public:
	OSErr m_error;
	TLocalPingEvent();
	operator AppParameters *() {
		return (AppParameters *)this;
	}
	Boolean IsGood() {
		return m_error == noErr;
	}
	OSErr Post(OSType target);
};

#endif
