/*
	TScript.cpp
 
	Ten Tool Class Library
	Copyright (C) 2000 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 2000.03.24	1.0			Takeshi Yoneki
*/

#include "csystem.h"

#define	SPIN_CIRCLE_CURSOR		140
static TScript *scriptObject = NULL;

pascal OSErr TScript_OnWildCard(const AppleEvent *aev, AppleEvent *reply, INT_REFCON refCon);
pascal OSErr TScript_Accessor_ObjFromWildCard(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *value, long accessorRefcon);
pascal OSErr TScript_Accessor_PropFromWildCard(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *value, long accessorRefcon);
pascal OSErr TScript_Count_WildCard(DescType desiredClass, DescType containerClass, const AEDesc *container, long *result);
pascal OSErr TScript_Compare_WildCard(DescType oper, const AEDesc *desc1, const AEDesc *desc2, Boolean *result);

pascal OSErr TScript_OnWildCard(const AppleEvent *aev, AppleEvent *reply, INT_REFCON refCon) {
	if (scriptObject == NULL)
		return errAEEventNotHandled;
	return scriptObject->OnWildCard(aev, reply, refCon);
}

pascal OSErr TScript_Accessor_ObjFromWildCard(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *value, long accessorRefcon) {
	if (scriptObject == NULL)
		return errAEEventNotHandled;
	return scriptObject->Accessor_ObjFromWildCard(desiredClass, container, containerClass, keyForm, keyData, value, accessorRefcon);
}

pascal OSErr TScript_Accessor_PropFromWildCard(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *value, long accessorRefcon) {
	if (scriptObject == NULL)
		return errAEEventNotHandled;
	return scriptObject->Accessor_PropFromWildCard(desiredClass, container, containerClass, keyForm, keyData, value, accessorRefcon);
}

pascal OSErr TScript_Count_WildCard(DescType desiredClass, DescType containerClass, const AEDesc *container, long *result) {
	if (scriptObject == NULL)
		return errAEEventNotHandled;
	return scriptObject->Count_WildCard(desiredClass, containerClass, container, result);
}

pascal OSErr TScript_Compare_WildCard(DescType oper, const AEDesc *desc1, const AEDesc *desc2, Boolean *result) {
	if (scriptObject == NULL)
		return errAEEventNotHandled;
	return scriptObject->Compare_WildCard(oper, desc1, desc2, result);
}

OSErr TScript::OnWildCard(const AppleEvent *aev, AppleEvent *reply, long refCon) {
	theCursor->Set(SPIN_CIRCLE_CURSOR, TRUE);

	if (m_logAppleEvent) {
		theDebug->Log("** Script Event Start **");
	}

	/* Cxg𓾂 */
	TAppleEvent ae(aev);
	DescType typeCode;
	AEEventID eventID = typeNull;
	Size actualSize;
	ae.AEGetAttributePtr(keyEventIDAttr, typeType, &typeCode, (Ptr)&eventID, sizeof eventID, &actualSize);
	if (ae.IsGood() == FALSE) {
		if (m_logAppleEvent) {
			TString out;
			out.sprintf("OnWildCard error1 %d", ae.m_error);
			theDebug->Log(out);
		}
		return ae.m_error;
	}
	if (m_logAppleEvent) {
		TString evID;
		evID = eventID;
		TString out;
		out.sprintf("OnWildCard 1 evID=%s", (char *)evID);
		theDebug->Log(out);
	}

	/* IuWFNgXyVt@CA𓾂 */
	TAEDesc directParam;
	TToken token;
	DescType desiredClass = 'null';
	ae.AEGetParamDesc(keyDirectObject, typeObjectSpecifier, directParam);
	Boolean hasObjSpec = ae.IsGood();
	/* IuWFNgXyVt@CAȂtheMain */
	if (hasObjSpec == FALSE) {
		/* application̂̂ɑ΂Cxg */
		TAEResult result;
		OSErr err = m_main->OnAppleEvent(eventID, desiredClass, aev, &result);
		TAppleEvent re(reply);
		if (err == noErr && result.m_keyword != typeNull)
			re.AEPutParamDesc(result.m_keyword, &result);
		return err;
	}

	if (directParam.descriptorType == typeNull) {
		if (m_logAppleEvent) {
			theDebug->Log("OnWildCard error2");
		}
		return errAEParamMissed;
	}

	/* IuWFNgXyVt@CA̕ */
	directParam.AEResolve(kAEIDoMinimum, token);
	if (directParam.IsGood() == FALSE) {
		if (m_logAppleEvent) {
			TString out;
			out.sprintf("OnWildCard error3 %d", directParam.m_error);
			theDebug->Log(out);
		}
		return directParam.m_error;
	}
	if (token.descriptorType == typeNull) {
		if (m_logAppleEvent) {
			theDebug->Log("OnWildCard error4");
		}
		return errAEUnknownObjectType;
	}

	/* Token͐H */
	TAppleObject *obj = token.GetAppleObject();
	if (obj == NULL) {
		if (m_logAppleEvent) {
			theDebug->Log("OnWildCard error5");
		}
		return errAEUnknownObjectType;
	}

	/* ړINXTokenĂ */
	/*if (eventID != kAECreateElement)*//* ̃Rg̐ǂĂ1998.05.20 */
	desiredClass = token.GetObjectDesiredClass();

	if (m_logAppleEvent) {
		TString des;
		des = desiredClass;
		TString evID;
		evID = eventID;
		TString objType;
		objType = obj->GetObjectType();
		TString out;
		out.sprintf("OnWildCard 2 evID=%s, des=%s, obj=%s", (char *)evID, (char *)des, (char *)objType);
		theDebug->Log(out);
	}

	TAEResult result;
	OSErr err = obj->OnAppleEvent(eventID, desiredClass, aev, &result);
	if (err != noErr) {
		if (m_logAppleEvent) {
			TString out;
			out.sprintf("OnWildCard error6 %d", err);
			theDebug->Log(out);
		}
		return err;
	}
	if (obj->GetContainer() != NULL)
		err = obj->GetContainer()->OnAdhocForContainer(&token, eventID, aev, &result);

	TAppleEvent re(reply);
	if (result.m_keyword != typeNull)
		re.AEPutParamDesc(result.m_keyword, &result);

	return err;
}

OSErr TScript::Accessor_ObjFromWildCard(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *value, long accessorRefcon) {
	if (m_logAppleEvent) {
		TString dc;
		dc = desiredClass;
		TString kf;
		kf = keyForm;
		TString kd;
		kd = keyData->descriptorType;
		TString out;
		out.sprintf("Accessor_ObjFromWildCard des=%s, keyF=%s, keyD=%s", (char *)dc, (char *)kf, (char *)kd);
		theDebug->Log(out);
	}

	TToken containerToken(container);
	TAppleObject *containerObj = containerToken.GetAppleObject();
	if (containerObj == NULL)
		containerObj = m_main;
	TAppleObject *obj = containerObj->GetContainedObject(desiredClass, keyForm, keyData);
	if (obj == NULL)
		return errAEUnknownObjectType;
	return obj->CreateToken(desiredClass, value);
}

OSErr TScript::Accessor_PropFromWildCard(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *value, long accessorRefcon) {
	TToken containerToken(container);
	TAppleObject *containerObj = containerToken.GetAppleObject();
	if (containerObj == NULL)
		containerObj = m_main;
	DescType propType = TAEDesc(keyData).GetDescType();
	//	DescType propType = *(DescType*)*keyData->dataHandle;

	if (m_logAppleEvent) {
		TString dc;
		dc = desiredClass;
		TString kf;
		kf = keyForm;
		TString pt;
		pt = propType;
		TString cc;
		cc = containerClass;
		TString out;
		out.sprintf("Accessor_PropFromWildCard des=%s, keyF=%s, prop=%s cont=%s", (char *)dc, (char *)kf, (char *)pt, (char *)cc);
		theDebug->Log(out);
	}

	TAppleObject *obj = containerObj->GetObjectProperty(propType, keyForm, keyData);
	if (obj == NULL)
		return errAEUnknownObjectType;
	return obj->CreateToken(propType, value);
	/*
		propTypeobj->GetObjectType()ɕύXB
		current xxxƂ\ɉ\ɂȂƎvB
		vpeB̃IuWFNgꍇvpeB̎ʂłȂÃIuWFNg
		ʎqŃg[NȂƃ]ułȂBǂlƂ܂ȘbB
		1997.01.12

		ꂾł͂͂肪ߊ{Iȍ\̃NX̃fXNv^
		NXCuƎ̂̂ɕύX
		TDirectory, TFSSpec, TInteger, TBoolean, TString
		
		܂܂肪TAppleObjectɎʂ̂߂DescTypei[悤ɂB
		̓GgvNXAvpeBvpeBʂƂȂB
		1997.09.26

		IuWFNgXyVt@CA쐬ɂTToken͖֌WȂ̂ŁATAppleObject^ȂĂ͂ȂB
		AIuWFNgXyVt@CA쐬Kv̂́AȂ킿GgɂȂNX
		GetObjectType()̖߂lVXe̗vNX(desiredClass)ƈvȂĂ͂ȂB
		desiredClassTAppleObjectłȂTToken̑ɎAdescriptorTypeꗥ'AObj'ɂB
		obj->GetObjectType()propTypeɖ߂B
		łԃXbLB
								Gg			vpeB			VXeႤ
		GetObjectType()			B̌^			ʂ̌^			-
		TTokendescriptorType	'AObj'				'AObj'				^
		TTokendesiredClass	desiredClass		propType			-
		1997.09.27
	*/
}

OSErr TScript::Count_WildCard(DescType desiredClass, DescType containerClass, const AEDesc *container, long *result) {
	if (m_logAppleEvent) {
		TString dc;
		dc = desiredClass;
		TString cc;
		cc = containerClass;
		TString out;
		out.sprintf("Count_WildCard des=%s, cont=%s, prop=%s", (char *)dc, (char *)cc);
		theDebug->Log(out);
	}

	TToken containerToken(container);
	TAppleObject *containerObj = containerToken.GetAppleObject();
	if (containerObj == NULL)
		containerObj = m_main;
	*result = containerObj->CountContainedObjects(desiredClass);
	return noErr;
}

OSErr TScript::Compare_WildCard(DescType oper, const AEDesc *desc1, const AEDesc *desc2, Boolean *result) {
	if (m_logAppleEvent) {
		TString op;
		op = oper;
		TString d1;
		d1 = desc1->descriptorType;
		TString d2;
		d2 = desc2->descriptorType;
		TString out;
		out.sprintf("Compare_WildCard oper=[%s], desc1=%s, desc2=%s", (char *)op, (char *)d1, (char *)d2);
		theDebug->Log(out);
	}

	TToken token1(desc1);
	TToken token2(desc2);

	/* Ƃ[JIuWFNgꂽ */
	if (token1.descriptorType == classAppleObject && token2.descriptorType == classAppleObject) {
		TAppleObject *obj1 = token1.GetAppleObject();
		TAppleObject *obj2 = token2.GetAppleObject();
		/* ^Ȃfɔr */
		if (obj1->GetObjectType() == obj2->GetObjectType()) {
			*result = obj1->CompareObjects(oper, obj2);
			return noErr;
		}

		/* Ⴄ^Ȃ疼Ô݃`FbN */
		if (oper == kAEEquals && obj2->GetObjectType() == classString) {
			TString name = *(TString*)obj2;
			if (name.GetLength() == 0)
				return errAEEventNotHandled;
			TCFString objName(obj1->GetObjectName());
			*result = objName.EqualsIgnoreCase(name);
			return noErr;
		}
		if (oper == kAEEquals && obj1->GetObjectType() == classString) {
			TString name = *(TString*)obj1;
			if (name.GetLength() == 0)
				return errAEEventNotHandled;
			TCFString objName(obj2->GetObjectName());
			*result = objName.EqualsIgnoreCase(name);
			return noErr;
		}
	}

	return errAEEventNotHandled;
}

void TScript::InstallObject(DescType desiredClass, DescType containerType) {
	if (m_main == NULL)
		return;
	AEInstallObjectAccessor(desiredClass, containerType, (OSLAccessorUPP)m_uppObjFromWildCard.GetUPP(), 0, FALSE);
}
void TScript::InstallProperty(DescType containerType) {
	if (m_main == NULL)
		return;
	AEInstallObjectAccessor(cProperty, containerType, (OSLAccessorUPP)m_uppPropFromWildCard.GetUPP(), 0, FALSE);
}

TScript::TScript(TAppleObject *main, AEEventClass applClassID) {
	if (theSystem->hasAppleScript == FALSE)
		return;
	scriptObject = this;
	m_main = main;
	m_logAppleEvent = FALSE;
	theCursor->Load(SPIN_CIRCLE_CURSOR, 8, 20);
	m_uppOnWildCard.SetUPP(TScript_OnWildCard);
	m_uppObjFromWildCard.SetUPP(TScript_Accessor_ObjFromWildCard);
	m_uppPropFromWildCard.SetUPP(TScript_Accessor_PropFromWildCard);
	m_uppCompare.SetUPP(TScript_Compare_WildCard);
	m_uppCount.SetUPP(TScript_Count_WildCard);

	/* initial AppleScript Handler */
	AEInstallEventHandler(kAECoreSuite, typeWildCard, (AEEventHandlerUPP)m_uppOnWildCard.GetUPP(), 0, FALSE);
	AEInstallEventHandler(applClassID, typeWildCard, (AEEventHandlerUPP)m_uppOnWildCard.GetUPP(), 0, FALSE);
	AEInstallObjectAccessor(cProperty, classAppleObject, (OSLAccessorUPP)m_uppPropFromWildCard.GetUPP(), 0, FALSE);
	AESetObjectCallbacks((OSLCompareUPP)m_uppCompare.GetUPP(), (OSLCountUPP)m_uppCount.GetUPP(), NULL, NULL, NULL, NULL, NULL);
}
