/*
	TSocket.h
 
	Ten Tool Class Library
	Copyright (C) 2000 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 2000.03.21	1.0			Takeshi Yoneki
*/

#include "csystem.h"

static pascal void TSocket_YieldingNotifier(void* contextPtr, OTEventCode code, OTResult result, void* cookie);

/*
	TSocket
*/

TSocket::TSocket() {
	m_ep = kOTInvalidEndpointRef;
	m_binded = FALSE;
	m_uppOTNotify.SetUPP(TSocket_YieldingNotifier);
	/* TCP/IP̏I[J */
	m_ep = OTOpenEndpointInContext(OTCreateConfiguration(kTCPName), 0, NULL, &m_error, NULL);
	if (m_ep == kOTInvalidEndpointRef)
		return;
	/* 񓯊[h */
	OTSetSynchronous(m_ep);
	/* ubLO */
	//	OTSetBlocking(m_ep);
	/* ʒm󂯎R[obN */
	OTInstallNotifier(m_ep, m_uppOTNotify.GetUPP(), this);
	/* 쒆̃AChCxgʒm */
	OTUseSyncIdleEvents(m_ep, TRUE);
	/* oCh */
	m_error = OTBind(m_ep, NULL, NULL);
	m_binded = m_error == noErr;
}

/* ubÑAChCxgőɃ^XN */
static pascal void TSocket_YieldingNotifier(void* contextPtr, OTEventCode code, OTResult result, void* cookie) {
	TSocket *socketObject = (TSocket *)contextPtr;
	if (code == kOTSyncIdleEvent)
		YieldToAnyThread();
}

TSocket::~TSocket() {
	/* oCh */
	if (m_binded)
		OTUnbind(m_ep);
	/* I[ */
	if (m_ep != kOTInvalidEndpointRef)
		OTCloseProvider(m_ep);
}

Boolean TSocket::Connect(char *hostName, int port) {
	char name[300];
	sprintf(name, "%s:%d", hostName, port);
	DNSAddress 	hostDNSAddress;
	TCall sndCall;
	::memset(&hostDNSAddress, 0, sizeof hostDNSAddress);
	::memset(&sndCall, 0, sizeof sndCall);
	sndCall.addr.buf = (UInt8 *)&hostDNSAddress;
	sndCall.addr.len = OTInitDNSAddress(&hostDNSAddress, name);
	sndCall.opt.buf = NULL;
	sndCall.opt.len = 0;
	sndCall.udata.buf = NULL;
	sndCall.udata.len = 0;
	sndCall.sequence = 0;
	m_error = OTConnect(m_ep, &sndCall, NULL);
	return m_error == noErr;
}

OTResult TSocket::Send(void* buff, size_t nbytes, OTFlags flags) {
	m_error = OTSnd(m_ep, buff, nbytes, flags);
	return m_error;
}

OTResult TSocket::Receive(void* buff, size_t nbytes, OTFlags* flags) {
	OTFlags dmy;
	m_error = OTRcv(m_ep, buff, nbytes, flags == NULL ? &dmy : flags);
	return m_error;
}

