/*
	TString.h
	NX
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.02.03	1.0			Takeshi Yoneki
*/

#ifndef	_CSTRING_H_
#define	_CSTRING_H_

class TString;
class TStringList;
//class CUniString;

#define	KANJI_SJIS			0
#define	KANJI_EUC			1
#define	KANJI_JIS7			2
#define	KANJI_UTF8			3

/*
	TString
	NX
	boŕāÂ܂ToolboxPASCALƂ
	n悤ɂĂ
*/
class TString : public TAppleObject {
protected:
	char *m_data;
	int m_dataLength;
	int m_allocLength;
	int m_scriptCode;
public:
	TString();
	~TString();
	TString(const TString& cs);
	TString(char *s);	/* bɂ鏉 */
	TString(const char *s);
	TString(ConstStr255Param ps);	/* PASCALɂ鏉 */
	//TString(OSType sig);	/* OSTypeɂ鏉 */
	//	TString(const CUniString& us);
	TString(const TCFString &sr);	/* CFStringRefɂ鏉 */
	TString(const TUniString &us);
	operator char *() const;	/* bւ̃LXg */
	operator ConstStr255Param() const;	/* PASCALւ̃LXg */
	/*operator StringPtr() const;*/	/* ЂƂPASCALւ̃LXg */
	/* 2002.01.댯Ȃ̂Œ~ */
	//operator OSType() const;	/* OSTypeւ̃LXg */
	operator CFStringRef() const;
	/* 2006.01 Iɂ͂ȂׂH */
	void operator=(const TString& cs);	/* TString̃Rs[ */
	void operator=(char* s);	/* b̃Rs[ */
	void operator=(const char* s);
	void operator=(ConstStr255Param ps);	/* PASCAL̃Rs[ */
	void operator=(OSType sig);	/* OSTypẽRs[ */
	void operator=(CFStringRef s);	/* CFStringRef̃Rs[ */
	//	void operator=(const CUniString& us);
	void operator=(const TCFString &sr);
	void operator=(const TUniString &us);
	Boolean operator==(const TString& cs);	/* ̃c */
	Boolean operator!=(const TString& cs) {
		return !operator==(cs);
	}
	Boolean operator==(char *s);
	Boolean operator!=(char *s) {
		return !operator==(s);
	}
	Boolean operator==(ConstStr255Param ps);
	Boolean operator!=(ConstStr255Param ps) {
		return !operator==(ps);
	}
	OSType GetOSType();
	void SetOSType(OSType sig);
	void CopyTo(StringPtr ps, int n = -1);	/* StringPtrւ̃Rs[ */
	void CopyTo(char *s, int n = -1);	/* tbւ̃Rs[ */
	/* n : ̈̃TCY, Str3132 */
	//	CFStringRef GetCFString(CFStringEncoding enc = CFStringGetSystemEncoding());
	void CopyFrom(char *s, int n = -1);	/* tb̃Rs[ */
	/* n : ̈̃TCY, char bf[16]16 */
	//	void SetCFString(CFStringRef s, CFStringEncoding enc = CFStringGetSystemEncoding());
	void SetScriptCode(int scriptCode) {
		m_scriptCode = scriptCode;
	}
	int GetScriptCode() const {
		return m_scriptCode;
	}
	char GetAt(int n) const;	/* LN^̊l */
	char operator[](int n) {
		return GetAt(n);
	}
	int	sprintf(const char *format, ...);	/* ̃c */
	char *strtok_first(const char *delim);
	char *strtok_next(const char *delim);
	int strcmp(const char *s);
	Boolean Equal(const char *s, int n = -1);
	int strncmp(const char *s, int n);
	int stricmp(const char *s);
	int strnicmp(const char *s, int n);
	int IUMagString(TString& s) {
		return CompareText((char *)*this, (char *)s, GetLength(), s.GetLength(), NULL);
	}
	int GetLength()	const/* ̒ */
	{
	    return m_dataLength;
	}
	Boolean IsEmpty() const {
		return m_dataLength == 0;
	}
	Boolean IsASCII();
	TString GetForMenu();
	void DrawString() {
		::DrawString(*this);
	}
	short StringWidth() {
		return ::StringWidth(*this);
	}
	void UppercaseText(TWindow * win);
	void UpperString() {
		::UpperString((StringPtr)(ConstStr255Param)*this, FALSE);
	}
	void MakeUpper(TWindow * win = NULL);
	int atoi();
	void CutRearSpace();
	void StripSpace();
	TString *GetNext() {
		return (TString *)TBase::GetNext();
	}
	void LoadSTRNum(short id, short n);	/* 'STR#'̓Ǎ n = 1... */
	Boolean CutShortcut(TString *body, TString *shortcut);
	/*  */
	TString ConvertToSJIS(int kanjiCode, TUnicodeTextEncodingInfo *encInfo = NULL);
	Boolean CheckConvertToSJIS(int kanjiCode, int *misHit, int *kanjiHit, TUnicodeTextEncodingInfo *encInfo = NULL);
	TString MakeJIS7();	/* GXP[vV[PXȂ */
	TString MakeEUC();
	TString MakeUTF8();
	/* for AppleScript */
	virtual DescType GetObjectType() {
		return classString;	/* 'Str ' */
	}
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual Boolean CompareObjects(DescType oper, TAppleObject *obj);
private:
	void Init();
	void SafeDelete();
	void AllocCopy(const char *p, int len);
};

char *TString_GetBuffer(int sz);
//void TString_SetBuffer(char *buf, int sz);

#pragma options align=mac68k

typedef struct {
	short m_number;
	Str255 m_string;
}
STRNumRec;

#pragma options align=reset

/*
	TStringList
	̃Xg
*/
class TStringList : public TAppleObject {
protected:
	int m_scriptCode;
	void Init();
public:
	TStringList();
	TStringList(TFilePath &filePath);
	~TStringList();
	void AppendStr(char *p);
	void LoadFile(TFilePath &filePath);
	void SaveFile(TFilePath &filePath, OSType creator, OSType fileType);
	void LoadStrNumAll(short id);
	TString *GetTop() {
		return (TString *)TListBase::GetTop();
	}
	TString *GetNth(int n) {
		return (TString *)TListBase::GetNth(n);
	}
	void CopyFrom(TMemory *buffer);
	void CopyFrom(char *data, int length);
	int CopyTo(TMemory *buffer);
	void CopyFromEditor(TEditor *ed);
	void CopyToEditor(TEditor *ed);
	TString GetStringWithKeyword(TString keyword);
	void SetScriptCode(int scriptCode) {
		m_scriptCode = scriptCode;
	}
	int GetScriptCode() const {
		return m_scriptCode;
	}
	/* for AppleScript */
	virtual DescType GetObjectType() {
		return 'TxLs';	/* '' */
	}
	virtual OSErr GetObjSpecifier(DescType desiredClass, AEDesc *objSpec) {
		return ThroughObjSpecifier(desiredClass, objSpec);
	}
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual OSErr OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result);
};

/*
	TUniString
	Unicode
	BOMȂ BOM_BIGz
*/

class TUniString : public TAppleObject {
protected:
	UniChar *m_data;
	int m_dataLength;
	int m_allocLength;
	int m_scriptCode;
	void Init();
	void SafeDelete();
	void AllocCopy(const UniChar *p, int len);
public:
	TUniString();
	~TUniString();
	TUniString(const TUniString &us);
	TUniString(const TCFString &cs);
	TUniString(const TString &s);
	TUniString(const char *cstr);
	TUniString(ConstStr255Param pStr);
	TUniString(const CFStringRef theString);
	TUniString(const CFURLRef anURL);
	TUniString(const HFSUniStr255 &us);
	TUniString(const THFSUniStr255 &us);
	TUniString(const UniChar *ustr);

	void operator=(const TUniString &cs);
	void operator=(const TCFString &cs);
	void operator=(const TString &s);
	void operator=(const char *cstr);
	void operator=(ConstStr255Param pStr);
	void operator=(const CFStringRef theString);
	void operator=(const CFURLRef anURL);
	void operator=(const HFSUniStr255 &us);
	void operator=(const THFSUniStr255 &us);
	void operator=(const UniChar *ustr);

	operator UniChar *() const {
		return m_data;
	}
	operator const UniChar *() const {
		return m_data;
	}
	int GetLength()	const {	/* ̒ioCgł͂Ȃj */
	    return m_dataLength;
	}
	Boolean IsEmpty();
	void SetScriptCode(int scriptCode) {
		m_scriptCode = scriptCode;
	}
	int GetScriptCode() const {
		return m_scriptCode;
	}

	int Compare(const TUniString &s, CFOptionFlags option = 0);
	int CompareIgnoreCase(const TUniString &s) {
		return Compare(s, kCFCompareCaseInsensitive);
	}
	Boolean Equals(const TUniString &s) {
		return Compare(s) == 0;
	}
	Boolean EqualsIgnoreCase(const TUniString &s) {
		return Compare(s, kCFCompareCaseInsensitive) == 0;
	}
	Boolean operator==(const TCFString &s) {
		return Equals(s);
	}
	Boolean operator!=(const TCFString &s) {
		return !Equals(s);
	}
	TUniString Append(const TUniString &s);
	TUniString operator+(const TUniString &s) {
		return Append(s);
	}
	void CutRearSpace();
	int unistrlen(const UniChar *p);

	void CopyFromUniString(const TUniString &us, int n = -1);
	void CopyFromTCFString(const TCFString &cs);
	void CopyFromCSTR(const char *cstr, int length, int scriptCode = -1);
	void CopyFromPSTR(ConstStr255Param pStr, int scriptCode = -1);
	void CopyFromUSTR(const UniChar *ustr, int length = -1);
	void CopyFromHFSUniStr255(const HFSUniStr255 &hu);

	void CopyToHFSUniStr255(HFSUniStr255 *hu);
//	void CopyToTString(TString *s);

	/* for AppleScript */
	virtual DescType GetObjectType() {
		return classUniString;	/* 'UStr' */
	}
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual Boolean CompareObjects(DescType oper, TAppleObject *obj);
};

short SwapInt16(short inData);

#endif
