#ifndef _CUPP_H_
#define	_CUPP_H_

//#include <OpenTransport.h>
//#include <OpenTptInternet.h>

class CUPP_NavEvent;
class CUPP_NavObjectFilter;
class CUPP_ModalFilter;
class CUPP_DlgHook;
class CUPP_FileFilter;
class CUPP_DlgHookYD;
class CUPP_ModalFilterYD;
class CUPP_FileFilterYD;
class CUPP_ActivateYD;
class CUPP_ControlAction;
class CUPP_TSMTEPreUpdate;
class CUPP_TSMTEPostUpdate;
class CUPP_TEClickLoop;
class CUPP_AEEventHandler;
class CUPP_AEIdle;
class CUPP_AEFilter;
class CUPP_OSLAccessor;
class CUPP_OSLCompare;
class CUPP_OSLCount;
class CUPP_GrowZone;
class CUPP_DragReceiveHandler;
class CUPP_DragTrackingHandler;
class CUPP_OTNotify;
class CUPP_ThreadEntry;
class CUPP_ListDef;
class CUPP_NM;

class CUPP_NavEvent {
public:
	NavEventUPP m_upp;
	CUPP_NavEvent() {
		m_upp = NULL;
	}
	CUPP_NavEvent(NavEventProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_NavEvent() {
		if (m_upp != NULL) {
			DisposeNavEventUPP(m_upp);
		}
	}
	operator NavEventUPP() {
		return GetUPP();
	}
	void SetUPP(NavEventProcPtr userRoutine) {
		m_upp = NewNavEventUPP(userRoutine);
	}
	NavEventUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_NavObjectFilter {
public:
	NavObjectFilterUPP m_upp;
	CUPP_NavObjectFilter() {
		m_upp = NULL;
	}
	CUPP_NavObjectFilter(NavObjectFilterProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_NavObjectFilter() {
		if (m_upp != NULL) {
			DisposeNavObjectFilterUPP(m_upp);
		}
	}
	operator NavObjectFilterUPP() {
		return GetUPP();
	}
	void SetUPP(NavObjectFilterProcPtr userRoutine) {
		m_upp = NewNavObjectFilterUPP(userRoutine);
	}
	NavObjectFilterUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_ModalFilter {
public:
	ModalFilterUPP m_upp;
	CUPP_ModalFilter() {
		m_upp = NULL;
	}
	CUPP_ModalFilter(ModalFilterProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_ModalFilter() {
		if (m_upp != NULL) {
			DisposeModalFilterUPP(m_upp);
		}
	}
	operator ModalFilterUPP() {
		return GetUPP();
	}
	void SetUPP(ModalFilterProcPtr userRoutine) {
		m_upp = NewModalFilterUPP(userRoutine);
	}
	ModalFilterUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_ModalFilterYD {
public:
	ModalFilterYDUPP m_upp;
	CUPP_ModalFilterYD() {
		m_upp = NULL;
	}
	CUPP_ModalFilterYD(ModalFilterYDProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_ModalFilterYD() {
		if (m_upp != NULL) {
			DisposeModalFilterYDUPP(m_upp);
		}
	}
	operator ModalFilterYDUPP() {
		return GetUPP();
	}
	void SetUPP(ModalFilterYDProcPtr userRoutine) {
		m_upp = NewModalFilterYDUPP(userRoutine);
	}
	ModalFilterYDUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_ControlAction {
public:
	ControlActionUPP m_upp;
	CUPP_ControlAction() {
		m_upp = NULL;
	}
	CUPP_ControlAction(ControlActionProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_ControlAction() {
		if (m_upp != NULL) {
			DisposeControlActionUPP(m_upp);
		}
	}
	operator ControlActionUPP() {
		return GetUPP();
	}
	void SetUPP(ControlActionProcPtr userRoutine) {
		m_upp = NewControlActionUPP(userRoutine);
	}
	ControlActionUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_TSMTEPreUpdate {
public:
	TSMTEPreUpdateUPP m_upp;
	CUPP_TSMTEPreUpdate() {
		m_upp = NULL;
	}
	CUPP_TSMTEPreUpdate(TSMTEPreUpdateProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_TSMTEPreUpdate() {
		if (m_upp != NULL) {
			DisposeTSMTEPreUpdateUPP(m_upp);
		}
	}
	operator TSMTEPreUpdateUPP() {
		return GetUPP();
	}
	void SetUPP(TSMTEPreUpdateProcPtr userRoutine) {
		m_upp = NewTSMTEPreUpdateUPP(userRoutine);
	}
	TSMTEPreUpdateUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_TSMTEPostUpdate {
public:
	TSMTEPostUpdateUPP m_upp;
	CUPP_TSMTEPostUpdate() {
		m_upp = NULL;
	}
	CUPP_TSMTEPostUpdate(TSMTEPostUpdateProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_TSMTEPostUpdate() {
		if (m_upp != NULL) {
			DisposeTSMTEPostUpdateUPP(m_upp);
		}
	}
	operator TSMTEPostUpdateUPP() {
		return GetUPP();
	}
	void SetUPP(TSMTEPostUpdateProcPtr userRoutine) {
		m_upp = NewTSMTEPostUpdateUPP(userRoutine);
	}
	TSMTEPostUpdateUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_TEClickLoop {
public:
	TEClickLoopUPP m_upp;
	CUPP_TEClickLoop() {
		m_upp = NULL;
	}
	CUPP_TEClickLoop(TEClickLoopProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_TEClickLoop() {
		if (m_upp != NULL) {
			DisposeTEClickLoopUPP(m_upp);
		}
	}
	operator TEClickLoopUPP() {
		return GetUPP();
	}
	void SetUPP(TEClickLoopProcPtr userRoutine) {
		m_upp = NewTEClickLoopUPP(userRoutine);
	}
	TEClickLoopUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_AEEventHandler {
public:
	AEEventHandlerUPP m_upp;
	CUPP_AEEventHandler() {
		m_upp = NULL;
	}
	CUPP_AEEventHandler(AEEventHandlerProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_AEEventHandler() {
		if (m_upp != NULL) {
			DisposeAEEventHandlerUPP(m_upp);
		}
	}
	operator AEEventHandlerUPP() {
		return GetUPP();
	}
	void SetUPP(AEEventHandlerProcPtr userRoutine) {
		m_upp = NewAEEventHandlerUPP(userRoutine);
	}
	AEEventHandlerUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_AEIdle {
public:
	AEIdleUPP m_upp;
	CUPP_AEIdle() {
		m_upp = NULL;
	}
	CUPP_AEIdle(AEIdleProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_AEIdle() {
		if (m_upp != NULL) {
			DisposeAEIdleUPP(m_upp);
		}
	}
	operator AEIdleUPP() {
		return GetUPP();
	}
	void SetUPP(AEIdleProcPtr userRoutine) {
		m_upp = NewAEIdleUPP(userRoutine);
	}
	AEIdleUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_AEFilter {
public:
	AEFilterUPP m_upp;
	CUPP_AEFilter() {
		m_upp = NULL;
	}
	CUPP_AEFilter(AEFilterProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_AEFilter() {
		if (m_upp != NULL) {
			DisposeAEFilterUPP(m_upp);
		}
	}
	operator AEFilterUPP() {
		return GetUPP();
	}
	void SetUPP(AEFilterProcPtr userRoutine) {
		m_upp = NewAEFilterUPP(userRoutine);
	}
	AEFilterUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_OSLAccessor {
public:
	OSLAccessorUPP m_upp;
	CUPP_OSLAccessor() {
		m_upp = NULL;
	}
	CUPP_OSLAccessor(OSLAccessorProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_OSLAccessor() {
		if (m_upp != NULL) {
			DisposeOSLAccessorUPP(m_upp);
		}
	}
	operator OSLAccessorUPP() {
		return GetUPP();
	}
	void SetUPP(OSLAccessorProcPtr userRoutine) {
		m_upp = NewOSLAccessorUPP(userRoutine);
	}
	OSLAccessorUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_OSLCompare {
public:
	OSLCompareUPP m_upp;
	CUPP_OSLCompare() {
		m_upp = NULL;
	}
	CUPP_OSLCompare(OSLCompareProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_OSLCompare() {
		if (m_upp != NULL) {
			DisposeOSLCompareUPP(m_upp);
		}
	}
	operator OSLCompareUPP() {
		return GetUPP();
	}
	void SetUPP(OSLCompareProcPtr userRoutine) {
		m_upp = NewOSLCompareUPP(userRoutine);
	}
	OSLCompareUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_OSLCount {
public:
	OSLCountUPP m_upp;
	CUPP_OSLCount() {
		m_upp = NULL;
	}
	CUPP_OSLCount(OSLCountProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_OSLCount() {
		if (m_upp != NULL) {
			DisposeOSLCountUPP(m_upp);
		}
	}
	operator OSLCountUPP() {
		return GetUPP();
	}
	void SetUPP(OSLCountProcPtr userRoutine) {
		m_upp = NewOSLCountUPP(userRoutine);
	}
	OSLCountUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_GrowZone {
public:
	GrowZoneUPP m_upp;
	CUPP_GrowZone() {
		m_upp = NULL;
	}
	CUPP_GrowZone(GrowZoneProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_GrowZone() {
		if (m_upp != NULL) {
			DisposeGrowZoneUPP(m_upp);
		}
	}
	operator GrowZoneUPP() {
		return GetUPP();
	}
	void SetUPP(GrowZoneProcPtr userRoutine) {
		m_upp = NewGrowZoneUPP(userRoutine);
	}
	GrowZoneUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_DragReceiveHandler {
public:
	DragReceiveHandlerUPP m_upp;
	CUPP_DragReceiveHandler() {
		m_upp = NULL;
	}
	CUPP_DragReceiveHandler(DragReceiveHandlerProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_DragReceiveHandler() {
		if (m_upp != NULL) {
			DisposeDragReceiveHandlerUPP(m_upp);
		}
	}
	operator DragReceiveHandlerUPP() {
		return GetUPP();
	}
	void SetUPP(DragReceiveHandlerProcPtr userRoutine) {
		m_upp = NewDragReceiveHandlerUPP(userRoutine);
	}
	DragReceiveHandlerUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_DragTrackingHandler {
public:
	DragTrackingHandlerUPP m_upp;
	CUPP_DragTrackingHandler() {
		m_upp = NULL;
	}
	CUPP_DragTrackingHandler(DragTrackingHandlerProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_DragTrackingHandler() {
		if (m_upp != NULL) {
			DisposeDragTrackingHandlerUPP(m_upp);
		}
	}
	operator DragTrackingHandlerUPP() {
		return GetUPP();
	}
	void SetUPP(DragTrackingHandlerProcPtr userRoutine) {
		m_upp = NewDragTrackingHandlerUPP(userRoutine);
	}
	DragTrackingHandlerUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_OTNotify {
public:
	OTNotifyUPP m_upp;
	CUPP_OTNotify() {
		m_upp = NULL;
	}
	CUPP_OTNotify(OTNotifyProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_OTNotify() {
		if (m_upp != NULL) {
			DisposeOTNotifyUPP(m_upp);
		}
	}
	operator OTNotifyUPP() {
		return GetUPP();
	}
	void SetUPP(OTNotifyProcPtr userRoutine) {
		m_upp = NewOTNotifyUPP(userRoutine);
	}
	OTNotifyUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_ThreadEntry {
public:
	ThreadEntryUPP m_upp;
	CUPP_ThreadEntry() {
		m_upp = NULL;
	}
	CUPP_ThreadEntry(ThreadEntryProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_ThreadEntry() {
		if (m_upp != NULL) {
			DisposeThreadEntryUPP(m_upp);
		}
	}
	operator ThreadEntryUPP() {
		return GetUPP();
	}
	void SetUPP(ThreadEntryProcPtr userRoutine) {
		m_upp = NewThreadEntryUPP(userRoutine);
	}
	ThreadEntryUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_ListDef {
public:
	ListDefUPP m_upp;
	CUPP_ListDef() {
		m_upp = NULL;
	}
	CUPP_ListDef(ListDefProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_ListDef() {
		if (m_upp != NULL) {
			DisposeListDefUPP(m_upp);
		}
	}
	operator ListDefUPP() {
		return GetUPP();
	}
	void SetUPP(ListDefProcPtr userRoutine) {
		m_upp = NewListDefUPP(userRoutine);
	}
	ListDefUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_EventLoopTimer {
public:
	EventLoopTimerUPP m_upp;
	CUPP_EventLoopTimer() {
		m_upp = NULL;
	}
	CUPP_EventLoopTimer(EventLoopTimerProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_EventLoopTimer() {
		if (m_upp != NULL) {
			DisposeEventLoopTimerUPP(m_upp);
		}
	}
	operator EventLoopTimerUPP() {
		return GetUPP();
	}
	void SetUPP(EventLoopTimerProcPtr userRoutine) {
		m_upp = NewEventLoopTimerUPP(userRoutine);
	}
	EventLoopTimerUPP GetUPP() {
		return m_upp;
	}
};

class CUPP_NM {
public:
	NMUPP m_upp;
	CUPP_NM() {
		m_upp = NULL;
	}
	CUPP_NM(NMProcPtr userRoutine) {
		SetUPP(userRoutine);
	}
	~CUPP_NM() {
		if (m_upp != NULL) {
			DisposeNMUPP(m_upp);
		}
	}
	operator NMUPP() {
		return GetUPP();
	}
	void SetUPP(NMProcPtr userRoutine) {
		m_upp = NewNMUPP(userRoutine);
	}
	NMUPP GetUPP() {
		return m_upp;
	}
};

#endif
