/*
	TWindow.h
	EBhENX
	w肵TWindowJg̃|[gɂ邽߂̃NX
	Jg|[g̃Nbv[WۑNX
	ʏ̃IuWFNg̊{NX
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.02.12	1.0			Takeshi Yoneki
*/

#ifndef	_CWINDOW_H_
#define	_CWINDOW_H_

#define	SCROLL_BAR_WIDTH	16
#define	MIN_WIN_SIZE		100
#define	WIN_RECT_PIX		5
#define	WIN_RECT_TOP		42

class TWindow;
class TSavePort;
class TSaveClipRgn;
class TControlBase;

/*
	TWindow
	EBhENX
	TListBaseł̃Xg̑ΏۂɂȂ
*/
class TWindow : public TAppleObject {
protected:
	WindowRef m_port;
	Boolean m_hasGrowIcon;
	TCFString m_name;
	Boolean m_activate;
	CUPP_DragReceiveHandler m_uppDragReceiveHandler;
	CUPP_DragTrackingHandler m_uppDragTrackingHandler;
	long m_prevClickTime;
	Point m_prevClickPoint;
	TRgn m_visRgn;
	TRgn m_flushRgn;
	Boolean m_enableDrag;
public:
	TRect m_growRect;
	TRect m_dragRect;
	TRect m_zoomRect;
	int m_depth;
	TWindow();
	~TWindow();
	void AppendChildControl(TControlBase *child);
	TWindow *GetNext() {
		return (TWindow *)TBase::GetNext();
	}
	TControlBase *GetTop() {
		return(TControlBase *)TListBase::GetTop();
	}
	TControlBase *WhichControl(TPoint mousePt);

	/* ȉvirtual\bh̓I[o[Ch̑ΏۂƂ */
	virtual void OnUpdate();
	virtual void OnActivate(Boolean act);
	virtual void OnDrag(Point where);
	virtual void OnContent(EventRecord *ev);
	virtual void OnGrow(Point where);
	virtual Boolean OnClose();
	virtual Boolean OnClose(const AppleEvent *aev);
	virtual Boolean OnGoAway(Point where);
	virtual void OnZoom(Point where, int partCode);
	virtual void OnChangeSize();
	virtual void OnTask();
	/* D&D */
	virtual OSErr DragReceiveHandler(WindowPtr wp, void *refCon, DragReference dragRef);
	virtual OSErr DragTrackingHandler(DragTrackingMessage message, WindowPtr wp, void *refCon, DragReference dragRef);
	/* ʏ̃\bh */
	TCFString& GetName() {
		return m_name;
	}
	void SetName(TCFString s) {
		m_name = s;
	}
	operator WindowRef() {
		return m_port;
	}
	operator CGrafPtr() {
		return ::GetWindowPort(m_port);
	}
	Boolean operator==(WindowRef win) {
		return m_port == win;
	}
	Boolean operator!=(WindowRef win) {
		return !operator==(win);
	}
	TRect GetPortRect() {
		TRect r;
		::GetWindowPortBounds(m_port, r);
		return r;
	}
	TRect GetPortRectGlobal();
	TPoint GetPositionGlobal();
	RgnHandle GetVisRgn() {
		::GetPortVisibleRegion(::GetWindowPort(m_port), (RgnHandle)m_visRgn);
		return m_visRgn;
	}
	const BitMap *GetPortBits() {
		return ::GetPortBitMapForCopyBits(::GetWindowPort(m_port));
	}
	void SetWindowUserState(Rect *r) {
		::SetWindowUserState(m_port, r);
	}
	void SetWindowStandardState(Rect *r) {
		::SetWindowStandardState(m_port, r);
	}
	void GetNewWindow(short windowID, WindowRef behind = (WindowRef)-1);
	void DisposeWindow() {
		::DisposeWindow(m_port);
		m_port = NULL;
	}
	void SetPort() {
		::SetPortWindowPort(m_port);
	}
	void GetWTitle(Str255 title) {
		::GetWTitle(m_port, title);
	}
	void SetWTitle(ConstStr255Param title) {
		::SetWTitle(m_port, title);
	}
	void SetWindowTitleWithCFString(CFStringRef s) {
		::SetWindowTitleWithCFString(m_port, s);
	}
	void SelectWindow();
	void HideWindow();
	void ShowWindow();
	void HiliteWindow(Boolean fHilite) {
		::HiliteWindow(m_port, fHilite);
	}
	void BringToFront() {
		::BringToFront(m_port);
	}
	void SendBehind(WindowRef theWindow, WindowRef behindWindow) {
		::SendBehind(m_port, behindWindow);
	}
	void DrawGrowIcon() {
		::DrawGrowIcon(m_port);
	}
	void DrawGrowIconOnly();
	void MoveWindow(short hGlobal, short vGlobal, Boolean front = FALSE) {
		::MoveWindow(m_port, hGlobal, vGlobal, front);
	}
	void SizeWindow(short w, short h, Boolean fUpdate = TRUE) {
		::SizeWindow(m_port, w, h, fUpdate);
	}
	void ZoomWindow(short partCode, Boolean front = FALSE) {
		::ZoomWindow(m_port, partCode, front);
	}
	void DragWindow(Point startPt, const Rect *boundsRect) {
		::DragWindow(m_port, startPt, boundsRect);
	}
	long GrowWindow(Point startPt, const Rect *bBox) {
		return ::GrowWindow(m_port, startPt, bBox);
	}
	void BeginUpdate() {
		::BeginUpdate(m_port);
	}
	void EndUpdate() {
		::EndUpdate(m_port);
	}
	void KillControls() {
		::KillControls(m_port);
	}
	void DrawControls() {
		::DrawControls(m_port);
	}
	void UpdateControls(RgnHandle updateRegion) {
		::UpdateControls(m_port, updateRegion);
	}
	ControlPartCode FindControl(Point thePoint, ControlRef *theControl) {
		return ::FindControl(thePoint, m_port, theControl);
	}
	Boolean TrackGoAway(Point thePt) {
		return ::TrackGoAway(m_port, thePt);
	}
	Boolean TrackBox(Point thePt, short partCode) {
		return ::TrackBox(m_port, thePt, partCode);
	}
	void SetFont(short fontNum);
	void SetFontSize(short fontSize);
	short GetFont() {
		return GetPortTextFont(::GetWindowPort(m_port));
	}
	short GetFontSize() {
		return GetPortTextSize(::GetWindowPort(m_port));
	}
	SInt16 GetKind() {
		return ::GetWindowKind(m_port);
	}
	void RGBBackColor(RGBColor *color);
	int CalcDepth();
	int GetDepth() {
		return m_depth;
	}
	TRect CalcNewWindowRect(int n, TRect userRect);
	Boolean IsDoubleClick(Point where, long when);
	void FlushPortBuffer(TRect r);
	void EnableDrag(Boolean enableDrag) {
		m_enableDrag = enableDrag;
	}
	OSErr SetAutomaticControlDragTrackingEnabledForWindow(Boolean tracks) {
		return ::SetAutomaticControlDragTrackingEnabledForWindow(m_port, tracks);
	}
	/* for AppleScript */
	virtual CFStringRef GetObjectName() {
		return GetName();
	}
	virtual DescType GetObjectType() {
		return cWindow;
	}
	virtual long GetObjectNumber();
	virtual TAppleObject *GetObjectProperty(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	virtual OSErr OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result);
};

class TWindowArray : public TArrayBase {
public:
	//	void Append(TWindow *win);
	//	void Remove(TWindow *win);
	TWindow *GetByWindowRef(WindowRef wref);
};

/*
	TSavePort
	w肵TWindowJg̃|[gɂ邽߂̎dg
	֐̐擪TSavePort savePort(this);ƋLqƂ̊֐̒ł
	JgOt|[gthisɂȂBȑÕ|[gۑA
	֐IɕAB
*/
class TSavePort {
private:
	GrafPtr m_savePort;
public:
	TSavePort(TWindow *cw = NULL);
	TSavePort(GrafPtr gp);
	~TSavePort();
};

/*
	TSaveClipRgn
	Jg|[g̃Nbv[Wۑdg
	֐̐擪TSaveClipRgn saveRgn;ƋLqƂ̊֐̒ł
	Nbv[Wɐݒ肵Ă֐IɕAB
*/
class TSaveClipRgn {
private:
	TRgn m_saveRgn;
	GrafPtr m_savePort;
public:
	TSaveClipRgn();
	TSaveClipRgn(TWindow *cw);
	~TSaveClipRgn();
};

/*
	TControlBase
	ʏ̃IuWFNg̊{NX
	ۂOnContent̉z֐̂߂ɂ
*/
class TControlBase : public TBase {
protected:
	TWindow *m_parent;
public:
	TControlBase() {
		m_parent = NULL;
	}
	TControlBase *GetNext() {
		return (TControlBase *)TBase::GetNext();
	}
	void SetParentWindow(TWindow *parent) {
		m_parent = parent;
	}
	TWindow *GetParentWindow() {
		return m_parent;
	}
	/* z֐ */
	/* }EX̃NbN */
	virtual void OnContent(EventRecord *ev);
	/* ANeBx[gCxg */
	virtual void OnActivate(Boolean act);
	/* Abvf[gCxg */
	virtual void OnUpdate();
	/* TCYύX */
	virtual short OnChangeSize(short top);
	virtual TPoint OnChangeSize(TPoint pt);		/* ͍WA߂l͕ƍ */
	/* ^XN */
	virtual void OnTask();
	/* }EX|C^̓Rg[ɂ邩 */
	virtual Boolean IsInside(TPoint mousePt);
	/* }EXJ[\ύX */
	virtual void OnMouseCursor(TPoint mousePt);
};

/*
	ėpItXN[NX
*/
class TOffScreen {
public:
	GWorldPtr m_world;
	int m_pixelDepth;
	TRect m_boundsRect;
	CGrafPtr m_savePort;
	GDHandle m_saveDevice;
	Boolean m_good;
	TOffScreen();
	~TOffScreen();
	GrafPtr BeginDraw();
	void EndDraw();
	TRect GetBoundsRect() {
		return m_boundsRect;
	}
	GrafPtr GetOffPort() {
		return (GrafPtr)m_world;
	}
	GrafPtr GetSavePort() {
		return (GrafPtr)m_savePort;
	}
	const BitMap *GetOffPortBits() {
		return ::GetPortBitMapForCopyBits(m_world);
	}
	const BitMap *GetSavePortBits() {
		return ::GetPortBitMapForCopyBits(m_savePort);
	}
	QDErr NewGWorld(short PixelDepth, const Rect *boundsRect, CTabHandle cTable = 0, GDHandle aGDevice = 0, GWorldFlags flags = 0);
	void DisposeGWorld();
	void ChangeSize(const Rect *r);
};

#endif
