/*
	MEdit.cpp
 
	NasuTen
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.03.03	1.0			Takeshi Yoneki
*/

#include "nglobal.h"

#define	STRNUM_UNDO		4
#define	STRNUM_REDO		5

#define STRNUM_TITLE2FILE			3
#define STRNUM_TITLE2FILEALL		4
#define STRNUM_FILE2TITLE			5
#define STRNUM_FILE2TITLEALL		6
#define STRNUM_TRACKFILE			7
#define STRNUM_TRACKFILEALL			8
#define STRNUM_TRACKTITLE			9
#define STRNUM_TRACKTITLEALL		10
#define STRNUM_PARENT2ALBUM			13
#define STRNUM_PARENT2ALBUMALL		14
#define STRNUM_GRANPA2ARTIST		15
#define STRNUM_GRANPA2ARTISTALL		16

MEdit::MEdit() {
	m_undoStr = "Undo";
	m_redoStr = "Redo";
	strcpy(m_enable, "EE-EEEE-EEEE-EEE");

	m_title2fileStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_TITLE2FILE);
	m_title2fileAllStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_TITLE2FILEALL);
	m_file2titleStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_FILE2TITLE);
	m_file2titleAllStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_FILE2TITLEALL);
	m_parent2albumStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_PARENT2ALBUM);
	m_parent2albumAllStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_PARENT2ALBUMALL);
	m_granpa2artistStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_GRANPA2ARTIST);
	m_granpa2artistAllStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_GRANPA2ARTISTALL);
	m_trackFileStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_TRACKFILE);
	m_trackFileAllStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_TRACKFILEALL);
	m_trackTitleStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_TRACKTITLE);
	m_trackTitleAllStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_TRACKTITLEALL);
}

void MEdit::FixMenu() {
	char save[32];
	strcpy(save, m_enable);

	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL) {
		m_enable[UNDO_ITEM] = 'E';
		m_enable[CUT_ITEM] = 'E';
		m_enable[COPY_ITEM] = 'E';
		m_enable[PASTE_ITEM] = 'E';
		m_enable[CLEAR_ITEM] = 'E';

		m_enable[COPY_TITLE2FILE_ITEM] = 'D';
		m_enable[COPY_FILE2TITLE_ITEM] = 'D';
		m_enable[COPY_PARENT2ALBUM_ITEM] = 'D';
		m_enable[COPY_GRANPA2ARTIST_ITEM] = 'D';
		m_enable[AUTO_TRACK_ITEM] = 'D';
		m_enable[TRACK_FILE_ITEM] = 'D';
		m_enable[TRACK_TITLE_ITEM] = 'D';

		m_menu->EnableMenuItemByList(m_enable, save);
		return;
	}

	m_enable[UNDO_ITEM] = view->m_titleBox.m_browser.EnableDataBrowserEditCommand(kDataBrowserEditMsgUndo) ? 'E' : 'D';
	m_enable[CUT_ITEM] = view->m_titleBox.m_browser.EnableDataBrowserEditCommand(kDataBrowserEditMsgCut) ? 'E' : 'D';
	m_enable[COPY_ITEM] = view->m_titleBox.m_browser.EnableDataBrowserEditCommand(kDataBrowserEditMsgCopy) ? 'E' : 'D';
	m_enable[PASTE_ITEM] = view->m_titleBox.m_browser.EnableDataBrowserEditCommand(kDataBrowserEditMsgPaste) ? 'E' : 'D';
	m_enable[CLEAR_ITEM] = view->m_titleBox.m_browser.EnableDataBrowserEditCommand(kDataBrowserEditMsgClear) ? 'E' : 'D';

	m_menu->SetMenuItemText(UNDO_ITEM, m_undoTags.m_undoCommand > DIFF_UNDO_REDO ? m_redoStr : m_undoStr);
	m_enable[UNDO_ITEM] = m_undoTags.m_undoCommand == UNDO_CMD_NON ? 'D' : 'E';

	m_enable[COPY_TITLE2FILE_ITEM] = 'E';
	m_enable[COPY_FILE2TITLE_ITEM] = 'E';
	m_enable[COPY_PARENT2ALBUM_ITEM] = 'E';
	m_enable[COPY_GRANPA2ARTIST_ITEM] = 'E';
	m_enable[AUTO_TRACK_ITEM] = 'E';
	m_enable[TRACK_FILE_ITEM] = 'E';
	m_enable[TRACK_TITLE_ITEM] = 'E';

	NTag *tag = view->m_tagList.GetBySelection();
	if (tag != NULL) {
		m_menu->SetMenuItemText(COPY_TITLE2FILE_ITEM, m_title2fileStr);
		m_menu->SetMenuItemText(COPY_FILE2TITLE_ITEM, m_file2titleStr);
		m_menu->SetMenuItemText(COPY_PARENT2ALBUM_ITEM, m_parent2albumStr);
		m_menu->SetMenuItemText(COPY_GRANPA2ARTIST_ITEM, m_granpa2artistStr);
		m_menu->SetMenuItemText(TRACK_FILE_ITEM, m_trackFileStr);
		m_menu->SetMenuItemText(TRACK_TITLE_ITEM, m_trackTitleStr);
	}
	else {
		m_menu->SetMenuItemText(COPY_TITLE2FILE_ITEM, m_title2fileAllStr);
		m_menu->SetMenuItemText(COPY_FILE2TITLE_ITEM, m_file2titleAllStr);
		m_menu->SetMenuItemText(COPY_PARENT2ALBUM_ITEM, m_parent2albumAllStr);
		m_menu->SetMenuItemText(COPY_GRANPA2ARTIST_ITEM, m_granpa2artistAllStr);
		m_menu->SetMenuItemText(TRACK_FILE_ITEM, m_trackFileAllStr);
		m_menu->SetMenuItemText(TRACK_TITLE_ITEM, m_trackTitleAllStr);
	}

	m_menu->EnableMenuItemByList(m_enable, save);
}

void MEdit::Command(short item) {
	if (item >= UNDO_ITEM && item <= CLEAR_ITEM) {
		if (theSystem->SystemEdit(item - 1))
			return;
	}

	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL)
		return;

	if (item == UNDO_ITEM) {
		m_undoTags.OnUndo();
		return;
	}

	if (item == AUTO_TRACK_ITEM) {
		view->m_tagList.SetUndo(UNDO_CMD_AUTOTRACK);
		view->m_titleBox.SetAutoTrack();
		return;
	}

	if (item >= CUT_ITEM && item <= CLEAR_ITEM) {
		switch(item) {
		case CUT_ITEM:
			view->m_titleBox.m_browser.ExecuteDataBrowserEditCommand(kDataBrowserEditMsgCut);
			break;
		case COPY_ITEM:
			view->m_titleBox.m_browser.ExecuteDataBrowserEditCommand(kDataBrowserEditMsgCopy);
			break;
		case PASTE_ITEM:
			view->m_titleBox.m_browser.ExecuteDataBrowserEditCommand(kDataBrowserEditMsgPaste);
			break;
		case CLEAR_ITEM:
			view->m_titleBox.m_browser.ExecuteDataBrowserEditCommand(kDataBrowserEditMsgClear);
			break;
		}
	}

	NTag *tag = view->m_tagList.GetBySelection();
	if (tag == NULL) {
		switch(item) {
		case COPY_TITLE2FILE_ITEM:
			view->m_tagList.SetUndo(UNDO_CMD_TITLE2FILE_ALL);
			view->m_tagList.CopyTitle2FileName();
			break;
		case COPY_FILE2TITLE_ITEM:
			view->m_tagList.SetUndo(UNDO_CMD_FILE2TITLE_ALL);
			view->m_tagList.CopyFileName2Title();
			break;
		case COPY_PARENT2ALBUM_ITEM:
			view->m_tagList.SetUndo(UNDO_CMD_PARENT2ALBUM_ALL);
			view->m_tagList.CopyParent2Album();
			break;
		case COPY_GRANPA2ARTIST_ITEM:
			view->m_tagList.SetUndo(UNDO_CMD_GRANPA2ARTIST_ALL);
			view->m_tagList.CopyGranpa2Artist();
			break;
		case TRACK_FILE_ITEM:
			view->m_tagList.SetUndo(UNDO_CMD_TRACK_FILE_ALL);
			view->m_tagList.PlusTrackFileName();
			break;
		case TRACK_TITLE_ITEM:
			view->m_tagList.SetUndo(UNDO_CMD_TRACK_TITLE_ALL);
			view->m_tagList.PlusTrackTitle();
			break;
		}
	}
	else {
		switch(item) {
		case COPY_TITLE2FILE_ITEM:
			tag->SetUndo(UNDO_CMD_TITLE2FILE);
			tag->CopyTitle2FileName();
			break;
		case COPY_FILE2TITLE_ITEM:
			tag->SetUndo(UNDO_CMD_FILE2TITLE);
			tag->CopyFileName2Title();
			break;
		case COPY_PARENT2ALBUM_ITEM:
			tag->SetUndo(UNDO_CMD_PARENT2ALBUM);
			tag->CopyParent2Album();
			break;
		case COPY_GRANPA2ARTIST_ITEM:
			tag->SetUndo(UNDO_CMD_GRANPA2ARTIST);
			tag->CopyGranpa2Artist();
			break;
		case TRACK_FILE_ITEM:
			tag->SetUndo(UNDO_CMD_TRACK_FILE);
			tag->PlusTrackFileName();
			break;
		case TRACK_TITLE_ITEM:
			tag->SetUndo(UNDO_CMD_TRACK_TITLE);
			tag->PlusTrackTitle();
			break;
		}
	}
}

NTagUndo::NTagUndo() {
	SetUndoNon();
}

void NTagUndo::SetUndoNon() {
	m_view = NULL;
	m_undoCommand = UNDO_CMD_NON;
	ChangeCount(0);
}

void NTagUndo::SetOneUndoTag(NView *view, int cmd, NTag *tag) {
	if (view == NULL || tag == NULL || cmd == UNDO_CMD_NON) {
		m_view = NULL;
		m_undoCommand = UNDO_CMD_NON;
	}
	else {
		m_view = view;
		m_undoCommand = cmd;
		ChangeCount(1);
		SetNth(0, tag);
		tag->CopyToUndoBuffer();
	}
}

void NTagUndo::SetAllUndoTags(NView *view, int cmd, NTagList *tagList) {
	if (view == NULL || tagList == NULL || cmd == UNDO_CMD_NON || tagList->GetCount() == 0) {
		m_view = NULL;
		m_undoCommand = UNDO_CMD_NON;
	}
	else {
		m_view = view;
		m_undoCommand = cmd;
		ChangeCount(tagList->GetCount());
		NTag *tag = tagList->GetTop();
		for (int i = 0; tag != NULL && i < tagList->GetCount(); tag = tag->GetNext(), i++) {
			SetNth(i, tag);
			tag->CopyToUndoBuffer();
		}
	}
}


void NTagUndo::OnUndo() {
	if (m_view == NULL || m_undoCommand == UNDO_CMD_NON || GetCount() == 0)
		return;
	for (int i = 0; i < GetCount(); i++) {
		NTag *tag = (*this)[i];
		if (m_undoCommand < DIFF_UNDO_REDO) {
			tag->CopyToRedoBuffer();
			tag->CopyFromUndoBuffer();
		}
		else {
			tag->CopyFromRedoBuffer();
		}
		m_view->m_titleBox.m_browser.UpdateDataBrowserItems(0, 1, (DataBrowserItemID *)&tag, kDataBrowserItemNoProperty, kDataBrowserNoItem);
	}
	if (m_undoCommand < DIFF_UNDO_REDO)
		m_undoCommand += DIFF_UNDO_REDO;
	else
		m_undoCommand -= DIFF_UNDO_REDO;
}

