/*
	MFile.cpp
 
	Copyright (C) 2000 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 2000.02.27 Takeshi Yoneki
*/

#include "nglobal.h"

#ifdef __MWERKS__
#define	APPL_NAME					"ID3TagEdit 2.0 CFM Carbon"
#else
#define	APPL_NAME					"ID3TagEdit 2.0 Mach-O Carbon"
#endif
#define	ABOUT_COLOR_DLG				134
#define	ABOUT_BW__DLG				137
#define	VERSION_DITEM				1

#define STRNUM_OPEN					2
#define STRNUM_IMPORTTSV			11
#define STRNUM_EXPORTTSV			12

MApple::MApple() {
}

void MApple::FixMenu() {
}

void MApple::Command(short item) {
	if (item == ABOUT_ITEM) {
		int dialogNumber = ABOUT_BW__DLG;
		if (theSystem->hasColorQD) {
			GDHandle gdev = GetMainDevice();
			if ((**(**gdev).gdPMap).pixelSize > 2)
				dialogNumber = ABOUT_COLOR_DLG;
		}
		TDialog dlg(dialogNumber);
//		TFont chicago("Chicago");
//		dlg.SetFont(chicago);
		dlg.SetDIText(VERSION_DITEM, APPL_NAME);
		dlg.DrawDialog();
		for (;;) {
			EventRecord ev;
			if (GetNextEvent(everyEvent, &ev) == TRUE)
				if (ev.what == mouseDown)
					break;
		}
		for (;;) {
			if (StillDown() == FALSE)
				break;
		}
		FlushEvents(everyEvent, 0);
	}
	else {
		TString name = m_menu->GetMenuItemText(item);
		TSavePort savePort(theMain->WhichWindow(FrontWindow()));
		theSystem->OpenDeskAcc(name);
	}
}

MFile::MFile() {
	m_quit = FALSE;
	strcpy(m_enable, "EEEEE-EEE-E-E");
	m_openStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_OPEN);
	m_importTSVStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_IMPORTTSV);
	m_exportTSVStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_EXPORTTSV);
	m_fdTypeList.LoadStrNumAll(STRNUM_ID_FDTYPE);
}

void MFile::FixMenu() {
	char save[32];
	strcpy(save, m_enable);

	TWindow *win = theMWindow->WhichWindow(FrontWindow());
	if (win == NULL) {
		m_enable[CLOSE_ITEM] = 'D';
		m_enable[ADD_ITEM] = 'D';
		m_enable[SAVE_ITEM] = 'D';
		m_enable[EXPORTTSV_ITEM] = 'D';
		m_enable[IMPORTTSV_ITEM] = 'D';
	}
	else {
		NView *view = (NView *)win;
		m_enable[CLOSE_ITEM] = 'E';
		m_enable[ADD_ITEM] = 'E';
		Boolean modify = FALSE;
		for (NTag *tag = view->m_tagList.GetTop(); tag != NULL; tag = tag->GetNext()) {
			if (tag->m_modify)
				modify = TRUE;
		}
		m_enable[SAVE_ITEM] = modify ? 'E' : 'D';
		m_enable[EXPORTTSV_ITEM] = view->m_tagList.GetCount() > 0 ? 'E' : 'D';
		m_enable[IMPORTTSV_ITEM] = view->m_tagList.GetCount() > 0 ? 'E' : 'D';
	}
	m_menu->EnableMenuItemByList(m_enable, save);
}

void MFile::Command(short item) {
	switch (item) {
	case NEW_ITEM:
		OnNew();
		break;
	case OPEN_ITEM:
		OnOpen();
		break;
	case PREF_ITEM:
		OnPref();
		break;
	case QUIT_ITEM:
		OnQuit();
		break;
	}

	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL)
		return;

	switch (item) {
	case ADD_ITEM:
		OnAdd(view);
		break;
	case SAVE_ITEM:
		OnSave(view);
		break;
	case EXPORTTSV_ITEM:
		OnExportTSV(view);
		break;
	case IMPORTTSV_ITEM:
		OnImportTSV(view);
		break;
	case CLOSE_ITEM:
		OnClose(view);
		break;
	}
}

class NStandardFile : public TStandardFile {
public:
	NStandardFile(TDirectory dir)
			:TStandardFile(dir) {
	}
	virtual Boolean Filter(TStandardFileFilterItemInfo& info) {
		if (info.m_isFolder)
			return TRUE;
		return TRUE;
	}
};

class NOpenStandardFile : public TStandardFileDirectory {
public:
	NTagList *m_tagList;
	/* TStandardFile's virtual function */
	NOpenStandardFile(TDirectory dir, NTagList *tagList = NULL)
			:TStandardFileDirectory(dir) {
		m_tagList = tagList;
	}
	virtual Boolean Filter(TStandardFileFilterItemInfo& info);
};

Boolean NOpenStandardFile::Filter(TStandardFileFilterItemInfo& info) {
	if (info.m_isFolder)
		return TRUE;
	return theMFile->OpenFileFilter(m_tagList, TFilePath(info.m_name, info.m_dir), info.m_fdType);
}

NView *MFile::OnNew() {
	NView *view = new NView;
	theMWindow->AppendWindow(view);
	return view;
}

class NSaveAsStandardFile : public TStandardFile {
public:
	/* TStandardFile's virtual function */
	NSaveAsStandardFile(TDirectory dir)
			:TStandardFile(dir) {
	}
	virtual Boolean Filter(TStandardFileFilterItemInfo& info) {
		if (info.m_isFolder)
			return TRUE;
		return theMFile->FileFilter(info.m_name, info.m_fdType);
	}
};

Boolean MFile::FileFilter(TUniString name, OSType fdType) {
	TString fdTypeStr;
	fdTypeStr = fdType;
	for (TString *tp = m_fdTypeList.GetTop(); tp != NULL; tp = tp->GetNext()) {
		if (*tp == fdTypeStr)
			return TRUE;
	}
	TUniString ext = ".mp3";
	if (name.GetLength() > ext.GetLength()) {
		UniChar *cmp = name;
		int lengDiff = name.GetLength() - ext.GetLength();
		TUniString edge;
		edge.CopyFromUSTR(&cmp[lengDiff], ext.GetLength());
		if (edge.EqualsIgnoreCase(ext))
			return TRUE;
	}
	return FALSE;
}

Boolean MFile::OpenFileFilter(NTagList *tagList, TFilePath filePath, OSType fdType) {
	if (tagList != NULL) {
		if (tagList->GetByFilePath(filePath) != NULL)
			return FALSE;
	}
	return FileFilter(filePath.m_fileName, fdType);
}

NView *MFile::OpenFiles(TStandardFileReplyList *fileList) {
	NView *view = new NView;
	theMWindow->AppendWindow(view);
	return AddFiles(view, fileList);
}

NView *MFile::OnOpen() {
	NOpenStandardFile std(TDirectory(thePref->m_volume, thePref->m_dirID));
	std.GetFile(m_openStr, TRUE);
	if (std.IsGood() == FALSE)
		return NULL;

	////////////////////////////////
	/*
		TFilePath filePath = std.GetFilePath();
		TFSSpec spec(filePath);
		TFSSpec parent(filePath.m_dir);
	 
		TString s = spec.GetLongName();
	 
		filePath.m_fileName = s;
		TFSSpec sp2(filePath);	
	 
		TUnicodeTextEncodingInfo ei(FontToScript(0));
		TMemory buffer;
		ei.TextToUnicode(BOM_BIG, &buffer, filePath.m_fileName);
	 
		FSRef newRef;
		memset(&newRef, 0, sizeof (newRef));
		OSErr err = FSMakeFSRefUnicode (parent, buffer.GetLength() / 2,
			(UniChar *)(char *)buffer,
			FontToScript(0),
			&newRef);
	 
		FSCatalogInfo ci;
		memset(&ci, 0, sizeof (ci));
		HFSUniStr255 longName;
		memset(&longName, 0, sizeof (longName));
		err = ::FSGetCatalogInfo(&newRef, kFSCatInfoGettableInfo, &ci, &longName, NULL, NULL);
	 
		int x = 0;
	*/
	////////////////////////////////

	return OpenFiles(&std);
}

NView *MFile::AddFiles(NView *view, TStandardFileReplyList *fileList) {
	view->m_tagList.AppendFiles(fileList);

	/* window title */
	if (view->GetName().IsEmpty()) {
		NTag *tag = view->m_tagList.GetTop();
		if (tag != NULL) {
			TCFString t = tag->m_filePath.m_dir.GetDirName();
			t.SetScriptCode(view->m_scriptCode);
			view->ChangeWindowTitle(t);
		}

	}

	return view;
}

NView *MFile::OnAdd(NView *view) {
	NOpenStandardFile std(TDirectory(thePref->m_volume, thePref->m_dirID), &view->m_tagList);
	std.GetFile(m_openStr, TRUE);
	if (std.IsGood() == FALSE)
		return NULL;
	return AddFiles(view, &std);
}

void MFile::OnSave(NView *view) {
	view->m_tagList.SaveFiles();
}

Boolean MFile::OnExportTSV(NView *view) {
	int count = view->m_tagList.MakeOrderArray();
	if (count == 0)
		return FALSE;
	TStandardFile std(TDirectory(thePref->m_tsvVolume, thePref->m_tsvDirID));
	TCFString orgName = view->GetName() + ".tsv";
//	orgName.sprintf("%s.tsv", (char *)view->GetName());
	std.PutFile(m_exportTSVStr, orgName);
	if (std.IsGood() == FALSE)
		return FALSE;
	TFilePath path = std.GetFilePath();
	view->m_tagList.ExportTSV(path);
	thePref->m_tsvVolume = path.m_dir.m_volume;
	thePref->m_tsvDirID = path.m_dir.m_dirID;
	return TRUE;
}

Boolean MFile::OnImportTSV(NView *view) {
	int count = view->m_tagList.MakeOrderArray();
	if (count == 0)
		return FALSE;
	TStandardFile std(TDirectory(thePref->m_tsvVolume, thePref->m_tsvDirID));
	std.GetFile(m_importTSVStr);
	if (std.IsGood() == FALSE)
		return FALSE;
	TFilePath path = std.GetFilePath();
	view->m_tagList.ImportTSV(path);
	thePref->m_tsvVolume = path.m_dir.m_volume;
	thePref->m_tsvDirID = path.m_dir.m_dirID;
	return TRUE;
}

void MFile::OnClose(NView *view) {
	if (view->OnClose(NULL))
		theMWindow->KillWindow(view);
}

#define	PREF_DLG					131
#define SAVEENC_DITEM				3
#define TAGVERSION_DITEM			4
#define LANG_DITEM					5
#define EXCEPTCMT_DITEM				6
#define TRACKFILE1_DITEM			7
#define TRACKFILE2_DITEM			8
#define TRACKFILE3_DITEM			9
#define TRACKFILESPC_DITEM			10
#define TRACKTITLE1_DITEM			11
#define TRACKTITLE2_DITEM			12
#define TRACKTITLE3_DITEM			13
#define TRACKTITLESPC_DITEM			14
#define DIRECTEDIT_DITEM			21
#define FILENAMETSV_DITEM			22

void MFile::OnPref() {
	int i;
	TDialog dlg(PREF_DLG);
	NTag tagModify(NULL);
	tagModify.m_saveEnc = thePref->m_defaultSaveEnc;
	tagModify.m_version = thePref->m_defaultVersion;
	int trackFileFig = TRACKFILE1_DITEM + thePref->m_trackFileFig - 1;
	int trackFileSpc = thePref->m_trackFileSpc;
	int trackTitleFig = TRACKTITLE1_DITEM + thePref->m_trackTitleFig - 1;
	int trackTitleSpc = thePref->m_trackTitleSpc;
	int exceptComment = thePref->m_exceptComment;
	int enableFileNameTSV = thePref->m_enableFileNameTSV;

	int saveEncItem = thePref->m_defaultSaveEnc + (AS_IS_ITEM - CODE_AS_IS);
	int versionItem = thePref->m_defaultVersion + (VERSION_1_0_ITEM - TAG_VERSION_1_0);
	int directEdit = thePref->m_directEdit;

	dlg.SetDIValue(SAVEENC_DITEM, saveEncItem);
	dlg.SetDIValue(TAGVERSION_DITEM, versionItem);
	dlg.SetDIText(LANG_DITEM, thePref->m_commentLanguage);
	for (i = TRACKFILE1_DITEM; i <= TRACKFILE3_DITEM; i++)
		dlg.SetDIValue(i, i == trackFileFig);
	for (i = TRACKTITLE1_DITEM; i <= TRACKTITLE3_DITEM; i++)
		dlg.SetDIValue(i, i == trackTitleFig);
	dlg.SetDIValue(TRACKFILESPC_DITEM, trackFileSpc);
	dlg.SetDIValue(TRACKTITLESPC_DITEM, trackTitleSpc);
	dlg.SetDIValue(EXCEPTCMT_DITEM, exceptComment);
	if (EnableDirectEdit() == FALSE)
		dlg.SetDIHilite(DIRECTEDIT_DITEM, 255);
	else
		dlg.SetDIValue(DIRECTEDIT_DITEM, directEdit);
	dlg.SetDIValue(FILENAMETSV_DITEM, enableFileNameTSV);

	int itemHit;
	for (;;) {
		theMDSaveEnc->FixMenuForDialog(&tagModify);
		theMDVersion->FixMenuForDialog();
		itemHit = dlg.ModalDialog();
		if (itemHit == SAVEENC_DITEM) {
			saveEncItem = dlg.GetDIValue(SAVEENC_DITEM);
			theMDSaveEnc->OnSaveEnc(saveEncItem, &tagModify);
		}
		else if (itemHit == TAGVERSION_DITEM) {
			versionItem = dlg.GetDIValue(TAGVERSION_DITEM);
			theMDVersion->OnVersion(versionItem, &tagModify);
			saveEncItem = tagModify.m_saveEnc + (AS_IS_ITEM - CODE_AS_IS);
			dlg.SetDIValue(SAVEENC_DITEM, saveEncItem);
		}
		else if (itemHit >= TRACKFILE1_DITEM && itemHit <= TRACKFILE3_DITEM) {
			trackFileFig = itemHit;
			for (i = TRACKFILE1_DITEM; i <= TRACKFILE3_DITEM; i++)
				dlg.SetDIValue(i, i == trackFileFig);
		}
		else if (itemHit >= TRACKTITLE1_DITEM && itemHit <= TRACKTITLE3_DITEM) {
			trackTitleFig = itemHit;
			for (i = TRACKTITLE1_DITEM; i <= TRACKTITLE3_DITEM; i++)
				dlg.SetDIValue(i, i == trackTitleFig);
		}
		else if (itemHit == TRACKFILESPC_DITEM) {
			trackFileSpc = 1 - trackFileSpc;
			dlg.SetDIValue(TRACKFILESPC_DITEM, trackFileSpc);
		}
		else if (itemHit == TRACKTITLESPC_DITEM) {
			trackTitleSpc = 1 - trackTitleSpc;
			dlg.SetDIValue(TRACKTITLESPC_DITEM, trackTitleSpc);
		}
		else if (itemHit == EXCEPTCMT_DITEM) {
			exceptComment = 1 - exceptComment;
			dlg.SetDIValue(EXCEPTCMT_DITEM, exceptComment);
		}
		else if (itemHit == FILENAMETSV_DITEM) {
			enableFileNameTSV = 1 - enableFileNameTSV;
			dlg.SetDIValue(FILENAMETSV_DITEM, enableFileNameTSV);
		}
		else if (itemHit == DIRECTEDIT_DITEM) {
			directEdit = 1 - directEdit;
			dlg.SetDIValue(DIRECTEDIT_DITEM, directEdit);
		}
		else if (itemHit == DEFAULT_OK_DITEM || itemHit == DEFAULT_CANCEL_DITEM)
			break;
	}
	if (itemHit != DEFAULT_OK_DITEM)
		return;

	TString s = dlg.GetDIText(LANG_DITEM);
	s.CopyTo(thePref->m_commentLanguage, 3);

	thePref->m_defaultSaveEnc = saveEncItem - (AS_IS_ITEM - CODE_AS_IS);
	thePref->m_defaultVersion = versionItem - (VERSION_1_0_ITEM - TAG_VERSION_1_0);
	thePref->m_trackFileFig = trackFileFig - TRACKFILE1_DITEM + 1;
	thePref->m_trackTitleFig = trackTitleFig - TRACKTITLE1_DITEM + 1;
	thePref->m_trackFileSpc = trackFileSpc;
	thePref->m_trackTitleSpc = trackTitleSpc;
	thePref->m_exceptComment = exceptComment;
	if (thePref->m_directEdit != directEdit) {
		thePref->m_directEdit = directEdit;
		NView *view = (NView *)theMWindow->GetTop();
		for (; view != NULL; view = view->GetNext())
			view->m_titleBox.ChangeDirectEdit();
	}
	thePref->m_enableFileNameTSV = enableFileNameTSV;
}

void MFile::OnQuit(const AppleEvent *aev) {
	for (; theMWindow->GetCount() > 0;) {
		TWindow *win = theMWindow->GetLast();
		if (win->OnClose(aev) == FALSE)
			return;
		theMWindow->KillWindow(win);
	}
	m_quit = TRUE;
}

