/*
	MID3.cpp
 
	Copyright (C) 2002 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 2002.02.10 Takeshi Yoneki
*/

#include "nglobal.h"

#define	STRNUM_ALLFILES			1

MID3::MID3() {
	strcpy(m_enable, "EEEEEE-EE-EE");
	m_allFilesStr.LoadSTRNum(STRNUM_ID_MISC, STRNUM_ALLFILES);
}

void MID3::FixMenu() {
	char save[32];
	strcpy(save, m_enable);

	m_enable[LOAD_ENC_ITEM] = 'D';
	m_enable[SAVE_ENC_ITEM] = 'D';
	m_enable[GENRE_ITEM] = 'D';
	m_enable[VERSION_ITEM] = 'D';
	m_enable[EDIT_ITEM] = 'D';
	m_enable[EDIT_ALL_ITEM] = 'D';
	m_enable[FONT_ITEM] = 'D';
	m_enable[SIZE_ITEM] = 'D';

	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL) {
	}
	else {
		if (view->m_tagList.GetBySelection() != NULL) {
			m_enable[LOAD_ENC_ITEM] = 'E';
			m_enable[SAVE_ENC_ITEM] = 'E';
			m_enable[GENRE_ITEM] = 'E';
			m_enable[VERSION_ITEM] = 'E';
			m_enable[EDIT_ITEM] = 'E';
		}
		if (view->m_tagList.GetCount() > 0)
			m_enable[EDIT_ALL_ITEM] = 'E';
		m_enable[FONT_ITEM] = 'E';
		m_enable[SIZE_ITEM] = 'E';
	}
	m_menu->EnableMenuItemByList(m_enable, save);
}

void MID3::Command(short item) {
	if (item == GENRE_SETUP_ITEM) {
		OnGenreSetup();
		return;
	}

	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL)
		return;

	switch (item) {
		//	case AUTO_TRACK_ITEM:
		//		view->m_titleBox.SetAutoTrack();
		//		break;
	case EDIT_ITEM:
		OnEdit(&view->m_tagList, view->m_tagList.GetBySelection());
		break;
	case EDIT_ALL_ITEM:
		OnEdit(&view->m_tagList, NULL);
		break;
	}
}

#define GENRE_EDIT_DLG			133
#define BROWSER_DITEM			3
//#define RELOAD_DITEM			4

#define	COLMN_ID_CHECK			6001
#define	COLMN_ID_NAME			6002

class NGenreSetupDlg : public TDialog {
public:
	unsigned char m_useGenre[256];
	NGenreRecList m_genres;
	TDataBrowserControl m_browser;
	TRect m_boxRect;
	NGenreSetupDlg(short dialogID)
			: TDialog(dialogID) {
	}
	virtual Boolean DialogFilter(DialogRef dref, EventRecord *ev, short *itemHit);
	virtual void UpdateCallback();
};

Boolean NGenreSetupDlg::DialogFilter(DialogRef dref, EventRecord *ev, short *itemHit) {
	TSavePort savePort(this);

	Boolean flg = FALSE;
	if (ev->what == keyDown) {
		flg = TRUE;
		Boolean command = (ev->modifiers & cmdKey) != 0;
		int code = (ev->message & charCodeMask);
		if ((command && code == '.') ||
		        (command && (code == 'c' || code == 'C')) ||
		        code == 0x1B)
			*itemHit = DEFAULT_CANCEL_DITEM;
		else if ((command && (code == 's' || code == 'S')) ||
		         code == 0x0D ||
		         code == 0x03)
			*itemHit = DEFAULT_OK_DITEM;
		else {
			ControlPartCode part = m_browser.HandleControlKey((ev->message & keyCodeMask) >> 8, ev->message & charCodeMask, ev->modifiers);
			flg = FALSE;
		}
		if (flg)
			SetDIHilite(*itemHit, 1);
	}
	else if (ev->what == mouseDown) {
		TPoint mousePt = ev->where;
		mousePt.GlobalToLocal();
		ControlPartCode part = m_browser.HandleControlClick(mousePt, ev->modifiers, NULL);
	}
	else if (ev->what == updateEvt) {
		if (dref == (DialogRef)ev->message) {
			OnUpdate();
			m_browser.UpdateControls(*this, GetVisRgn());
		}
		else
			Update(ev->message);
	}

	return flg;
}

void NGenreSetupDlg::UpdateCallback() {
	TSavePort(this);
	m_boxRect.FrameRectOut();
}

static pascal OSStatus NGenreSetupDlg_GetSetItemDataCallback(ControlRef ctrl,
        DataBrowserItemID itemID, DataBrowserPropertyID property,
        DataBrowserItemDataRef itemData, Boolean changeValue) {
	NGenreSetupDlg *dlg = (NGenreSetupDlg *)::GetControlReference(ctrl);
	TDataBrowserControl browser(ctrl);
	NGenreRec *genre = (NGenreRec *)itemID;
	if (changeValue) {
		if (property == COLMN_ID_CHECK) {
			ThemeButtonValue value;
			browser.GetDataBrowserItemDataButtonValue(itemData, &value);
			dlg->m_useGenre[genre->m_number] = (value == kControlCheckBoxCheckedValue ? 1 : 0);
		}
	}
	else {
		if (property == COLMN_ID_CHECK) {
			browser.SetDataBrowserItemDataButtonValue(itemData,
			        dlg->m_useGenre[genre->m_number] != 0 ? kControlCheckBoxCheckedValue : kControlCheckBoxUncheckedValue);
		}
		else if (property == COLMN_ID_NAME) {
			TString s;
			s.sprintf("%d : %s", genre->m_number, (char *)genre->m_name);
			browser.SetDataBrowserItemDataText(itemData, s);
		}
		else if (property == kDataBrowserItemIsEditableProperty) {
			browser.SetDataBrowserItemDataBooleanValue(itemData, TRUE);
		}
	}
	return noErr;
}

void MID3::OnGenreSetup() {
	NGenreSetupDlg dlg(GENRE_EDIT_DLG);
	TControl rootControl;
	memcpy(dlg.m_useGenre, thePref->m_useGenre, 256);
	short itemType;
	dlg.GetDialogItem(BROWSER_DITEM, &itemType, dlg.m_boxRect);
	rootControl.CreateRootControl(dlg);
	dlg.m_browser.CreateDataBrowserControl(dlg, dlg.m_boxRect, kDataBrowserListView);
	dlg.m_browser.SetControlReference((UInt32)&dlg);
	Boolean frameAndFocus = false;
	dlg.m_browser.SetControlData(kControlNoPart, kControlDataBrowserIncludesFrameAndFocusTag, sizeof(frameAndFocus), &frameAndFocus);
	dlg.m_browser.SetDataBrowserHasScrollBars(FALSE, TRUE);

	DataBrowserCallbacks callbacks;
	callbacks.version = kDataBrowserLatestCallbacks;
	InitDataBrowserCallbacks(&callbacks);
	callbacks.u.v1.itemDataCallback = NewDataBrowserItemDataUPP(NGenreSetupDlg_GetSetItemDataCallback);
	dlg.m_browser.SetDataBrowserCallbacks(&callbacks);

	dlg.m_browser.AddColumn(COLMN_ID_CHECK, "", 40, kDataBrowserCheckboxType, kDataBrowserPropertyIsMutable);
	dlg.m_browser.AddColumn(COLMN_ID_NAME, "Genre", dlg.m_boxRect.GetWidth() - 40, kDataBrowserTextType, 0);

	if (theMGenre->m_genres.GetCount() > 0) {
		DataBrowserItemID *items = new DataBrowserItemID[theMGenre->m_genres.GetCount()];
		int i = 0;
		for (NGenreRec *rec = theMGenre->m_genres.GetTop(); rec != NULL; rec = rec->GetNext(), i++)
			items[i] = (DataBrowserItemID)rec;
		dlg.m_browser.AddDataBrowserItems(0, theMGenre->m_genres.GetCount(), items);
		delete [] items;
	}
	int itemHit;
	for (;;) {
		itemHit = dlg.ModalDialog();
		if (itemHit == DEFAULT_OK_DITEM || itemHit == DEFAULT_CANCEL_DITEM)
			break;
	}

	if (itemHit == DEFAULT_OK_DITEM) {
		memcpy(thePref->m_useGenre, dlg.m_useGenre, 256);
		theMGenre->AttachGenreMenu();
		theMDGenre->AttachGenreMenu();
	}

	dlg.m_browser.DisposeControl();
	rootControl.DisposeControl();
	DisposeDataBrowserItemDataUPP(callbacks.u.v1.itemDataCallback);
}

#define EDIT_TAG_DLG			129
#define FILENAME_DITEM			3
#define TITLE_DITEM				4
#define ARTIST_DITEM			5
#define ALBUM_DITEM				6
#define COMMENT_DITEM			7
#define	TRACK_DITEM				8
#define	TRACKMAX_DITEM			9
#define YEAR_DITEM				10
#define GENRE_DITEM				11
#define GENRE_MENU_DITEM		12
#define LOADENC_DITEM			13
#define SAVEENC_DITEM			14
#define VERSION_DITEM			15

#define FILENAME_STATIC_DITEM	16
#define TRACK_STATIC_DITEM		17
#define TITLE_STATIC_DITEM		18
#define LOADENC_STATIC_DITEM	24

void MID3::OnEdit(NTagList *tagList, NTag *tag) {
	Boolean all = FALSE;
	if (tag == NULL) {
		all = TRUE;
		tag = tagList->GetBySelection();
		if (tag == NULL)
			tag = (NTag *)tagList->GetTop();
		if (tag == NULL)
			return;
	}

	NTag *tagModify = tag->CloneForModify();

	TDialog dlg(EDIT_TAG_DLG, thePref->m_editDlgPosition);

//	dlg.SetWTitle(all ? m_allFilesStr : (TString)tag->GetStringByPropertyID(COLMN_ID_FILENAME));
	dlg.SetWindowTitleWithCFString(all ? (TCFString)m_allFilesStr : tag->GetStringByPropertyID(COLMN_ID_FILENAME));
	//	dlg.SetFont(tagList->m_view->GetFont());

	ControlFontStyleRec fontStyle;
	memset(&fontStyle, 0, sizeof(fontStyle));
	fontStyle.flags = kControlUseFontMask;
	fontStyle.font = tagList->m_view->GetFont();
	int scriptCode = tagList->m_view->m_scriptCode;
	SetControlFontStyle(dlg.GetDialogItemAsControl(FILENAME_DITEM), &fontStyle);
	SetControlFontStyle(dlg.GetDialogItemAsControl(TITLE_DITEM), &fontStyle);
	SetControlFontStyle(dlg.GetDialogItemAsControl(ARTIST_DITEM), &fontStyle);
	SetControlFontStyle(dlg.GetDialogItemAsControl(ALBUM_DITEM), &fontStyle);
	SetControlFontStyle(dlg.GetDialogItemAsControl(COMMENT_DITEM), &fontStyle);

	Boolean appearance = TRUE;

	if (all == FALSE) {
		dlg.SetDITextCFStringAndSelect(TITLE_DITEM, tag->GetStringByPropertyID(COLMN_ID_TITLE), appearance);
		dlg.SetDIKeyboardFocus(TITLE_DITEM);
		dlg.SetDITextCFString(FILENAME_DITEM, tag->GetStringByPropertyID(COLMN_ID_FILENAME), appearance);
		dlg.SetDITextCFString(TRACK_DITEM, tag->GetStringByPropertyID(COLMN_ID_TRACKNUM), appearance);
		dlg.SetDITextCFString(ARTIST_DITEM, tag->GetStringByPropertyID(COLMN_ID_ARTIST), appearance);
		dlg.SetDITextCFString(COMMENT_DITEM, tag->GetStringByPropertyID(COLMN_ID_COMMENT), appearance);
	}
	else {
		dlg.SetDIHilite(FILENAME_DITEM, 255);
		dlg.SetDIHilite(TITLE_DITEM, 255);
		dlg.SetDIHilite(TRACK_DITEM, 255);
		dlg.SetDIHilite(LOADENC_DITEM, 255);
		dlg.SetDIHilite(FILENAME_STATIC_DITEM, 255);
		dlg.SetDIHilite(TRACK_STATIC_DITEM, 255);
		dlg.SetDIHilite(TITLE_STATIC_DITEM, 255);
		dlg.SetDIHilite(LOADENC_STATIC_DITEM, 255);
		dlg.SetDITextCFStringAndSelect(ARTIST_DITEM, tag->GetStringByPropertyID(COLMN_ID_ARTIST), appearance);
		dlg.SetDIKeyboardFocus(ARTIST_DITEM);
		if (thePref->m_exceptComment == OFF)
			dlg.SetDITextCFString(COMMENT_DITEM, tag->GetStringByPropertyID(COLMN_ID_COMMENT), appearance);
		else
			dlg.SetDIHilite(COMMENT_DITEM, 255);
	}

	dlg.SetDITextCFString(TRACKMAX_DITEM, tag->GetStringByPropertyID(COLMN_ID_TRACKMAX), appearance);
	dlg.SetDITextCFString(ALBUM_DITEM, tag->GetStringByPropertyID(COLMN_ID_ALBUM), appearance);
	dlg.SetDITextCFString(YEAR_DITEM, tag->GetStringByPropertyID(COLMN_ID_YEAR), appearance);
	TString s;
	s.sprintf("%d", tag->m_genre);
	dlg.SetDIText(GENRE_DITEM, s, appearance);

	int loadEncItem = tag->m_loadEnc + (AS_IS_ITEM - CODE_AS_IS);
	int saveEncItem = tag->m_saveEnc + (AS_IS_ITEM - CODE_AS_IS);
	int versionItem = tag->m_version + (VERSION_1_0_ITEM - TAG_VERSION_1_0);
	int genre = theMGenre->GenreToMenuItemNumber(tag->m_genre);

	if (all == FALSE)
		dlg.SetDIValue(LOADENC_DITEM, loadEncItem);
	dlg.SetDIValue(SAVEENC_DITEM, saveEncItem);
	dlg.SetDIValue(VERSION_DITEM, versionItem);
	dlg.SetDIValue(GENRE_MENU_DITEM, genre);

	int itemHit;
	for (;;) {
		theMDLoadEnc->FixMenuForDialog(tagModify, all);
		theMDSaveEnc->FixMenuForDialog(tagModify);
		theMDVersion->FixMenuForDialog();
		theMDGenre->FixMenuForDialog(tagModify);

		itemHit = dlg.ModalDialog();
		if (itemHit == LOADENC_DITEM) {
			loadEncItem = dlg.GetDIValue(LOADENC_DITEM);
			theMDLoadEnc->OnLoadEnc(loadEncItem, tagModify);

			if (all == FALSE)
				dlg.SetDITextCFString(TITLE_DITEM, tagModify->GetStringByPropertyID(COLMN_ID_TITLE), appearance);
			dlg.SetDITextCFString(ARTIST_DITEM, tagModify->GetStringByPropertyID(COLMN_ID_ARTIST), appearance);
			dlg.SetDITextCFString(ALBUM_DITEM, tagModify->GetStringByPropertyID(COLMN_ID_ALBUM), appearance);
			dlg.SetDITextCFString(COMMENT_DITEM, tagModify->GetStringByPropertyID(COLMN_ID_COMMENT), appearance);
		}
		else if (itemHit == SAVEENC_DITEM) {
			saveEncItem = dlg.GetDIValue(SAVEENC_DITEM);
			theMDSaveEnc->OnSaveEnc(saveEncItem, tagModify);
		}
		else if (itemHit == VERSION_DITEM) {
			versionItem = dlg.GetDIValue(VERSION_DITEM);
			theMDVersion->OnVersion(versionItem, tagModify);
			saveEncItem = tagModify->m_saveEnc + (AS_IS_ITEM - CODE_AS_IS);
			dlg.SetDIValue(SAVEENC_DITEM, saveEncItem);
		}
		else if (itemHit == GENRE_MENU_DITEM) {
			genre = dlg.GetDIValue(GENRE_MENU_DITEM);
			s.sprintf("%d", theMDGenre->MenuItemNumberToGenre(genre));
			dlg.SetDITextCFString(GENRE_DITEM, s, appearance);
		}
		else if (itemHit == DEFAULT_OK_DITEM || itemHit == DEFAULT_CANCEL_DITEM)
			break;
	}

	TRect r = dlg.GetPortRectGlobal();
	thePref->m_editDlgPosition.h = r.left;
	thePref->m_editDlgPosition.v = r.top;

	delete tagModify;

	if (itemHit != DEFAULT_OK_DITEM) {
		return;
	}

	if (all) {
		tagList->SetUndo(UNDO_CMD_EDIT_ALL);
		tag = tagList->GetTop();
	}
	else {
		tag->SetUndo(UNDO_CMD_EDIT);
	}

	for (; tag != NULL;) {
		TString s;
		if (all == FALSE) {
			theMLoadEnc->OnLoadEnc(loadEncItem, tag);
			tag->SetStringByPropertyID(COLMN_ID_FILENAME, dlg.GetDITextCFString(FILENAME_DITEM, appearance));
			tag->SetStringByPropertyID(COLMN_ID_TITLE, dlg.GetDITextCFString(TITLE_DITEM, appearance));
			tag->SetStringByPropertyID(COLMN_ID_TRACKNUM, dlg.GetDITextCFString(TRACK_DITEM, appearance));
		}
		else {
			//			tag->m_title.DecodeString(tag->m_loadEnc);
		}
		theMSaveEnc->OnSaveEnc(saveEncItem, tag);
		tag->SetStringByPropertyID(COLMN_ID_TRACKMAX, dlg.GetDITextCFString(TRACKMAX_DITEM, appearance));

		tag->SetStringByPropertyID(COLMN_ID_ARTIST, dlg.GetDITextCFString(ARTIST_DITEM, appearance));
		tag->SetStringByPropertyID(COLMN_ID_ALBUM, dlg.GetDITextCFString(ALBUM_DITEM, appearance));

		if (all == false || thePref->m_exceptComment == OFF) {
			tag->SetStringByPropertyID(COLMN_ID_COMMENT, dlg.GetDITextCFString(COMMENT_DITEM, appearance));
		}
		tag->SetStringByPropertyID(COLMN_ID_YEAR, dlg.GetDITextCFString(YEAR_DITEM, appearance));
		tag->SetStringByPropertyID(COLMN_ID_GENRE, dlg.GetDITextCFString(GENRE_DITEM, appearance));
		theMVersion->OnVersion(versionItem, tag);
		tagList->m_view->m_titleBox.m_browser.UpdateDataBrowserItems(0, 1, (DataBrowserItemID *)&tag, kDataBrowserItemNoProperty, kDataBrowserNoItem);
		if (all)
			tag = tag->GetNext();
		else
			break;
	}
}

MVersion::MVersion() {
	strcpy(m_enable, "EEEEEE");
}

void MVersion::FixMenu() {
	char save[32];
	strcpy(save, m_enable);
	NView *view = (NView *)theMWindow->GetCurrentView();
	NTag *tag = NULL;
	m_enable[VERSION_1_0_ITEM] = 'D';
	m_enable[VERSION_1_1_ITEM] = 'D';
	m_enable[VERSION_2_2_ITEM] = 'D';
	m_enable[VERSION_2_3_ITEM] = 'D';
	m_enable[VERSION_2_4_ITEM] = 'D';
	if (view != NULL) {
		tag = view->m_tagList.GetBySelection();
		if (tag != NULL) {
			m_enable[VERSION_1_0_ITEM] = 'E';
			m_enable[VERSION_1_1_ITEM] = 'E';
			m_enable[VERSION_2_2_ITEM] = 'E';
			m_enable[VERSION_2_3_ITEM] = 'E';
			m_enable[VERSION_2_4_ITEM] = 'E';
		}
	}
	for (int i = 1; i <= m_menu->CountMItems(); i++)
		m_menu->CheckItem(i, tag != NULL ? tag->m_version + (VERSION_1_0_ITEM - TAG_VERSION_1_0) == i : FALSE);
	m_menu->EnableMenuItemByList(m_enable, save);
}

void MVersion::FixMenuForDialog() {
	char save[32];
	strcpy(save, m_enable);
	m_enable[VERSION_1_0_ITEM] = 'E';
	m_enable[VERSION_1_1_ITEM] = 'E';
	m_enable[VERSION_2_2_ITEM] = 'E';
	m_enable[VERSION_2_3_ITEM] = 'E';
	m_enable[VERSION_2_4_ITEM] = 'E';
	for (int i = 1; i <= m_menu->CountMItems(); i++)
		m_menu->CheckItem(i, FALSE);
	m_menu->EnableMenuItemByList(m_enable, save);
}

void MVersion::Command(short item) {
	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL)
		return;
	NTag *tag = view->m_tagList.GetBySelection();
	if (tag == NULL)
		return;
	tag->SetUndo(UNDO_CMD_VERSION);
	OnVersion(item, tag);
	view->m_titleBox.m_browser.UpdateDataBrowserItems(0, 1, (DataBrowserItemID *)&tag, kDataBrowserItemNoProperty, kDataBrowserNoItem);
}

void MVersion::OnVersion(short item, NTag *tag) {
	int n = item - (VERSION_1_0_ITEM - TAG_VERSION_1_0);
	if (tag->m_version != n) {
		tag->m_version = n;
		if (tag->m_version < TAG_VERSION_2_2 && tag->m_saveEnc >= CODE_UTF16)
			tag->m_saveEnc = CODE_AS_IS;
		tag->m_modify = TRUE;
	}
}

MLoadEnc::MLoadEnc() {
	strcpy(m_enable, "EEEE");
}

void MLoadEnc::FixMenu() {
	char save[32];
	strcpy(save, m_enable);

	NView *view = (NView *)theMWindow->GetCurrentView();
	NTag *tag = NULL;
	m_enable[AS_IS_ITEM] = 'D';
	m_enable[LATIN1_ITEM] = 'D';
	m_enable[UTF16_ITEM] = 'D';
	if (view != NULL) {
		tag = view->m_tagList.GetBySelection();
		if (tag != NULL) {
			if (tag->m_loadEnc >= CODE_UTF16) {
				m_enable[AS_IS_ITEM] = 'D';
				m_enable[LATIN1_ITEM] = 'D';
				m_enable[UTF16_ITEM] = 'E';
			}
			else {
				m_enable[AS_IS_ITEM] = 'E';
				m_enable[LATIN1_ITEM] = 'E';
				m_enable[UTF16_ITEM] = 'D';
			}
			m_menu->SetMenuItemText(AS_IS_ITEM, tag->GetCodingString(CODE_AS_IS));
		}
	}
	for (int i = 1; i <= m_menu->CountMItems(); i++)
		m_menu->CheckItem(i, tag != NULL ? tag->m_loadEnc + (AS_IS_ITEM - CODE_AS_IS) == i : FALSE);
	m_menu->EnableMenuItemByList(m_enable, save);
}

void MLoadEnc::FixMenuForDialog(NTag *tag, Boolean all) {
	char save[32];
	strcpy(save, m_enable);
	if (all)	/* all */
	{
		m_enable[AS_IS_ITEM] = 'E';
		m_enable[LATIN1_ITEM] = 'E';
		m_enable[UTF16_ITEM] = 'E';
	}
	else	/* one file */
	{
		if (tag->m_loadEnc >= CODE_UTF16) {
			m_enable[AS_IS_ITEM] = 'D';
			m_enable[LATIN1_ITEM] = 'D';
			m_enable[UTF16_ITEM] = 'E';
		}
		else {
			m_enable[AS_IS_ITEM] = 'E';
			m_enable[LATIN1_ITEM] = 'E';
			m_enable[UTF16_ITEM] = 'D';
		}
	}
	m_menu->SetMenuItemText(AS_IS_ITEM, tag->GetCodingString(CODE_AS_IS));
	for (int i = 1; i <= m_menu->CountMItems(); i++)
		m_menu->CheckItem(i, FALSE);
	m_menu->EnableMenuItemByList(m_enable, save);
}

void MLoadEnc::Command(short item) {
	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL)
		return;
	NTag *tag = view->m_tagList.GetBySelection();
	if (tag == NULL)
		return;
	tag->SetUndo(UNDO_CMD_LOADENC);
	OnLoadEnc(item, tag);
	view->m_titleBox.m_browser.UpdateDataBrowserItems(0, 1, (DataBrowserItemID *)&tag, kDataBrowserItemNoProperty, kDataBrowserNoItem);
}

void MLoadEnc::OnLoadEnc(short item, NTag *tag) {
	int n = item - (AS_IS_ITEM - CODE_AS_IS);
	if (tag->m_loadEnc != n) {
		if ((tag->m_loadEnc >= CODE_UTF16 && item >= UTF16_ITEM) || (tag->m_loadEnc < CODE_UTF16 && item < UTF16_ITEM)) {
			tag->m_loadEnc = n;
			tag->DecodeStrings();
		}
	}
}

MSaveEnc::MSaveEnc() {
	strcpy(m_enable, "EEEE");
}

void MSaveEnc::FixMenu() {
	char save[32];
	strcpy(save, m_enable);
	NView *view = (NView *)theMWindow->GetCurrentView();
	NTag *tag = NULL;
	m_enable[AS_IS_ITEM] = 'D';
	m_enable[LATIN1_ITEM] = 'D';
	m_enable[UTF16_ITEM] = 'D';
	if (view != NULL) {
		tag = view->m_tagList.GetBySelection();
		if (tag != NULL) {
			m_enable[AS_IS_ITEM] = 'E';
			m_enable[LATIN1_ITEM] = 'E';
			if (tag->m_version >= TAG_VERSION_2_2)
				m_enable[UTF16_ITEM] = 'E';
			else
				m_enable[UTF16_ITEM] = 'D';
			m_menu->SetMenuItemText(AS_IS_ITEM, tag->GetCodingString(CODE_AS_IS));
		}
	}
	for (int i = 1; i <= m_menu->CountMItems(); i++)
		m_menu->CheckItem(i, tag != NULL ? tag->m_saveEnc + (AS_IS_ITEM - CODE_AS_IS) == i : FALSE);
	m_menu->EnableMenuItemByList(m_enable, save);
}

void MSaveEnc::FixMenuForDialog(NTag *tag) {
	char save[32];
	strcpy(save, m_enable);
	m_enable[AS_IS_ITEM] = 'E';
	m_enable[LATIN1_ITEM] = 'E';
	if (tag->m_version >= TAG_VERSION_2_2)
		m_enable[UTF16_ITEM] = 'E';
	else
		m_enable[UTF16_ITEM] = 'D';
	for (int i = 1; i <= m_menu->CountMItems(); i++)
		m_menu->CheckItem(i, FALSE);
	m_menu->EnableMenuItemByList(m_enable, save);
}

void MSaveEnc::Command(short item) {
	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL)
		return;
	NTag *tag = view->m_tagList.GetBySelection();
	if (tag == NULL)
		return;
	tag->SetUndo(UNDO_CMD_SAVEENC);
	OnSaveEnc(item, tag);
	view->m_titleBox.m_browser.UpdateDataBrowserItems(0, 1, (DataBrowserItemID *)&tag, kDataBrowserItemNoProperty, kDataBrowserNoItem);
}

void MSaveEnc::OnSaveEnc(short item, NTag *tag) {
	int n = item - (AS_IS_ITEM - CODE_AS_IS);
	if (tag->m_saveEnc != n) {
		tag->m_saveEnc = item - (AS_IS_ITEM - CODE_AS_IS);
		tag->m_modify = TRUE;
	}
}

MGenre::MGenre() {
	m_genreMenuItems = NULL;
}

void MGenre::FixMenu() {
	NView *view = (NView *)theMWindow->GetCurrentView();
	NTag *tag = NULL;
	if (view != NULL) {
		tag = view->m_tagList.GetBySelection();
	}
	if (tag == NULL) {
		m_menu->DisableItem(0);
	}
	else {
		m_menu->EnableItem(0);
		int count = m_menu->CountMItems();
		for (int i = 0; i < count; i++)
			m_menu->CheckItem(i + 1, MenuItemNumberToGenre(i + 1) == tag->m_genre);
	}
}

void MGenre::FixMenuForDialog(NTag *tag) {
	m_menu->EnableItem(0);
	int count = m_menu->CountMItems();
	for (int i = 1; i <= count; i++)
		m_menu->CheckItem(i, FALSE);
	//		m_menu->CheckItem(i, MenuItemNumberToGenre(i) == tag->m_genre);
}

void MGenre::AttachGenreMenu() {
	TStringList list;
	list.LoadStrNumAll(STRNUM_ID_GENRE);
	int count = 0;
	int i;
	for (i = 0; i < 256; i++) {
		if (thePref->m_useGenre[i] != OFF)
			count++;
	}

	m_genres.RemoveDeleteAll();
	if (m_genreMenuItems != NULL)
		delete [] m_genreMenuItems;
	m_genreMenuItems = new NGenreRec * [count + 1];
	for (; m_menu->CountMItems() > 0;)
		m_menu->DeleteMenuItem(1);

	i = 0;
	for (TString *s = list.GetTop(); s != NULL; s = s->GetNext()) {
		TString t = *s;
		TString u = t.strtok_first(":");
		TString v = t.strtok_next("");
		NGenreRec *rec = new NGenreRec;
		rec->m_number = u.atoi();
		rec->m_name = v;
		if (thePref->m_useGenre[rec->m_number] != OFF) {
			m_menu->AppendMenu("\pdmy");
			m_menu->SetMenuItemText(m_menu->CountMItems(), rec->m_name);
			m_genreMenuItems[i] = rec;
			i++;
		}
		m_genres.Append(rec);
	}
}

void MGenre::Command(short item) {
	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL)
		return;
	NTag *tag = view->m_tagList.GetBySelection();
	if (tag == NULL)
		return;
	tag->SetUndo(UNDO_CMD_GENRE);
	OnGenre(item, tag);
	view->m_titleBox.m_browser.UpdateDataBrowserItems(0, 1, (DataBrowserItemID *)&tag, kDataBrowserItemNoProperty, kDataBrowserNoItem);
}

void MGenre::OnGenre(short item, NTag *tag) {
	int n = MenuItemNumberToGenre(item);
	if (tag->m_genre != n) {
		tag->m_genre = n;
		tag->m_modify = TRUE;
	}
}

int MGenre::GenreToMenuItemNumber(int genre) {
	int count = m_menu->CountMItems();
	for (int i = 0; i < count; i++) {
		if (m_genreMenuItems[i]->m_number == genre)
			return i + 1;
	}
	return 0;
}

int MGenre::MenuItemNumberToGenre(int itemNo) {
	if (itemNo == 0)
		return 0;
	return m_genreMenuItems[itemNo - 1]->m_number;
}

TString MGenre::GetGenreName(int genre) {
	for (NGenreRec *rec = m_genres.GetTop(); rec != NULL; rec = rec->GetNext()) {
		if (rec->m_number == genre)
			return rec->m_name;
	}
	return "";
}

/*
	MFont
*/

MFont::MFont() {
}

void MFont::FixMenu() {
	TWindow *window = theMWindow->GetCurrentView();
	if (window == NULL) {
		m_menu->DisableItem(0);
		return;
	}
	m_menu->EnableItem(0);
	TFont font(window->GetFont());
	TString fontName = font.GetFontName();
	for (int i = 1; i <= m_menu->CountMItems(); i++)
		m_menu->CheckItem(i, fontName == m_menu->GetMenuItemText(i));
}

void MFont::Command(short item) {
	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL)
		return;
	TFont font(m_menu->GetMenuItemText(item));
	if (font != view->GetFont())
		view->OnChangeFont(font, view->GetFontSize());
}

/*
	MSize
*/

#define	OTHER_FONT_SIZE_ITEM		1
#define	TOP_FONT_SIZE_ITEM			3

MSize::MSize() {
}

void MSize::FixMenu() {
	TWindow *window = theMWindow->GetCurrentView();
	if (window == NULL) {
		m_menu->DisableItem(0);
		return;
	}
	m_menu->EnableItem(0);
	TFont font(window->GetFont());
	short fontSize = window->GetFontSize();
	for (int i = TOP_FONT_SIZE_ITEM; i <= m_menu->CountMItems(); i++) {
		short n = m_menu->GetMenuItemText(i).atoi();
		m_menu->SetItemStyle(i, font.RealFont(n) ? outline : normal);
		m_menu->CheckItem(i, fontSize == n);
	}
}

void MSize::Command(short item) {
	NView *view = (NView *)theMWindow->GetCurrentView();
	if (view == NULL)
		return;
	short fontSize = item == OTHER_FONT_SIZE_ITEM ? OtherFontSizeDlg(view->GetFontSize()) : m_menu->GetMenuItemText(item).atoi();
	if (fontSize != 0 && fontSize != view->GetFontSize())
		view->OnChangeFont(view->GetFont(), fontSize);
}

#define	FONT_SIZE_DLG			139
#define	SIZE_EDIT_DITEM			3

short MSize::OtherFontSizeDlg(short oldSize) {
	short itemHit;
	TDialog dlg(FONT_SIZE_DLG);
	dlg.SetDINumberAndSelect(SIZE_EDIT_DITEM, oldSize);
	for (;;) {
		itemHit = dlg.ModalDialog();
		if (itemHit == DEFAULT_OK_DITEM) {
			short newSize = dlg.GetDINumber(SIZE_EDIT_DITEM);
			if (newSize >= 4 && newSize <= 256) {
				return newSize;
			}
			else {
				SysBeep(0);
				dlg.SetDINumberAndSelect(SIZE_EDIT_DITEM, newSize);
			}
		}
		if (itemHit == DEFAULT_CANCEL_DITEM) {
			return 0;
		}
	}
}

