/*
	MWindow.cpp
 
	NasuTen
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.03.03	1.0			Takeshi Yoneki
*/

#include "nglobal.h"

MWindow::MWindow() {
}

void MWindow::FixMenu() {
	TWindow *front = GetCurrentView();
	short item = TOP_WINDOW_ITEM;
	TWindow *window;
	for (window = GetTop(); window != NULL; window = window->GetNext()) {
		m_menu->CheckItem(item, *window == *front);
		item += 1;
	}
}

void MWindow::Command(short item) {
	if (item == NEXT_WINDOW_ITEM) {
		NextWindow();
	}
	else {
		TWindow *window = GetNth(item - TOP_WINDOW_ITEM);
		if (window != NULL)
			window->SelectWindow();
	}
}

void MWindow::NextWindow() {
	TWindow *window = GetCurrentView();
	;
	if (window != NULL)
		window = window->GetNext();
	if (window == NULL)
		window = GetTop();
	if (window != NULL)
		window->SelectWindow();
}

TWindow *MWindow::WhichWindow(WindowRef win) {
	if (win == NULL)
		return NULL;
	TWindow *window;
	for (window = GetTop(); window != NULL; window = window->GetNext()) {
		if (*window == win)
			return window;
	}
	return NULL;
}

TWindow *MWindow::GetCurrentView() {
	WindowRef win = FrontWindow();
	if (win == NULL)
		return NULL;
	TWindow *window;
	for (window = GetTop(); window != NULL; window = window->GetNext()) {
		if (*window == win)
			return window;
	}
	return (TWindow *)GetContainedObjectByNumber(cWindow, 1);
}

void MWindow::AppendWindow(TWindow *win) {
	Append(win);
	win->m_container = this;
	m_menu->AppendMenu("\px");
	ChangeWindowName(win);
}

void MWindow::ChangeWindowName(TWindow *win) {
	int n = GetOrder(win);
	if (n < 0)
		return;
	TCFString s = win->GetName();
	if (s.IsEmpty())
		s = "Untitled";
	m_menu->SetMenuItemTextCFString(n + TOP_WINDOW_ITEM, s.GetForMenu());
}

void MWindow::KillWindow(TWindow *win) {
	m_menu->DeleteMenuItem(GetOrder(win) + TOP_WINDOW_ITEM);
	RemoveDelete(win);
}

/*
	NMWindowtheMainڎgAapplicationxƓ
*/

long MWindow::GetAnyContainedObjectNumber() {
	TWindow *target = theMWindow->GetCurrentView();
	if (target != NULL)
		return target->GetObjectNumber();
	return CountContainedObjects(cWindow);
}

TAppleObject *MWindow::GetContainedObjectByNumber(DescType desiredClass, int n) {
	int i;
	int count = GetCount();
	if (count == 0)
		return NULL;
	WindowRef *array = new WindowRef[count];
	for (i = 0; i < n; i++)
		array[i] = NULL;
	WindowRef win = FrontWindow();
	for (i = 0; i < count;) {
		if (win == NULL)
			break;
		if (theMWindow->WhichWindow(win) != NULL) {
			array[i] = win;
			i += 1;
		}
		win = GetNextWindow(win);
	}
	TWindow *target = NULL;
	if (n >= 1 && n <= count)
		target = theMWindow->WhichWindow(array[n - 1]);
	delete [] array;
	return (TAppleObject *)target;
}

OSErr MWindow::OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result) {
	TAppleEvent ae(aev);
	if (token->GetObjectDesiredClass() == cWindow) {
		TWindow *target = (TWindow *)token->PurgeObject();
		if (eventID == kAEClose) {
			target->OnClose();
			return noErr;
		}
	}

	return noErr;
}

