/*
	NMain.cpp
 
	Copyright (C) 1998 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1998.01.27 Takeshi Yoneki
*/

#define _MAIN_
#include "nglobal.h"

pascal OSErr OnAEOpenAppl(const AppleEvent *ae, AppleEvent *reply, long refCon);
pascal OSErr OnAEOpenDocs(const AppleEvent *ae, AppleEvent *reply, long refCon);
pascal OSErr OnAEPrintDocs(const AppleEvent *ae, AppleEvent *reply, long refCon);
pascal OSErr OnAEQuitAppl(const AppleEvent *ae, AppleEvent *reply, long refCon);

NMain::NMain() {
	/* c[{bNX̏ */
	theSystem = new TSystem(20, 1024L * 32L);
	theEvent = new CEvent;
	/* J[\̓ǂݍ */
	theCursor->Load(FINGER_CURSOR);
	theCursor->Load(PECK_FINGER_CURSOR);
	theCursor->Load(SPIN_WATCH_CURSOR, 8, 20);
	theCursor->Load(SPLIT_CURSOR);
	theCursor->Load(SPIN_CIRCLE_CURSOR, 8, 20);
	theCursor->Load(WHITE_ARROW_CURSOR);
	theCursor->Load(BOOK_PAGE_CURSOR, 8, 20);
	m_applName = LMGetCurApName();
}

void NMain::Initial() {
	m_startTickCount = TickCount();
	m_quitAfterJob = FALSE;

	/* ݒt@C̓ǂݍ */
	thePref = new NPref;

	/* j[NX */
	theMenu = new NMenu;

	theGlobalData = new NGlobalData;

	/* ej[R}hNX */
	theMApple = new MApple;
	theMFile = new MFile;
	theMEdit = new MEdit;
	theMID3 = new MID3;
	theMWindow = new MWindow;

	theMLoadEnc = new MLoadEnc;
	theMSaveEnc = new MSaveEnc;
	theMGenre = new MGenre;
	theMVersion = new MVersion;
	theMFont = new MFont;
	theMSize = new MSize;

	theMDLoadEnc = new MLoadEnc;
	theMDSaveEnc = new MSaveEnc;
	theMDGenre = new MGenre;
	theMDVersion = new MVersion;

	theMenu->Initial();

	theMGenre->AttachGenreMenu();
	theMDGenre->AttachGenreMenu();

	if (theSystem->hasAppleEvents) {
		m_uppAEOpenAppl.SetUPP(OnAEOpenAppl);
		m_uppAEOpenDosc.SetUPP(OnAEOpenDocs);
		m_uppAEPrintDocs.SetUPP(OnAEPrintDocs);
		m_uppAEQuitAppl.SetUPP(OnAEQuitAppl);
		AEInstallEventHandler(kCoreEventClass, kAEOpenApplication, (AEEventHandlerUPP)m_uppAEOpenAppl.GetUPP(), 0, FALSE);
		AEInstallEventHandler(kCoreEventClass, kAEOpenDocuments, (AEEventHandlerUPP)m_uppAEOpenDosc.GetUPP(), 0, FALSE);
		AEInstallEventHandler(kCoreEventClass, kAEPrintDocuments, (AEEventHandlerUPP)m_uppAEPrintDocs.GetUPP(), 0, FALSE);
		AEInstallEventHandler(kCoreEventClass, kAEQuitApplication, (AEEventHandlerUPP)m_uppAEQuitAppl.GetUPP(), 0, FALSE);
	}
}

NMain::~NMain() {
	delete theMApple;
	delete theMFile;
	delete theMEdit;
	delete theMID3;
	delete theMWindow;

	delete theMLoadEnc;
	delete theMSaveEnc;
	delete theMGenre;
	delete theMVersion;
	delete theMFont;
	delete theMSize;

	delete theMDLoadEnc;
	delete theMDSaveEnc;
	delete theMDGenre;
	delete theMDVersion;

	delete theGlobalData;

	delete thePref;
	delete theMenu;
	delete theEvent;
	delete theSystem;
}

TWindow *NMain::WhichWindow(WindowPtr win) {
	return theMWindow->WhichWindow(win);
}

void NMain::OnTask() {
	TWindow *target = WhichWindow(FrontWindow());
	if (target == NULL)
		return;
	target->OnTask();
}

void NMain::OnMouseDown() {
	WindowRef win;
	int partCode = FindWindow(theEvent->where, &win);
	TWindow *target = WhichWindow(win);

	if (partCode == inMenuBar) {
		theMenu->OnMenuCommand(*theEvent);
		return;
	}
	else if (partCode == inSysWindow) {
		theSystem->SystemClick(theEvent, win);
		return;
	}
	else if (target == NULL) {
		return;
	}

	switch (partCode) {
	case inDrag:
		target->OnDrag(theEvent->where);
		break;
	case inContent:
		if (*target != FrontWindow())
			target->SelectWindow();
		else
			target->OnContent(*theEvent);
		break;
	case inGrow:
		target->OnGrow(theEvent->where);
		break;
	case inGoAway:
		if (target->OnGoAway(theEvent->where))
			theMFile->OnClose((NView *)target);
		//			theMWindow->KillWindow(target);
		break;
	case inZoomIn:
	case inZoomOut:
		target->OnZoom(theEvent->where, partCode);
		break;
	default:
		break;
	}
}

void NMain::OnKey() {
	Boolean command = (theEvent->modifiers & cmdKey) != 0;
	if (command && theEvent->what == keyDown) {
		//		if (theMScript->CommandKey(theEvent->message))
		//			return;
		theMenu->OnMenuCommand(*theEvent);
		return;
	}
	int code = (theEvent->message & keyCodeMask) >> 8;
	if (code == 71) {
		theMWindow->NextWindow();
		return;
	}

	NView *target = (NView *)WhichWindow(FrontWindow());
	if (target == NULL)
		return;
	target->OnKey(theEvent);
}

void NMain::OnActivate(WindowRef win, Boolean act) {
	TWindow *target = WhichWindow(win);
	if (target == NULL)
		return;
	target->OnActivate(act);
	theCursor->Reset();
}

void NMain::OnOSEvt() {
	if ((((theEvent->message & osEvtMessageMask) >> 24) & suspendResumeMessage) != 0)
		OnActivate(FrontWindow(), (theEvent->message & resumeFlag) != 0);
}

void NMain::OnUpdate() {
	TWindow *target = WhichWindow((WindowRef)theEvent->message);
	if (target == NULL)
		return;

	target->OnUpdate();
}

pascal OSErr OnAEOpenAppl(const AppleEvent *ae, AppleEvent *reply, long refCon) {
	if (thePref->m_logAppleEvent)
		theDebug->Log("OnAEOpenAppl");

	theMain->m_startTickCount = TickCount();

	return noErr;
}

pascal OSErr OnAEOpenDocs(const AppleEvent *aev, AppleEvent *reply, long refCon) {
	TAEDescList docList;
	long itemsInList;

	TAppleEvent ae(aev);
	ae.AEInteractWithUser();
	ae.AEGetParamDesc(keyDirectObject, typeAEList, docList);
	itemsInList = docList.CountItems();
	if (itemsInList == 0)
		return noErr;

	NView *view = (NView *)theMWindow->GetCurrentView();

	TStandardFileReplyList fileList;

	TDirectory dir;
	int i;
	for (i = 0; i < itemsInList; i++) {
		FSSpec spec;
		AEKeyword returnedKeywd;
		DescType returnedType;
		Size actualSize;
		docList.AEGetNthPtr(i + 1, typeFSS, &returnedKeywd, &returnedType, &spec, sizeof (FSSpec), &actualSize);
		TFilePath path(spec);
		TFinderInfo info = path.GetFinderInfo();
		if (path.IsGood() && itemsInList == 1 && info.m_info.fdType == 'TEXT' && view != NULL)
			return view->m_tagList.ImportTSV(path) ? noErr : -1;
		TFSSpec fsSpec(spec);
		fileList.AppendFile(fsSpec);
	}

	theMFile->OpenFiles(&fileList);

	return noErr;
}

pascal OSErr OnAEPrintDocs(const AppleEvent *ae, AppleEvent *reply, long refCon) {
	SysBeep(0);
	return noErr;
}

pascal OSErr OnAEQuitAppl(const AppleEvent *aev, AppleEvent *reply, long refCon) {
	//	TAppleEvent ae(aev);
	//	ae.AEInteractWithUser();

	if (thePref->m_logAppleEvent)
		theDebug->Log("OnAEQuitAppl");

	theMFile->OnQuit(aev);
	if (theMFile->IsQuit())
		return noErr;
	else
		return userCanceledErr;
}

void NMain::OnHighLevelEvent() {
	char ev[sizeof (EventRecord)];
	memcpy(ev, (EventRecord *)*theEvent, sizeof (EventRecord));
	AEProcessAppleEvent((EventRecord *)*theEvent);
}

TAppleObject *NMain::GetObjectProperty(DescType desiredClass, DescType keyForm, const AEDesc *keyData) {
	TAppleObject *obj = NULL;
	if (desiredClass == pName) {
		obj = new TUniString(GetObjectName());
		if (obj != NULL)
			obj->BeTemporary();
		return obj;
	}
	else {
		TWindow *win = theMWindow->GetCurrentView();
		if (win == NULL)
			return NULL;
		return win->GetObjectProperty(desiredClass, keyForm, keyData);
	}
}

OSErr NMain::OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result) {
	return theMWindow->OnAdhocForContainer(token, eventID, aev, result);
}

TAppleObject *NMain::GetContainedObject(DescType desiredClass, DescType keyForm, const AEDesc *keyData) {
	TAppleObject *obj = NULL;
	if (desiredClass == classMP3File) {
		TWindow *win = theMWindow->GetCurrentView();
		if (win == NULL)
			return NULL;
		obj = win->GetContainedObject(desiredClass, keyForm, keyData);
	}
	else if (desiredClass == cWindow)
		obj = theMWindow->GetContainedObject(desiredClass, keyForm, keyData);
	return obj;
}

long NMain::CountContainedObjects(DescType desiredClass) {
	long n = 0;
	return n;
}

OSErr NMain::OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result) {
	if (eventID == kAECreateElement) {
		TAppleEvent ae(aev);
		DescType what = typeNull;
		what = ae.GetParamDescType(keywordNew, typeWildCard);
		if (what == cWindow) {
			NView *win = theMFile->OnNew();
			if (win == NULL)
				return -1;
			TAEDesc objSpec;
			win->GetObjSpecifier(cWindow, objSpec);
			result->PutDescWithKeyword(keyDirectObject, objSpec);
			return noErr;
		}
		return errAEEventNotHandled;
	}
	else {
		TWindow *win = theMWindow->GetCurrentView();
		if (win == NULL)
			return -1;
		return win->OnAppleEvent(eventID, desiredClass, aev, result);
	}
	return errAEEventNotHandled;
}

#define	MEMORY_WARN_DLG		132

void NMain::doFinderInfo() {
}

void NMain::MainLoop() {
	Boolean posted = FALSE;
	Boolean warning = FALSE;
	Boolean working = FALSE;

	doFinderInfo();

	//	if (theSystem->hasAppleEvents == FALSE)
	//		theView->ShowFirst();

	for(; FALSE == theMFile->IsQuit();) {
		if (theSystem->systemVersion < 0x0700)
			posted = theEvent->GetNextEvent(everyEvent);
		else
			posted = theEvent->WaitNextEvent(everyEvent, posted || working ? 0 : LONG_MAX);
		if (theSystem->hasTSMTE)
			if (theEvent->TSMEvent())
				continue;
		if (posted) {
			switch (theEvent->what) {
			case keyDown:
			case autoKey:
				OnKey();
				break;
			case mouseDown:
				OnMouseDown();
				break;
			case updateEvt:
				OnUpdate();
				break;
			case activateEvt:
				OnActivate((WindowRef)theEvent->message, (theEvent->modifiers & activeFlag) != 0);
				break;
			case osEvt:
				OnOSEvt();
				break;
			case kHighLevelEvent:
				OnHighLevelEvent();
				break;
			default:
				break;
			}
		}
		else {
			if (FreeMem() < 32000L && warning == FALSE) {
				SysBeep(0);
				TDialog dlg(MEMORY_WARN_DLG);
				dlg.ModalDialog();
				warning = TRUE;
			}

			OnTask();
		}
		if (theSystem->hasThreadMgr)
			YieldToAnyThread();
	}
}

int main() {
	theMain = new NMain;
	if (theSystem->systemVersion < 0x0700)
		return 0;
	theMain->Initial();
	theMain->MainLoop();
	delete theMain;
	return 0;
}
