/*
	NMenu.cpp
 
	NasuTen
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.02.12	1.0			Takeshi Yoneki
*/

#include "nglobal.h"

#pragma options align=mac68k

typedef struct {
	short magic;
	Handle iconSuite;
}
IconMenuTitle;

#pragma options align=reset

NMenu::NMenu() {
	short id;
	TMenu *menu;

	for (id = APPLE_MENU; id <= WINDOW_MENU; id++) {
		menu = new TMenu(id);
		Append(menu);
		menu->InsertMenu();
	}

	for (id = LOAD_ENC_MENU; id <= SIZE_MENU; id++) {
		menu = new TMenu(id);
		Append(menu);
		menu->InsertMenuHier();
	}

	for (id = LOAD_ENC_DLG_MENU; id <= VERSION_DLG_MENU; id++) {
		menu = new TMenu(id);
		Append(menu);
		menu->InsertMenuHier();
	}

	AppendResMenu(APPLE_MENU, 'DRVR');
	GetByID(FONT_MENU)->AppendResMenu('FONT');

	DrawMenuBar();
}

void NMenu::Initial() {
	GetByID(APPLE_MENU)->SetRelateToCommand(theMApple);
	GetByID(FILE_MENU)->SetRelateToCommand(theMFile);
	GetByID(EDIT_MENU)->SetRelateToCommand(theMEdit);
	GetByID(ID3_MENU)->SetRelateToCommand(theMID3);
	GetByID(WINDOW_MENU)->SetRelateToCommand(theMWindow);
	GetByID(LOAD_ENC_MENU)->SetRelateToCommand(theMLoadEnc);
	GetByID(SAVE_ENC_MENU)->SetRelateToCommand(theMSaveEnc);
	GetByID(GENRE_MENU)->SetRelateToCommand(theMGenre);
	GetByID(VERSION_MENU)->SetRelateToCommand(theMVersion);
	GetByID(FONT_MENU)->SetRelateToCommand(theMFont);
	GetByID(SIZE_MENU)->SetRelateToCommand(theMSize);

	GetByID(LOAD_ENC_DLG_MENU)->SetRelateToCommand(theMDLoadEnc);
	GetByID(SAVE_ENC_DLG_MENU)->SetRelateToCommand(theMDSaveEnc);
	GetByID(GENRE_DLG_MENU)->SetRelateToCommand(theMDGenre);
	GetByID(VERSION_DLG_MENU)->SetRelateToCommand(theMDVersion);
}

void NMenu::FixMenu() {
	TMenu *menu;
	for (menu = GetTop(); menu != NULL; menu = menu->GetNext()) {
		if (menu->m_command != NULL)
			menu->m_command->FixMenu();
	}
}

void NMenu::OnMenuCommand(EventRecord *ev) {
	long code;
	FixMenu();
	if (ev->what == mouseDown) {
		code = MenuSelect(ev->where);
		if (theSystem->hasTSMTE) {
			if (theSystem->TSMMenuSelect(code)) {
				theMenu->HiliteMenuOff();
				return;
			}
		}
	}
	else {
		code = MenuKey(ev->message);
	}

	short id = HiWord(code);
	short item = LoWord(code);
	TMenuCommandBase *command = GetCommandByID(id);
	if (command != NULL)
		command->Command(item);

	theMenu->HiliteMenuOff();
}
