/*
	NPref.cpp
 
	NasuTen
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.02.12	1.0			Takeshi Yoneki
*/

#include "nglobal.h"

#define	PREF_VERSION_1_0			1
#define	PREF_VERSION_1_1			2

#define	STRNUM_CREATOR				8

static char *prefFileName = "ID3TagEdit Pref";
static long defaultColumnWidth[] = {
                                       40, 45, 160, 160, 80, 100, 50, 50, 60, 50, 70, 70
                                   };

NPref::NPref() {
	PrefRecord *p = this;
	memset(p, 0, sizeof (PrefRecord));
	TWindow w;
	Rect defaultWinRect = w.m_zoomRect;
	m_prefFileName = prefFileName;

	if (FALSE == Load() || m_prefVersion < PREF_VERSION_1_0) {
		int i;
		memset(p, 0, sizeof (PrefRecord));
		m_prefVersion = PREF_VERSION_1_0;
		m_openBrowseAsDefault = 0;
		m_zoomBrowseToDefault = 0;
		m_browseRect = defaultWinRect;
		m_defaultBrowseRect = defaultWinRect;
		m_browseFont = 1;
		m_browseFontSize = 10/* 12 */;
		for (i = 0; i < 80; i++)
			m_useGenre[i] = ON;
		m_defaultSaveEnc = CODE_AS_IS;
		m_defaultVersion = TAG_VERSION_1_1;
		strcpy(m_commentLanguage, "eng");
		memcpy(m_columnWidth, defaultColumnWidth, sizeof(defaultColumnWidth));
		for (i = COLMN_ID_FIRST; i <= COLMN_ID_LAST; i++)
			m_columnOrder[i - COLMN_ID_FIRST] = i;
		m_trackFileFig = 2;
		m_trackFileSpc = 1;
		m_trackTitleFig = 2;
		m_trackTitleSpc = 1;
	}
	if (m_prefVersion < PREF_VERSION_1_1) {
		m_prefVersion = PREF_VERSION_1_1;
		m_enableFileNameTSV = 0;
	}
}

NPref::~NPref() {
	Save();
}

Boolean NPref::Load() {
	Boolean good;
	TFilePath filePath(m_prefFileName, theSystem->sysPrefDirectory);
	TFileIO prefFile(filePath);
	good = prefFile.IsGood();
	if (good)
		prefFile.Read(sizeof (PrefRecord), (PrefRecord *)this);
	return prefFile.IsGood() || prefFile.m_error == eofErr;
}

Boolean NPref::Save() {
	TFilePath filePath(m_prefFileName, theSystem->sysPrefDirectory);
	TFileIO prefFile(filePath, APPL_CREATOR, 'pref');
	if (prefFile.IsGood())
		prefFile.Write(sizeof (PrefRecord), (PrefRecord *)this);
	return prefFile.IsGood();
}

NSavePref::NSavePref() {
	m_saveData = new PrefRecord;
	*m_saveData = *thePref;
}

NSavePref::~NSavePref() {
	delete m_saveData;
}

void NSavePref::Recover() {
	*thePref = *m_saveData;
}
