/*
	NTag.cpp
 
	Copyright (C) 2002 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 2002.02.03	1.0			Takeshi Yoneki
*/

#include "nglobal.h"

static TUniString DeleteFileExtention(TUniString orgName, TUniString ext, TUniString *outExt = NULL);
static TUniString DeleteFileExtention(TUniString orgName, TUniString ext, TUniString *outExt) {
	UniChar *p = orgName;
	int n = ext.GetLength();
	if (orgName.GetLength() > n) {
		TUniString tail = &p[orgName.GetLength() - n];
		if (tail.CompareIgnoreCase(ext) == 0) {
			orgName.CopyFromUniString(p, orgName.GetLength() - n);
			if (outExt != NULL)
				*outExt = tail;
		}
	}
	return orgName;
}

NTagString::NTagString() {
	m_encoding = CODE_AS_IS;
}

void NTagString::operator=(const NTagString& ts) {
	m_org = ts.m_org;
	m_str = ts.m_str;
	m_encoding = ts.m_encoding;
}

void NTagString::DecodeString(int as, int scriptCode) {
	int i;
	int count = m_org.GetLength();
	if (m_encoding == CODE_UTF16 && count >= 4) {
		m_str.CopyFromUSTR((const UniChar *)(char *)m_org, count / 2);
		//m_str = ((NTag *)GetContainer())->GetUniEncInfo()->UnicodeToText((char *)m_org, count);
	}
	else if (as == CODE_LATIN1 && count >= 1) {
		char *p = (char *)m_org;
		char *q = new char[count + 1];
		for (i = 0; i < count; i++) {
			q[i] = theGlobalData->m_Latin1ToMacRoman[0xFF & p[i]];
		}
		q[count] = 0;
		m_str.CopyFromCSTR(q, -1, scriptCode);
		m_encoding = CODE_LATIN1;
	}
	else if (count >= 1) {
		TString s;
		s.CopyFrom((char *)m_org, count);
		s.SetScriptCode(scriptCode);
		m_str = s;
		m_encoding = CODE_AS_IS;
	}
	else {
		m_str = "";
		m_encoding = CODE_AS_IS;
	}
	m_str.CutRearSpace();
}

void NTagString::EncodeString(int as, int scriptCode, int limit) {
	int count = m_str.GetLength();
	if (count == 0) {
		m_org.ChangeLength(0);
		m_encoding = CODE_AS_IS;
		return;
	}

/*
	if (limit > 0 && count > limit) {
		char *p = (char *)m_str;
		count = 0;
		for (;;) {
			int charByte = ((NTag *)GetContainer())->GetUniEncInfo()->GetCharSize(p[count]);
			if (charByte + count > limit)
				break;
			count += charByte;
		}
		s.CopyFrom(m_str, count);
	}
	else {
		s = m_str;
	}

	if (m_str.IsASCII())
		as = CODE_AS_IS;
*/

	if (as == CODE_UTF16) {
		m_org.ChangeLength(m_str.GetLength() * sizeof(UniChar) + sizeof(UniChar));
		UniChar *up = (UniChar *)m_org.GetPtr();
		up[0] = BOM_LITTLE;
		const UniChar *p = m_str;
		for (int i = 0; i < m_str.GetLength(); i++) {
			up[1 + i] = SwapInt16(p[i]);
		}
		//memcpy(&up[1], (const UniChar *)m_str, m_str.GetLength());
		//((NTag *)GetContainer())->GetUniEncInfo()->TextToUnicode(BOM_LITTLE, &m_org, m_str);
		m_encoding = CODE_UTF16;
	}
	else {
		TString s;
		m_str.SetScriptCode(scriptCode);
		// USHIFT_JISɂB
		TString str = m_str;
		count = str.GetLength();
		// TCŶV1.xB
		if (limit > 0 && count > limit) {
			char *p = (char *)str;
			count = 0;
			for (;;) {
				int charByte = ((NTag *)GetContainer())->GetUniEncInfo()->GetCharSize(p[count]);
				if (charByte + count > limit)
					break;
				count += charByte;
			}
			s.CopyFrom(str, count);
		}
		else {
			s = str;
		}

		if (as == CODE_AS_IS) {
			m_org.ChangeLength(count + 1);
			char *p = (char *)m_org;
			memcpy(p, (char *)s, count);
			p[count] = 0;
			m_encoding = CODE_AS_IS;
		}
		else if (as == CODE_LATIN1) {
			m_org.ChangeLength(count + 1);
			char *p = (char *)m_org;
			char *q = (char *)s;
			for (int i = 0; i < count; i++)
				p[i] = theGlobalData->m_macRomanToLatin1[0xFF & q[i]];
			p[count] = 0;
			m_encoding = CODE_LATIN1;
		}
		else {
			m_org.ChangeLength(0);
			m_encoding = CODE_AS_IS;
		}
	}
}

/*
	WindowsňʓIShift_JISX[AiTunes̖MacRomanƂ݂ȂLatin-1
	ϊĂ邩𔻒fAfR[hB
	fޗƂĂShift_JISƂĐApJigĂ邩gB
*/

void NTagString::Set(char *data, int count, int encoding) {
	m_org.ChangeLength(count);
	memcpy((char *)m_org, data, count);
	m_encoding = encoding;
}

int NTagString::CheckString() {
	int decodeAs = CODE_AS_IS;
	char *p = (char *)m_org;
	int count = m_org.GetLength();
	if (count == 0)
		return decodeAs;

	int scriptCode = ((NTag *)GetContainer())->GetViewScriptCode();
	if (scriptCode == smJapanese) {
		for (int i = 0; i < count;) {
			int k1 = CharacterByteType(&p[i], 0, scriptCode);
			if (k1 == smFirstByte) {
				if (i + 1 == count) {
					decodeAs = CODE_LATIN1;
					break;
				}
				int k2 = CharacterByteType(&p[i], 1, scriptCode);
				if (k2 == smLastByte) {
					i += 2;
				}
				else {
					decodeAs = CODE_LATIN1;
					break;
				}
			}
			else if (CharacterByteType(&p[i], 0, scriptCode) == smSingleByte) {
				if ((p[i] & 0xFF) < 0x80) {
					i += 1;
				}
				else {
					decodeAs = CODE_LATIN1;
					break;
				}
			}
			else {
				decodeAs = CODE_LATIN1;
				break;
			}
		}
	}
	return decodeAs;
}

NTag::NTag(NTagList *parent) {
	SetContainer(parent);
	m_genre = 0;
	m_track = 0;
	m_trackMax = 0;
	m_soundStartPos = 0;
	m_soundSize = 0;
	m_modify = FALSE;

	m_loadEnc = CODE_AS_IS;
	m_saveEnc = thePref->m_defaultSaveEnc;
	m_version = thePref->m_defaultVersion;

	m_title.SetContainer(this);
	m_artist.SetContainer(this);
	m_album.SetContainer(this);
	m_comment.SetContainer(this);
}

NTag *NTag::CloneForModify() {
	NTag *tag = new NTag((NTagList *)GetContainer());
	/*
		tag->m_filePath = m_filePath;
	//	tag.m_icon = m_icon;
		tag->m_fileName = m_fileName;
		tag->m_title = m_title;
		tag->m_artist = m_artist;
		tag->m_album = m_album;
		tag->m_year = m_year;
		tag->m_comment = m_comment;
		tag->m_genre = m_genre;
		tag->m_version = m_version;
		tag->m_track = m_track;
		tag->m_trackMax = m_trackMax;
		tag->m_loadEnc = m_loadEnc;
		tag->m_saveEnc = m_saveEnc;
	*/
	*(NTagRecord *)tag = *(NTagRecord *)this;

	tag->m_soundStartPos = m_soundStartPos;
	tag->m_soundSize = m_soundSize;
	tag->m_modify = m_modify;
	return tag;
}

TString NTag::GetVersionString() {
	if (m_version == TAG_VERSION_1_0)
		return "v1.0";
	else if (m_version == TAG_VERSION_1_1)
		return "v1.1";
	else if (m_version == TAG_VERSION_2_2)
		return "v2.2";
	else if (m_version == TAG_VERSION_2_3)
		return "v2.3";
	else if (m_version == TAG_VERSION_2_4)
		return "v2.4";
	else
		return "-";
}

TString NTag::GetGenreString(int forWhat) {
	TString s;
	if (forWhat == FOR_TSV) {
		s.sprintf("(%d)", m_genre);
	}
	else {
		s = theMGenre->GetGenreName(m_genre);
		if (s.IsEmpty())
			s.sprintf("%d", m_genre);
	}
	return s;
}

TString NTag::GetTrackString(DataBrowserPropertyID property) {
	TString s;
	if (property == COLMN_ID_TRACKNUM) {
		if (m_track > 0)
			s.sprintf("%d", m_track);
	}
	else if (property == COLMN_ID_TRACKMAX) {
		if (m_trackMax > 0)
			s.sprintf("%d", m_trackMax);
	}
	else if (m_track > 0) {
		if (m_trackMax > 0)
			s.sprintf("%d/%d", m_track, m_trackMax);
		else
			s.sprintf("%d", m_track);
	}
	return s;
}

TString NTag::GetCodingString(int coding) {
	if (coding == CODE_LATIN1)
		return "Latin-1";
	else if (coding == CODE_UTF16)
		return "Unicode";
	else	/* CODE_AS_IS */
	{
		int scriptCode = GetViewScriptCode();
		if (scriptCode == smJapanese)
			return theGlobalData->m_shiftJISStr;
		else if (scriptCode == smRoman)
			return theGlobalData->m_macRomanStr;
		else
			return theGlobalData->m_asIsStr;
	}
}

int NTag::CheckLimit() {
	if (m_version >= TAG_VERSION_2_2)
		return 0;

	ID3_V1 *data;
	if (m_title.m_str.GetLength() > sizeof(data->m_title))
		return COLMN_ID_TITLE;
	if (m_artist.m_str.GetLength() > sizeof(data->m_artist))
		return COLMN_ID_ARTIST;
	if (m_album.m_str.GetLength() > sizeof(data->m_album))
		return COLMN_ID_ALBUM;
	if (m_version >= TAG_VERSION_1_0) {
		if (m_comment.m_str.GetLength() > sizeof(data->u.v10.m_comment))
			return COLMN_ID_COMMENT;
	}
	else {
		if (m_comment.m_str.GetLength() > sizeof(data->u.v11.m_comment))
			return COLMN_ID_COMMENT;
	}
	return 0;
}

int NTag::LoadTag(TFilePath filePath) {
	m_filePath = filePath;
	m_fileName = filePath.m_fileName;
	m_icon.GetIconRefFromFile(TFSSpec(filePath));

	/**/
	{
		TFileIO file(m_filePath);
		if (file.IsGood() == FALSE)
			return FALSE;
		m_soundStartPos = 0;
		m_soundSize = file.GetFileSize();
	}

	LoadV1Tag();
	LoadV2Tag();

	TString tempFileName;
	tempFileName.sprintf("~%08X~", this);
	;
	m_tempPath.m_fileName = tempFileName;
	m_tempPath.m_dir = m_filePath.m_dir;

	return TRUE;
}

void NTag::DecodeStrings() {
	int scriptCode = GetViewScriptCode();
	m_title.DecodeString(m_loadEnc, scriptCode);
	m_artist.DecodeString(m_loadEnc, scriptCode);
	m_album.DecodeString(m_loadEnc, scriptCode);
	m_comment.DecodeString(m_loadEnc, scriptCode);
}

Boolean NTag::LoadV1Tag() {
	TFileIO file(m_filePath);
	if (file.IsGood() == FALSE)
		return FALSE;
	long fileSize = file.GetFileSize();
	if (fileSize < sizeof(ID3_V1))
		return FALSE;
	file.SetFPos(fsFromStart, fileSize - sizeof(ID3_V1));
	ID3_V1 data;
	if (file.Read(sizeof(ID3_V1), &data) != sizeof(ID3_V1))
		return FALSE;
	if (memcmp(data.m_tag, "TAG", 3) != 0)
		return FALSE;

	//	m_soundStartPos = 0;
	m_soundSize = fileSize - sizeof(ID3_V1);

	if (data.u.v11.m_null == 0)
		m_version = TAG_VERSION_1_1;
	else
		m_version = TAG_VERSION_1_0;

	m_title.Set(data.m_title, sizeof(data.m_title));
	m_artist.Set(data.m_artist, sizeof(data.m_artist));
	m_album.Set(data.m_album, sizeof(data.m_album));
	m_title.Set(data.m_title, sizeof(data.m_title));
	if (m_version == TAG_VERSION_1_1)
		m_comment.Set(data.u.v11.m_comment, sizeof(data.u.v11.m_comment));
	else
		m_comment.Set(data.u.v10.m_comment, sizeof(data.u.v10.m_comment));

	m_loadEnc = CODE_AS_IS;
	if (m_loadEnc == CODE_AS_IS)
		m_loadEnc = m_title.CheckString();
	if (m_loadEnc == CODE_AS_IS)
		m_loadEnc = m_artist.CheckString();
	if (m_loadEnc == CODE_AS_IS)
		m_loadEnc = m_album.CheckString();
	if (m_loadEnc == CODE_AS_IS)
		m_loadEnc = m_comment.CheckString();

	DecodeStrings();

	m_year.CopyFromCSTR(data.m_year, sizeof(data.m_year));
	m_year.CutRearSpace();
	if (m_version == TAG_VERSION_1_1) {
		m_track = data.u.v11.m_track;
	}
	m_genre = data.m_genre;
	m_saveEnc = m_loadEnc;

	return TRUE;
}

long NTag::CalcV2TagSize(ID3_V2_HEAD *head) {
	long sz = (head->m_size[0] << (7 * 3)) + (head->m_size[1] << (7 * 2)) +
	          (head->m_size[2] << (7 * 1)) + (head->m_size[3]);
	if (head->m_major == TAG_VERSION_2_4 && (head->m_flags & TAG_V2_HEAD_FLAG_FOOTER) != 0)
		sz += sizeof(ID3_V2_FOOT);
	return sz;
}

long NTag::CalcV22FrameSize(ID3_V2_2_FRAME *frame) {
	return (frame->m_size[0] << (8 * 2)) + (frame->m_size[1] << (8 * 1)) + (frame->m_size[2]);
}

Boolean NTag::LoadV22Tag(TFileIO *file, long tagSize) {
	TMemory buff(tagSize);
	char *p = (char *)buff;
	file->Read(tagSize, (char *)buff);
	long pos = 0;
	for (; pos < tagSize;) {
		ID3_V2_2_FRAME *frame = (ID3_V2_2_FRAME *)&p[pos];
		pos += sizeof(ID3_V2_2_FRAME);
		char *body = &p[pos];
		long bsz = CalcV22FrameSize(frame);
		if (bsz == 0)
			continue;
		pos += bsz;
		if (frame->m_frameID[0] == 0) {
			break;
		}
		else if (memcmp(frame->m_frameID, "TT2", 3) == 0) {
			m_title.Set(&body[1], bsz - 1, body[0]);
		}
		else if (memcmp(frame->m_frameID, "TP1", 3) == 0) {
			m_artist.Set(&body[1], bsz - 1, body[0]);
		}
		else if (memcmp(frame->m_frameID, "TAL", 3) == 0) {
			m_album.Set(&body[1], bsz - 1, body[0]);
		}
		else if (memcmp(frame->m_frameID, "TYE", 3) == 0) {
			m_year.CopyFromCSTR(&body[1], bsz - 1, -1);
		}
		else if (memcmp(frame->m_frameID, "COM", 3) == 0) {
			int term = body[0] == CODE_LATIN1 ? 1 : 2;
			for (int i = 4; i < bsz - term; i++) {
				if (body[i] == 0) {
					m_comment.Set(&body[i + term], bsz - (i + term), body[0]);
					break;
				}
			}
		}
		else if (memcmp(frame->m_frameID, "TCO", 3) == 0) {
			TString s;
			s.CopyFrom(&body[1], bsz);
			TString t = s.strtok_first("()");
			m_genre = t.atoi();
		}
		else if (memcmp(frame->m_frameID, "TRK", 3) == 0) {
			TString s;
			s.CopyFrom(&body[1], bsz);
			TString t = s.strtok_first("/");
			m_track = t.atoi();
			t = s.strtok_next("");
			m_trackMax = t.atoi();
		}
	}
	if (m_title.m_encoding > CODE_LATIN1 ||
	        m_artist.m_encoding > CODE_LATIN1 ||
	        m_album.m_encoding > CODE_LATIN1 ||
	        m_comment.m_encoding > CODE_LATIN1) {
		m_loadEnc = CODE_UTF16;
	}
	else {
		/* Ȃ`FbNKv */
		m_loadEnc = CODE_AS_IS;
		if (m_loadEnc == CODE_AS_IS)
			m_loadEnc = m_title.CheckString();
		if (m_loadEnc == CODE_AS_IS)
			m_loadEnc = m_artist.CheckString();
		if (m_loadEnc == CODE_AS_IS)
			m_loadEnc = m_album.CheckString();
		if (m_loadEnc == CODE_AS_IS)
			m_loadEnc = m_comment.CheckString();
	}

	DecodeStrings();

	m_saveEnc = m_loadEnc;

	return TRUE;
}

long NTag::CalcV23FrameSize(ID3_V2_3_FRAME *frame) {
	return (frame->m_size[0] << (8 * 3)) + (frame->m_size[1] << (8 * 2)) + (frame->m_size[2] << (8 * 1)) + (frame->m_size[3]);
}

Boolean NTag::LoadV23Tag(TFileIO *file, long tagSize) {
	TMemory buff(tagSize);
	char *p = (char *)buff;
	file->Read(tagSize, (char *)buff);
	long pos = 0;
	for (; pos < tagSize;) {
		ID3_V2_3_FRAME *frame = (ID3_V2_3_FRAME *)&p[pos];
		pos += sizeof(ID3_V2_3_FRAME);
		char *body = &p[pos];
		long bsz = CalcV23FrameSize(frame);
		if (bsz == 0)
			continue;
		pos += bsz;
		if (frame->m_frameID[0] == 0) {
			break;
		}
		else if (memcmp(frame->m_frameID, "TIT2", 4) == 0) {
			m_title.Set(&body[1], bsz - 1, body[0]);
		}
		else if (memcmp(frame->m_frameID, "TPE1", 4) == 0) {
			m_artist.Set(&body[1], bsz - 1, body[0]);
		}
		else if (memcmp(frame->m_frameID, "TALB", 4) == 0) {
			m_album.Set(&body[1], bsz - 1, body[0]);
		}
		else if (memcmp(frame->m_frameID, "TYER", 4) == 0) {
			m_year.CopyFromCSTR(&body[1], bsz - 1, -1);
		}
		else if (memcmp(frame->m_frameID, "COMM", 3) == 0) {
			int term = body[0] == CODE_LATIN1 ? 1 : 2;
			for (int i = 4; i < bsz - term; i++) {
				if (body[i] == 0) {
					m_comment.Set(&body[i + term], bsz - (i + term), body[0]);
					break;
				}
			}
		}
		else if (memcmp(frame->m_frameID, "TCON", 4) == 0) {
			TString s;
			s.CopyFrom(&body[1], bsz);
			TString t = s.strtok_first("()");
			m_genre = t.atoi();
		}
		else if (memcmp(frame->m_frameID, "TRCK", 4) == 0) {
			TString s;
			s.CopyFrom(&body[1], bsz);
			TString t = s.strtok_first("/");
			m_track = t.atoi();
			t = s.strtok_next("");
			m_trackMax = t.atoi();
		}
	}
	if (m_title.m_encoding > CODE_LATIN1 ||
	        m_artist.m_encoding > CODE_LATIN1 ||
	        m_album.m_encoding > CODE_LATIN1 ||
	        m_comment.m_encoding > CODE_LATIN1) {
		m_loadEnc = CODE_UTF16;
	}
	else {
		/* Ȃ`FbNKv */
		m_loadEnc = CODE_AS_IS;
		if (m_loadEnc == CODE_AS_IS)
			m_loadEnc = m_title.CheckString();
		if (m_loadEnc == CODE_AS_IS)
			m_loadEnc = m_artist.CheckString();
		if (m_loadEnc == CODE_AS_IS)
			m_loadEnc = m_album.CheckString();
		if (m_loadEnc == CODE_AS_IS)
			m_loadEnc = m_comment.CheckString();
	}

	DecodeStrings();

	m_saveEnc = m_loadEnc;

	return TRUE;
}

Boolean NTag::LoadV2Tag() {
	TFileIO file(m_filePath);
	if (file.IsGood() == FALSE)
		return FALSE;
	long fileSize = file.GetFileSize();
	if (fileSize < sizeof(ID3_V2_HEAD))
		return FALSE;
	ID3_V2_HEAD head;
	if (file.Read(sizeof(ID3_V2_HEAD), &head) != sizeof(ID3_V2_HEAD))
		return FALSE;
	if (memcmp(head.m_tag, "ID3", 3) != 0)
		return FALSE;
	if (head.m_flags != 0)
		return FALSE;

	long tagSize = CalcV2TagSize(&head);
	m_soundStartPos = sizeof(ID3_V2_HEAD) + tagSize;
	m_soundSize -= m_soundStartPos;
	if (m_soundSize < 0)
		return FALSE;

	m_version = head.m_major;

	if (m_version == TAG_VERSION_2_2) {
		return LoadV22Tag(&file, tagSize);
	}
	else if (m_version >= TAG_VERSION_2_3) {
		return LoadV23Tag(&file, tagSize);
	}

	return TRUE;
}

void NTag::EncodeStrings() {
	int scriptCode = GetViewScriptCode();
	if (m_version >= TAG_VERSION_2_2) {
		m_title.EncodeString(m_saveEnc, scriptCode);
		m_artist.EncodeString(m_saveEnc, scriptCode);
		m_album.EncodeString(m_saveEnc, scriptCode);
		m_comment.EncodeString(m_saveEnc, scriptCode);
	}
	else {
		ID3_V1 *data;
		m_title.EncodeString(m_saveEnc, scriptCode, sizeof(data->m_title));
		m_artist.EncodeString(m_saveEnc, scriptCode, sizeof(data->m_artist));
		m_album.EncodeString(m_saveEnc, scriptCode, sizeof(data->m_album));
		if (m_version >= TAG_VERSION_1_0)
			m_comment.EncodeString(m_saveEnc, scriptCode, sizeof(data->u.v10.m_comment));
		else
			m_comment.EncodeString(m_saveEnc, scriptCode, sizeof(data->u.v11.m_comment));
	}
}

void NTag::MakeV1TagSub(char *dst, TMemory &src) {
	int count = src.GetLength();
	if (count == 0)
		return;
	char *p = (char *)src;
	if (p[count - 1] == 0)
		count = strlen(p);
	memcpy(dst, p, count);
}

void NTag::MakeV1Tag(TMemory *buffer) {
	ID3_V1 data;
	memset(&data, 0x20, sizeof(data));
	memcpy(data.m_tag, "TAG", sizeof(data.m_tag));
	MakeV1TagSub(data.m_title, m_title.m_org);
	MakeV1TagSub(data.m_artist, m_artist.m_org);
	MakeV1TagSub(data.m_album, m_album.m_org);
	MakeV1TagSub(data.u.v10.m_comment, m_comment.m_org);
	TString ys = m_year;
	TString year;
	year.sprintf("%d    ", ys.atoi());
	memcpy(data.m_year, (char *)year, sizeof(data.m_year));
	if (m_version == TAG_VERSION_1_1) {
		data.u.v11.m_null = 0;
		data.u.v11.m_track = m_track;
	}
	data.m_genre = m_genre;
	buffer->ChangeLength(sizeof(data));
	memcpy((char *)*buffer, &data, sizeof(data));
}

int NTag::MakeV2Frame(char *frame, TString frameID, int sz) {
	char *p = frame;
	int frameIDSize = (m_version == TAG_VERSION_2_2 ? 3 : 4);
	memcpy(p, (char *)frameID, frameIDSize);
	p += frameIDSize;
	int frameSizeSize = (m_version == TAG_VERSION_2_2 ? 3 : 4);
	for (int i = 0; i < frameSizeSize; i++) {
		*p = ((sz >> (8 * (frameSizeSize - 1 - i))) & 0xFF);
		p++;
	}
	if (m_version > TAG_VERSION_2_2)
		p += 2;
	return p - frame;
}

int NTag::MakeV2TextFrame(char *frame, TString frameID, NTagString &data) {
	if (data.m_str.IsEmpty())
		return 0;
	int sz = data.m_org.GetLength() + 1 /* encoding */;
	char *p = frame;
	p += MakeV2Frame(p, frameID, sz);
	*p = (data.m_encoding >= CODE_UTF16 ? data.m_encoding : CODE_LATIN1);
	p++;
	memcpy(p, (char *)data.m_org, data.m_org.GetLength());
	p += data.m_org.GetLength();
	return p - frame;
}

int NTag::MakeV2CommentFrame(char *frame, TString frameID, NTagString &data) {
	if (data.m_str.IsEmpty())
		return 0;
	int sz = data.m_org.GetLength() + 1 /* encoding */ + 3 /* language */ +
	         (m_saveEnc < CODE_UTF16 ? 1 : 4);
	char *p = frame;
	p += MakeV2Frame(p, frameID, sz);
	*p = (data.m_encoding >= CODE_UTF16 ? data.m_encoding : CODE_LATIN1);
	p++;
	memcpy(p, thePref->m_commentLanguage, 3 /* language */);
	p += 3;
	if (m_saveEnc < CODE_UTF16) {
		*p = 0;
		p += 1;
	}
	else {
		memcpy(p, "\xFF\xFE\0\0", 4);
		p += 4;
	}
	memcpy(p, (char *)data.m_org, data.m_org.GetLength());
	p += data.m_org.GetLength();
	return p - frame;
}

int NTag::MakeV2ASCIIFrame(char *frame, TString frameID, TString &data) {
	if (data.IsEmpty())
		return 0;
	int sz = data.GetLength() + 1 /* null */ + 1 /* encoding */;
	char *p = frame;
	p += MakeV2Frame(p, frameID, sz);
	*p = CODE_LATIN1;
	p++;
	memcpy(p, (char *)data, data.GetLength() + 1);
	p += (data.GetLength() + 1);
	return p - frame;
}

void NTag::SetV2TagSize(ID3_V2_HEAD *head, int sz) {
	head->m_size[3] = (sz & 0x7F);
	head->m_size[2] = ((sz >> 7) & 0x7F);
	head->m_size[1] = ((sz >> 7 * 2) & 0x7F);
	head->m_size[0] = ((sz >> 7 * 3) & 0x7F);
}

void NTag::MakeV2Tag(TMemory *buffer) {
	/* GcȃTCYvZ */
	int sz = 128 +
	         m_title.m_org.GetLength() +
	         m_artist.m_org.GetLength() +
	         m_album.m_org.GetLength() +
	         m_comment.m_org.GetLength() +
	         m_year.GetLength();
	char *data = new char [sz];
	memset(data, 0, sz);
	char *p = data;

	ID3_V2_HEAD *head = (ID3_V2_HEAD *)p;
	memcpy(head->m_tag, "ID3", sizeof(head->m_tag));
	head->m_major = m_version;
	head->m_minor = 0;
	p += sizeof(ID3_V2_HEAD);

	TString year, genre, track;
	TString ys = m_year;
	int y = ys.atoi();
	if (y != 0)
		year.sprintf("%d", y);
	genre.sprintf("(%d)", m_genre);
	if (m_track != 0) {
		if (m_trackMax > 0)
			track.sprintf("%d/%d", m_track, m_trackMax);
		else
			track.sprintf("%d", m_track);
	}

	Boolean isV22 = (m_version == TAG_VERSION_2_2);
	p += MakeV2TextFrame(p, isV22 ? "TT2" : "TIT2", m_title);
	p += MakeV2TextFrame(p, isV22 ? "TP1" : "TPE1", m_artist);
	p += MakeV2TextFrame(p, isV22 ? "TAL" : "TALB", m_album);
	p += MakeV2ASCIIFrame(p, isV22 ? "TYE" : "TYER", year);
	p += MakeV2ASCIIFrame(p, isV22 ? "TCO" : "TCON", genre);
	p += MakeV2ASCIIFrame(p, isV22 ? "TRK" : "TRCK", track);
	p += MakeV2CommentFrame(p, isV22 ? "COM" : "COMM", m_comment);

	SetV2TagSize(head, p - data - sizeof(ID3_V2_HEAD));

	buffer->ChangeLength(p - data);
	memcpy((char *)*buffer, data, p - data);
	delete [] data;
}

void NTag::MakeTag(TMemory *buffer) {
	EncodeStrings();
	if (m_version == TAG_VERSION_1_1 || m_version == TAG_VERSION_1_0) {
		MakeV1Tag(buffer);
	}
	else {
		MakeV2Tag(buffer);
	}
}

int NTag::GetViewScriptCode() {
	if (GetContainer() != NULL)
		if (((NTagList *)GetContainer())->m_view != NULL)
			return ((NTagList *)GetContainer())->m_view->m_scriptCode;
	return ::FontToScript(0);
}

void NTag::SetUndo(int cmd) {
	if (GetContainer() != NULL)
		theMEdit->m_undoTags.SetOneUndoTag(((NTagList *)GetContainer())->m_view, cmd, this);
}

TUnicodeTextEncodingInfo *NTag::GetUniEncInfo() {
	return &((NTagList *)GetContainer())->m_view->m_uniEncInfo;
}

TCFString NTag::GetStringByPropertyID(DataBrowserPropertyID property, int forWhat) {
	switch (property) {
	case COLMN_ID_MODIFY:
		return m_modify ? "M" : "-";
	case COLMN_ID_FILENAME:
		return m_fileName;
	case COLMN_ID_TITLE:
		return m_title.m_str;
	case COLMN_ID_ARTIST:
		return m_artist.m_str;
	case COLMN_ID_ALBUM:
		return m_album.m_str;
	case COLMN_ID_YEAR:
		return m_year;
	case COLMN_ID_TRACK:
		return GetTrackString(property);
	case COLMN_ID_COMMENT:
		return m_comment.m_str;
	case COLMN_ID_GENRE:
		return GetGenreString(forWhat);
	case COLMN_ID_VERSION:
		return GetVersionString();
	case COLMN_ID_LOADENC:
		return GetCodingString(m_loadEnc);
	case COLMN_ID_SAVEENC:
		return GetCodingString(m_saveEnc);
	case COLMN_ID_TRACKNUM:
		return GetTrackString(property);
	case COLMN_ID_TRACKMAX:
		return GetTrackString(property);
	default:
		return "";
	}
}

void NTag::SetStringByPropertyID(DataBrowserPropertyID property, TCFString s) {
	struct {
		DataBrowserPropertyID m_property;
		TUniString *m_sp;
		int *m_ip;
	}
	typeArray[] = {
		{COLMN_ID_FILENAME, &m_fileName, NULL},
		{COLMN_ID_TITLE, &m_title.m_str, NULL},
		{COLMN_ID_ARTIST, &m_artist.m_str, NULL},
		{COLMN_ID_ALBUM, &m_album.m_str, NULL},
		{COLMN_ID_YEAR, &m_year, NULL},
		{COLMN_ID_COMMENT, &m_comment.m_str, NULL},
		{COLMN_ID_TRACK, NULL, &m_track},
		{COLMN_ID_GENRE, NULL, &m_genre},
		{COLMN_ID_VERSION, NULL, &m_version},
		{COLMN_ID_LOADENC, NULL, &m_loadEnc},
		{COLMN_ID_SAVEENC, NULL, &m_saveEnc},
		{COLMN_ID_TRACKNUM, NULL, &m_track},
		{COLMN_ID_TRACKMAX, NULL, &m_trackMax},
		{0, NULL, NULL}
	};

	for (int i = 0; typeArray[i].m_property != 0; i++) {
		if (typeArray[i].m_property == property) {
			if (typeArray[i].m_sp != NULL) {
				if (*typeArray[i].m_sp != s) {
					*typeArray[i].m_sp = s;
					m_modify = TRUE;
				}
			}
			else if (typeArray[i].m_ip != NULL) {
				TString ss = s;
				int n = 0;
				if (property == COLMN_ID_GENRE)
					ss = ss.strtok_first("()");
				n = ss.atoi();
				if (*typeArray[i].m_ip != n) {
					*typeArray[i].m_ip = n;
					if (property != COLMN_ID_LOADENC)
						m_modify = TRUE;
				}
			}

			if (typeArray[i].m_property == COLMN_ID_FILENAME)
				CorrectFileName();
			break;
		}
	}
}

void NTag::UpdateDataBrowser() {
	DataBrowserItemID itemID = (DataBrowserItemID)this;
	((NTagList *)GetContainer())->m_view->m_titleBox.m_browser.UpdateDataBrowserItems(0, 1, &itemID, kDataBrowserItemNoProperty, kDataBrowserNoItem);
}

#define EXT_MP3		".mp3"

void NTag::CopyFileName2Title() {
	TCFString s = DeleteFileExtention(m_fileName, EXT_MP3);
	SetStringByPropertyID(COLMN_ID_TITLE, s);
	UpdateDataBrowser();
}

void NTag::CopyTitle2FileName() {
//	CopyToUndoBuffer();
	TUniString t = m_title.m_str + ".mp3";
//	TString s, t;
//	s.CopyFrom(m_title.m_str, 31 - 4);
//	t.sprintf("%s.mp3", (char *)s);
	SetStringByPropertyID(COLMN_ID_FILENAME, t);
	UpdateDataBrowser();
}

void NTag::CopyParent2Album() {
	SetStringByPropertyID(COLMN_ID_ALBUM, m_filePath.m_dir.GetDirName());
	UpdateDataBrowser();
}

void NTag::CopyGranpa2Artist() {
	SetStringByPropertyID(COLMN_ID_ARTIST, m_filePath.m_dir.GetParent().GetDirName());
	UpdateDataBrowser();
}

void NTag::PlusTrackFileName() {
	if (m_track == 0)
		return;
	TString number, format;
//	TUniString body = DeleteFileExtention(m_fileName, EXT_MP3);
//	Boolean hasExt = (body.GetLength() < m_fileName.GetLength());
	format.sprintf("%s%sd%s", "%",
	               thePref->m_trackFileFig == 3 ? "03" : (thePref->m_trackFileFig == 2 ? "02" : ""),
	               thePref->m_trackFileSpc ? " " : "");
	number.sprintf((char *)format, m_track);
	TUniString result = (TUniString)number + m_fileName;
	SetStringByPropertyID(COLMN_ID_FILENAME, result);
	UpdateDataBrowser();
}

void NTag::PlusTrackTitle() {
	if (m_track == 0)
		return;
	TString number, format;
	format.sprintf("%s%sd%s", "%",
	               thePref->m_trackTitleFig == 3 ? "03" : (thePref->m_trackTitleFig == 2 ? "02" : ""),
	               thePref->m_trackTitleSpc ? " " : "");
	number.sprintf((char *)format, m_track);
	TUniString result = (TUniString)number + m_title.m_str;
	SetStringByPropertyID(COLMN_ID_TITLE, result);
	UpdateDataBrowser();
}

void NTag::WriteTSVLine(TFileWriter *file) {
	int scriptCode = kCFStringEncodingUTF8/*GetViewScriptCode()*/;
	NColumnEditable **columnOrder = ((NTagList *)GetContainer())->m_view->m_titleBox.m_columnOrder;
	Boolean first = TRUE;
	for (int i = 0; i < COLUMN_COUNT; i++) {
		if (columnOrder[i]->IsEnableTSV() == FALSE)
			continue;
		//////////////////////////////////////////////////
		// 2006.01.27 ۑ̕GR[h͂ǂH
		// ݂SHIFT_JIS
		// UTF8ɂ邱ƂlǂB
		// ǂ݂̂݊͂܂CɂKv͂ȂB
		//////////////////////////////////////////////////
		TCFString r = GetStringByPropertyID(columnOrder[i]->m_property, FOR_TSV);
		r.SetScriptCode(scriptCode);
		TString s = r;
		if (first == FALSE)
			file->PutC('\t');
		first = FALSE;
		if (s.GetLength() > 0)
			file->PutP((char *)s, s.GetLength());
	}
	file->PutC('\r');
}

void NTag::ReadTSVLine(TString &line) {
	int scriptCode = kCFStringEncodingUTF8/*GetViewScriptCode()*/;
	int i;
	TStringList items;
	items.SetScriptCode(scriptCode);
	char *p = line;
	int count = line.GetLength();
	int start = 0;
	char c = 0;
	for (i = 0; i < count; i++) {
		c = p[i];
		if (c == '\t') {
			TString *s = new TString;
			if (i > start) {
				int sz = i - start;
				if (sz > 255)
					sz = 255;
				s->CopyFrom(&p[start], sz);
			}
			s->SetScriptCode(scriptCode);
			items.Append(s);
			start = i + 1;
		}
	}
	if (c == '\t') {
		items.AppendStr("");
	}
	else if (start < count) {
		TString *s = new TString;
		int sz = count - start;
		if (sz > 255)
			sz = 255;
		s->CopyFrom(&p[start], sz);
		s->SetScriptCode(scriptCode);
		items.Append(s);
	}

	NColumnEditable **columnOrder = ((NTagList *)GetContainer())->m_view->m_titleBox.m_columnOrder;
	Boolean first = TRUE;
	TString *sp = items.GetTop();
	for (i = 0; sp != NULL && i < COLUMN_COUNT; i++) {
		if (columnOrder[i]->IsEnableTSV() == FALSE)
			continue;
		TCFString cfs = *sp;
		if (cfs.IsNull()) {
		}
		else {
			SetStringByPropertyID(columnOrder[i]->m_property, cfs);
		}
		sp = sp->GetNext();
	}
	UpdateDataBrowser();
}

void NTag::CorrectFileName() {
	int count = m_fileName.GetLength();
	if (count == 0) {
		m_fileName = "untitled.mp3";
		return;
	}

	/* _ȃLN^̋ */
	UniChar *p = m_fileName;
	for (int i = 0; i < count;) {
		UniChar uc = ntohs(p[i]);
		if (uc == ':' || uc == '/')
			p[i] = htons('_');
		i += 1;
	}

	/*
		char *p = m_fileName;
		for (int i = 0; i < count;)
		{
			if (CharacterByteType(&p[i], 0, FontToScript(0)) == smFirstByte)
			{
				i += 2;
			}
			else
			{
				if (p[i] == ':' || p[i] == '/')
					p[i] = '_';
				i += 1;
			}
		}
	 
		// ̋
		TString ext;
		TString s = DeleteFileExtention(m_fileName, EXT_MP3, &ext);
		int limit = ext.GetLength() > 0 ? 31 - 4 : 31;
		if (s.GetLength() <= limit)
			return;
	 
		p = (char *)s;
		count = 0;
		for (;;)
		{
			int charByte = CharacterByteType(&p[count], 0, FontToScript(0)) == smFirstByte ? 2 : 1;
			if (charByte + count > limit)
				break;
			count += charByte;
		}
		s.CopyFrom(m_fileName, count);
		m_fileName.sprintf("%s%s", (char *)s, (char *)ext);	
	*/
}

NTagList::NTagList() {
	m_array = NULL;
}

NTagList::~NTagList() {
	RemoveDeleteAll();
	if (m_array != NULL)
		delete [] m_array;
}

int NTagList::MakeOrderArray() {
	int count = GetCount();
	if (count == 0)
		return count;
	if (m_array != NULL)
		delete [] m_array;
	m_array = new NTag *[count];
	NTag *tag = GetTop();
	for (int i = 0; tag != NULL; tag = tag->GetNext(), i++) {
		DataBrowserTableViewRowIndex row;
		m_view->m_titleBox.m_browser.GetDataBrowserTableViewItemRow((DataBrowserItemID)tag, &row);
		m_array[row] = tag;
	}
	return count;
}

void NTagList::SaveFiles() {
	int count = GetCount();
	if (count == 0)
		return;

	Boolean *bSaveTemp = new Boolean [count];

	NTag *tag;
	int index;
	for (index = 0, tag = GetTop(); tag != NULL; tag = tag->GetNext(), index++) {
		if (theSystem->hasThreadMgr)
			YieldToAnyThread();
		theCursor->Set(SPIN_WATCH_CURSOR, TRUE);
		if (tag->m_modify) {
			bSaveTemp[index] = FALSE;
			if (tag->m_version >= TAG_VERSION_2_2)
				bSaveTemp[index] = TRUE;
			if (tag->m_fileName != tag->m_filePath.m_fileName)
				bSaveTemp[index] = TRUE;
			if (tag->m_soundStartPos != 0)
				bSaveTemp[index] = TRUE;
			tag->m_info = tag->m_filePath.GetFinderInfo();
			TMemory tagBuffer;
			tag->MakeTag(&tagBuffer);
			if (bSaveTemp[index] == FALSE) {
				TFileIO file(tag->m_filePath);
				file.SetEOF(tag->m_soundSize);
				file.SetFPos(fsFromLEOF, 0);
				file.Write(tagBuffer.GetLength(), (char *)tagBuffer);
			}
			else {
				TFileReader inFile;
				TFileWriter outFile;
				TString name1 = tag->m_filePath.m_fileName;
				TString name2 = tag->m_tempPath.m_fileName;
				inFile.OpenForGet(tag->m_filePath);
				outFile.OpenForPut(tag->m_tempPath, tag->m_info.m_info.fdCreator, tag->m_info.m_info.fdType);
				if (tag->m_version >= TAG_VERSION_2_2)
					outFile.PutP((char *)tagBuffer, tagBuffer.GetLength());
				inFile.Seek(fsFromStart, tag->m_soundStartPos);
				for (int i = 0; i < tag->m_soundSize; i++)
					outFile.PutC(inFile.GetC());
				if (tag->m_version < TAG_VERSION_2_2)
					outFile.PutP((char *)tagBuffer, tagBuffer.GetLength());
				if (tag->m_version < TAG_VERSION_2_2)
					tag->m_soundStartPos = 0;
				else
					tag->m_soundStartPos = tagBuffer.GetLength();
			}
		}
	}

	for (index = 0, tag = GetTop(); tag != NULL; tag = tag->GetNext(), index++) {
		if (theSystem->hasThreadMgr)
			YieldToAnyThread();
		theCursor->Set(SPIN_WATCH_CURSOR, TRUE);
		if (tag->m_modify) {
			if (bSaveTemp[index])
				tag->m_filePath.DeleteFile();
		}
	}

	for (index = 0, tag = GetTop(); tag != NULL; tag = tag->GetNext(), index++) {
		if (theSystem->hasThreadMgr)
			YieldToAnyThread();
		theCursor->Set(SPIN_WATCH_CURSOR, TRUE);
		if (tag->m_modify) {
			if (bSaveTemp[index])
				tag->m_tempPath.RenameFile(tag->m_fileName);
			tag->m_filePath.m_fileName = tag->m_fileName;
			tag->m_filePath.SetFinderInfo(tag->m_info);
		}
		tag->m_loadEnc = tag->m_saveEnc;
		tag->m_modify = FALSE;
		m_view->m_titleBox.m_browser.UpdateDataBrowserItems(0, 1, (DataBrowserItemID *)&tag, kDataBrowserItemNoProperty, kDataBrowserNoItem);
	}

	theCursor->Reset();

	delete [] bSaveTemp;
}

void NTagList::LoadTagFiles(TListBase *list, TStandardFileReply *file) {
	TSavePort savePort(m_view);

	if (file->m_isFolder || file->m_isVolume) {
		TDirectory dir(file->m_dir, file->m_fName);
		short n = dir.GetCatFileNum();
		for (int i = 0; i < n; i++) {
			long attrib, dirID, fFlags;
			TCFString fileName = dir.GetCatInfoByDirIndex(i, &attrib, &fFlags, &dirID);
			if (fileName.IsEmpty()) {
			}
			else if ((attrib & fsSBDrNmFls) != 0)	/* Folder */
			{
			}
			else	/* File */
			{
				if (GetByFilePath(TFilePath(fileName, dir)) == NULL) {
					FInfo info;
					OSErr err = dir.GetFInfoByName(fileName, &info);
					if (err == noErr) {
						if (theMFile->OpenFileFilter(this, TFilePath(fileName, dir), info.fdType)) {
							NTag * tag = new NTag(this);
							tag->LoadTag(TFilePath(fileName, dir));
							list->Append(tag);
						}
					}
				}
			}
		}
		thePref->m_volume = dir.m_volume;
		thePref->m_dirID = dir.m_dirID;
	}
	else {
		TFilePath filePath(file->m_fName, file->m_dir);
		TFinderInfo info = filePath.GetFinderInfo();
		if (theMFile->OpenFileFilter(this, filePath, info.m_info.fdType)) {
			NTag * tag = new NTag(this);
			tag->LoadTag(filePath);
			list->Append(tag);
		}
		thePref->m_volume = file->m_dir.m_volume;
		thePref->m_dirID = file->m_dir.m_dirID;
	}
}

int NTagList_CompareFileName(const void *elem1, const void *elem2);
int NTagList_CompareFileName(const void *elem1, const void *elem2) {
	NTag *tag1 = *((NTag **)elem1);
	NTag *tag2 = *((NTag **)elem2);
	return tag1->m_fileName.Compare(tag2->m_fileName);
}

int NTagList_CompareTrackNumber(const void *elem1, const void *elem2);
int NTagList_CompareTrackNumber(const void *elem1, const void *elem2) {
	NTag *tag1 = *((NTag **)elem1);
	NTag *tag2 = *((NTag **)elem2);
	if (tag1->m_track == tag2->m_track)
		return NTagList_CompareFileName(elem1, elem2);
	if (tag1->m_track == 0)
		return 1;
	if (tag2->m_track == 0)
		return (-1);
	if (tag1->m_track < tag2->m_track)
		return (-1);
	return 1;
}

void NTagList::AppendFiles(TStandardFileReplyList *fileList) {
	int i;
	if (fileList->GetCount() == 0)
		return;

	TListBase list;
	for (TStandardFileReply *file = fileList->GetTop(); file != NULL; file = file->GetNext()) {
		theCursor->Set(SPIN_WATCH_CURSOR, TRUE);
		LoadTagFiles(&list, file);
	}

	if (list.GetCount() == 0)
		return;

	TArrayBase array;
	array.CopyFromList(list);
	array.qsort(NTagList_CompareTrackNumber);

	int count = array.GetCount();

	DataBrowserItemID *items = new DataBrowserItemID[array.GetCount()];
	for (i = 0; i < array.GetCount(); i++) {
		TBase *p1 = array[i];
		NTag *p2 = (NTag *)array[i];
		items[i] = (DataBrowserItemID)(NTag *)array[i];
		Append((NTag *)array[i]);
	}
	m_view->m_titleBox.m_browser.AddDataBrowserItems(0, array.GetCount(), items);
	m_view->m_titleBox.OnChangeFont(m_view->GetFont(), m_view->GetFontSize());

	theCursor->Reset();

	delete [] items;
}

NTag *NTagList::GetBySelection() {
	for (NTag *tag = GetTop(); tag != NULL; tag = tag->GetNext()) {
		if (m_view->m_titleBox.m_browser.IsDataBrowserItemSelected((DataBrowserItemID)tag))
			return tag;
	}
	return NULL;
}

NTag *NTagList::GetByFilePath(TFilePath filePath) {
	for (NTag *tag = GetTop(); tag != NULL; tag = tag->GetNext()) {
		if (tag->m_filePath == filePath)
			return tag;
	}
	return NULL;
}

void NTagList::CopyFileName2Title() {
	for (NTag *tag = GetTop(); tag != NULL; tag = tag->GetNext())
		tag->CopyFileName2Title();
}

void NTagList::CopyTitle2FileName() {
	for (NTag *tag = GetTop(); tag != NULL; tag = tag->GetNext())
		tag->CopyTitle2FileName();
}

void NTagList::CopyParent2Album() {
	for (NTag *tag = GetTop(); tag != NULL; tag = tag->GetNext())
		tag->CopyParent2Album();
}

void NTagList::CopyGranpa2Artist() {
	for (NTag *tag = GetTop(); tag != NULL; tag = tag->GetNext())
		tag->CopyGranpa2Artist();
}

void NTagList::PlusTrackFileName() {
	for (NTag *tag = GetTop(); tag != NULL; tag = tag->GetNext())
		tag->PlusTrackFileName();
}

void NTagList::PlusTrackTitle() {
	for (NTag *tag = GetTop(); tag != NULL; tag = tag->GetNext())
		tag->PlusTrackTitle();
}

Boolean NTagList::ImportTSV(TFilePath &path) {
	int scriptCode = kCFStringEncodingUTF8/*m_view->m_scriptCode*/;
	int count = MakeOrderArray();
	if (count == 0)
		return FALSE;
	TStringList data;
	data.SetScriptCode(scriptCode);
	data.LoadFile(path);
	TString *line = data.GetTop();
	for (int i = 0; i < count && line != NULL; i++, line = line->GetNext())
		m_array[i]->ReadTSVLine(*line);
	return TRUE;
}

Boolean NTagList::ExportTSV(TFilePath &path) {
	int count = MakeOrderArray();
	if (count == 0)
		return FALSE;
	TFileWriter file;
	file.OpenForPut(path, APPL_CREATOR, 'TEXT');
	if (file.IsGood() == FALSE)
		return FALSE;
	for (int i = 0; i < count; i++)
		m_array[i]->WriteTSVLine(&file);
	return TRUE;
}

void NTagList::SetUndo(int cmd) {
	theMEdit->m_undoTags.SetAllUndoTags(m_view, cmd, this);
}

