/*
	NView.cpp
 
	GripGrop
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.04.04	1.0			Takeshi Yoneki
*/

#include "nglobal.h"

static NColumnEditable theColumnEditableTable[] = {
            {COLMN_ID_MODIFY, TRUE, FALSE, ""},
            {COLMN_ID_TRACK, TRUE, TRUE, "No."},
            //	{COLMN_ID_FILENAME, TRUE, FALSE, "File Name"},
            {COLMN_ID_FILENAME, TRUE, TRUE, "File Name"},	/* 2002.09.14 ŏIIɃXCb`ق */
            {COLMN_ID_TITLE, TRUE, TRUE, "Title"},
            {COLMN_ID_ARTIST, TRUE, TRUE, "Artist"},
            {COLMN_ID_ALBUM, TRUE, TRUE, "Album"},
            {COLMN_ID_YEAR, TRUE, TRUE, "Year"},
            {COLMN_ID_COMMENT, TRUE, TRUE, "Comment"},
            {COLMN_ID_GENRE, FALSE, TRUE, "Genre"},
            {COLMN_ID_VERSION, FALSE, FALSE, "ID3"},
            {COLMN_ID_LOADENC, FALSE, FALSE, "Source Enc"},
            {COLMN_ID_SAVEENC, FALSE, FALSE, "Target Enc"},
            {0, FALSE, FALSE, ""}
        };

Boolean NColumnEditable::IsEnableTSV() {
	if (m_property == COLMN_ID_FILENAME)
		return thePref->m_enableFileNameTSV != 0;
	else
		return m_tsv;
}

NGlobalData::NGlobalData() {
	TResource res('ISOM', 4000);
	char *p = (char *)res.HLock();
	memcpy(m_Latin1ToMacRoman, p, sizeof(m_Latin1ToMacRoman));
	memcpy(m_macRomanToLatin1, &p[256], sizeof(m_Latin1ToMacRoman));
	res.HUnlock();
	m_shiftJISStr.LoadSTRNum(STRNUM_ID_ENCASIS, STRNUM_SHIFTJIS);
	m_macRomanStr.LoadSTRNum(STRNUM_ID_ENCASIS, STRNUM_MACROMAN);
	m_asIsStr.LoadSTRNum(STRNUM_ID_ENCASIS, STRNUM_ASIS);

	m_statusNotModifyIcon.GetFromResource(ICON_MODIFY_NOT, 'Hun3', 'Mod-');
	m_statusModifyIcon.GetFromResource(ICON_MODIFY_DONE, 'Hun3', 'Mod+');
	m_statusModifyWarningIcon.GetFromResource(ICON_MODIFY_WARNING, 'Hun3', 'Modx');
}

Boolean EnableDirectEdit() {
	return (theSystem->carbonVersion >= 0x150 || theSystem->systemVersion >= 0x1000);
}

/*
	^CgXg{bNXNX
*/
NTitleListBox::NTitleListBox() {
	m_fontHeight = 0;
	m_dragCanAccept = FALSE;
	m_dragInContent = FALSE;
	m_editing = FALSE;
	memset(m_columnOrder, 0, sizeof(m_columnOrder));
	for (int i = 0; i <= COLMN_ID_LAST - COLMN_ID_FIRST; i++)
		m_columnOrder[i] = &theColumnEditableTable[thePref->m_columnOrder[i] - COLMN_ID_FIRST];
}

NTitleListBox::~NTitleListBox() {
	for (int i = 0; i <= COLMN_ID_LAST - COLMN_ID_FIRST; i++) {
		UInt16 width;
		m_browser.GetDataBrowserTableViewNamedColumnWidth(theColumnEditableTable[i].m_property, &width);
		thePref->m_columnWidth[i] = width;
	}

	m_browser.DisposeControl();
	m_rootControl.DisposeControl();
}

short NTitleListBox::OnChangeSize(short top) {
	TFontInfo fInfo;
	short fontHeight = fInfo.GetHeight();
	Boolean changeFont = m_fontHeight != fontHeight;
	m_fontHeight = fontHeight;

	TRect winRect = m_parent->GetPortRect();
	TRect bg(0, top, winRect.GetWidth(), winRect.GetHeight());
	m_bgRect = bg;
	m_boxRect = bg;
	m_vScrollRect = bg;
	m_vScrollRect.SetWidth(winRect.GetWidth());

	if (m_browser.IsNull() == FALSE) {
		m_browser.SetControlBounds(m_boxRect);
	}

	bg.InvalRect();

	return m_bgRect.GetHeight();
}

void NTitleListBox::OnUpdate() {
	m_browser.UpdateControls(*m_parent, m_parent->GetVisRgn());
}

void NTitleListBox::OnTask() {
	IdleControls(*m_parent);
}

int NTitleListBox::GetNextEditableColumn(int current) {
	int count = COLUMN_COUNT;
	int i, n;
	for (i = 0; i < count; i++) {
		if (m_columnOrder[i]->m_property == current) {
			n = i;
			break;
		}
	}
	for (;;) {
		n++;
		if (n >= count)
			n = 0;
		if (m_columnOrder[n]->m_editable)
			return m_columnOrder[n]->m_property;
	}
}

int NTitleListBox::GetPrevEditableColumn(int current) {
	int count = COLUMN_COUNT;
	int i, n;
	for (i = 0; i < count; i++) {
		if (m_columnOrder[i]->m_property == current) {
			n = i;
			break;
		}
	}
	for (;;) {
		n--;
		if (n < 0)
			n = count - 1;
		if (m_columnOrder[n]->m_editable)
			return m_columnOrder[n]->m_property;
	}
}

void NTitleListBox::OnKey(CEvent *ev) {
	int data = (ev->message & charCodeMask);
	int code = (ev->message & keyCodeMask) >> 8;
	Boolean shift = (ev->modifiers & shiftKey) != 0;
	Boolean option = (ev->modifiers & optionKey) != 0;
	Boolean control = (ev->modifiers & controlKey) != 0;

	int nextColumn = m_currentColumn;
	if (EnableDirectEdit()) {
		if (m_editing == FALSE) {
			if ((data == 0x09 && shift == FALSE) || data == 0x1D) {
				nextColumn = GetNextEditableColumn(m_currentColumn);
			}
			else if ((data == 0x09 && shift) || data == 0x1C) {
				nextColumn = GetPrevEditableColumn(m_currentColumn);
			}
			else if (m_currentColumn == COLMN_ID_FIRST && data == 0x0D && shift == FALSE) {
				theMID3->OnEdit(&m_view->m_tagList, m_view->m_tagList.GetBySelection());
				return;
			}
			else if (m_currentColumn == COLMN_ID_FIRST && data == 0x0D && shift) {
				theMID3->OnEdit(&m_view->m_tagList, NULL);
				return;
			}
		}
		if (thePref->m_directEdit != OFF && nextColumn != m_currentColumn) {
			DataBrowserPropertyFlags flags;
			GetDataBrowserPropertyFlags(m_browser, m_currentColumn, &flags);
			flags &= (~(kDataBrowserListViewSelectionColumn | kDataBrowserPropertyIsMutable));
			SetDataBrowserPropertyFlags(m_browser, m_currentColumn, flags);
			m_currentColumn = nextColumn;
			GetDataBrowserPropertyFlags(m_browser, m_currentColumn, &flags);
			flags |= kDataBrowserListViewSelectionColumn;
			if (m_currentColumn != COLMN_ID_MODIFY)
				flags |= kDataBrowserPropertyIsMutable;
			SetDataBrowserPropertyFlags(m_browser, m_currentColumn, flags);
		}
	}
	if (data == 0x1B) {
		if (m_editing == FALSE)
			SetDataBrowserSelectedItems(m_browser, 0, NULL, kDataBrowserItemsRemove);
		else
			SetDataBrowserEditItem(m_browser, 0, 0);
	}

	ControlPartCode part = m_browser.HandleControlKey((ev->message & keyCodeMask) >> 8, ev->message & charCodeMask, ev->modifiers);
}

void NTitleListBox::OnActivate(Boolean act) {
}

Boolean NTitleListBox::IsInside(TPoint mousePt) {
	return m_boxRect.PtInRect(mousePt);
}

static pascal OSStatus NTitleListBox_GetSetItemDataCallback(ControlRef browser,
        DataBrowserItemID itemID, DataBrowserPropertyID property,
        DataBrowserItemDataRef itemData, Boolean changeValue) {
	NTitleListBox *box = (NTitleListBox *)::GetControlReference(browser);
	NTag *tag = (NTag *)itemID;
	CFStringEncoding enc = box->m_view->GetTextEncoding();

	if (changeValue) {
		tag->SetUndo(UNDO_CMD_TYPING);
		TString s;
		TCFString cs;
		s.SetScriptCode(enc);
		cs.SetScriptCode(enc);
		if (property == COLMN_ID_TRACK) {
			box->m_browser.GetDataBrowserItemDataText(itemData, cs);
			s = cs;
			TString track, trackMax;
			TString t = s.strtok_first("/");
			track.sprintf("%d", t.atoi());
			t = s.strtok_next("");
			trackMax.sprintf("%d", t.atoi());
			tag->SetStringByPropertyID(COLMN_ID_TRACKNUM, track);
			tag->SetStringByPropertyID(COLMN_ID_TRACKMAX, trackMax);
		}
		else if (property >= COLMN_ID_FIRST && property <= COLMN_ID_LAST) {
			box->m_browser.GetDataBrowserItemDataText(itemData, cs);
			tag->SetStringByPropertyID(property, cs);
		}
		box->m_browser.UpdateDataBrowserItems(0, 1, &itemID, kDataBrowserItemNoProperty, kDataBrowserNoItem);
	}
	else {
		if (property == kDataBrowserItemIsEditableProperty) {
			box->m_browser.SetDataBrowserItemDataBooleanValue(itemData, TRUE);
		}
		else if (property == COLMN_ID_MODIFY) {
			box->m_browser.SetDataBrowserItemDataIcon(itemData,
			        tag->m_modify ?
			        (tag->CheckLimit() == 0 ? theGlobalData->m_statusModifyIcon : theGlobalData->m_statusModifyWarningIcon)
					        : theGlobalData->m_statusNotModifyIcon);
		}
		else if (property == COLMN_ID_FILENAME) {
			box->m_browser.SetDataBrowserItemDataIcon(itemData, tag->m_icon);
			box->m_browser.SetDataBrowserItemDataText(itemData, tag->m_fileName);
		}
		else if (property >= COLMN_ID_FIRST && property <= COLMN_ID_LAST) {
			tag->GetStringByPropertyID(property);
			box->m_browser.SetDataBrowserItemDataText(itemData, tag->GetStringByPropertyID(property));
		}
	}
	return noErr;
}

static pascal void NTitleListBox_ItemNotificationCallback(
    ControlRef browser,
    DataBrowserItemID itemID,
    DataBrowserItemNotification message) {
	NTitleListBox *box = (NTitleListBox *)::GetControlReference(browser);
	NTag *tag = (NTag *)itemID;
	switch (message) {
	case kDataBrowserItemSelected:
		break;
	case kDataBrowserEditStarted:
		theMEdit->m_undoTags.SetUndoNon();
		box->m_editing = TRUE;
		break;
	case kDataBrowserEditStopped:
		box->m_editing = FALSE;
		theCursor->Reset();
		break;
	case kDataBrowserItemDoubleClicked:
		theMID3->OnEdit(&box->m_view->m_tagList, tag);
	case kDataBrowserUserStateChanged: {
			for (DataBrowserTableViewColumnID i = COLMN_ID_FIRST; i <= COLMN_ID_LAST; i++) {
				DataBrowserTableViewColumnIndex position;
				box->m_browser.GetDataBrowserTableViewColumnPosition(i, &position);
				box->m_columnOrder[position] = &theColumnEditableTable[i - COLMN_ID_FIRST];
				thePref->m_columnOrder[position] = i;
			}
		}
		break;
	}
}

static pascal Boolean NTitleListBox_ItemCompareCallback(
    ControlRef browser, DataBrowserItemID itemOneID,
    DataBrowserItemID itemTwoID, DataBrowserPropertyID sortProperty) {
	NTitleListBox *box = (NTitleListBox *)::GetControlReference(browser);
	NTag *tag1 = (NTag *)itemOneID;
	NTag *tag2 = (NTag *)itemTwoID;
	if (sortProperty == COLMN_ID_TRACK) {
		if (tag1->m_track == tag2->m_track)
			return FALSE;
		if (tag1->m_track == 0)
			return FALSE;
		if (tag2->m_track == 0)
			return TRUE;
		return tag1->m_track < tag2->m_track;
	}
	else {
		TString s1 = tag1->GetStringByPropertyID(sortProperty);
		TString s2 = tag2->GetStringByPropertyID(sortProperty);
		return s1.strcmp(s2) < 0;
	}
}

static pascal Boolean NTitleListBox_AcceptDragCallback(
    ControlRef browser, DragReference dragRef, DataBrowserItemID itemID) {
	NTitleListBox *box = (NTitleListBox *)::GetControlReference(browser);

	TSavePort savePort(box->m_view);
	TDrag drag(dragRef);

	unsigned short numItems, i, numFlavors, j;
	numItems = drag.CountDragItems();
	for (i = 1; i <= numItems; i++) {
		ItemReference item;
		item = drag.GetDragItemReferenceNumber(i);
		FlavorType tp = '    ';
		numFlavors = drag.CountDragItemFlavors(item);
		for (j = 1; j <= numFlavors; j++) {
			tp = drag.GetFlavorType(item, j);
			if (tp == 'hfs ')
				return TRUE;
		}
	}
	return FALSE;
}

static pascal Boolean NTitleListBox_ReceiveDragCallback(
    ControlRef browser, DragReference dragRef, DataBrowserItemID itemID) {
	NTitleListBox *box = (NTitleListBox *)::GetControlReference(browser);

	TSavePort savePort(box->m_view);
	TDrag drag(dragRef);

	unsigned short numItems, i, numFlavors, j;
	numItems = drag.CountDragItems();

	TStandardFileReplyList fileList;

	for (i = 1; i <= numItems; i++) {
		ItemReference item = drag.GetDragItemReferenceNumber(i);
		FlavorType tp = '    ';
		numFlavors = drag.CountDragItemFlavors(item);
		for (j = 1; j <= numFlavors; j++) {
			tp = drag.GetFlavorType(item, j);
			if (tp == 'hfs ')
				break;
		}
		if (tp == 'hfs ') {
			long sz = sizeof(HFSFlavor);
			HFSFlavor hfsf;
			drag.GetFlavorData(item, 'hfs ', &hfsf, &sz, 0);
			if (drag.IsGood() == FALSE)
				continue;
			TFSSpec spec(hfsf.fileSpec);
			TFilePath path(spec);
			TFinderInfo info = path.GetFinderInfo();
			if (path.IsGood() && numItems == 1 && info.m_info.fdType == 'TEXT')
				return box->m_view->m_tagList.ImportTSV(path);
			fileList.AppendFile(spec);
		}
	}

	if (fileList.GetCount() > 0)
		theMFile->AddFiles(box->m_view, &fileList);

	return fileList.GetCount() > 0;
}

void NTitleListBox::SetAutoTrack() {
	int i;
	int count = m_view->m_tagList.GetCount();
	if (count == 0)
		return;
	DataBrowserTableViewRowIndex *row = new DataBrowserTableViewRowIndex[count];
	NTag *tag = m_view->m_tagList.GetTop();
	for (i = 0; tag != NULL; tag = tag->GetNext(), i++)
		m_browser.GetDataBrowserTableViewItemRow((DataBrowserItemID)tag, &row[i]);
	tag = m_view->m_tagList.GetTop();
	for (i = 0; tag != NULL; tag = tag->GetNext(), i++) {
		if (tag->m_track != row[i] + 1) {
			tag->m_track = row[i] + 1;
			tag->m_modify = TRUE;
			m_browser.UpdateDataBrowserItems(0, 1, (DataBrowserItemID *)&tag, kDataBrowserItemNoProperty, kDataBrowserNoItem);
		}
	}
	delete [] row;
	return;
}

void NTitleListBox::OnChangeFont(short fontNum, short fontSize) {
	if (m_browser.IsNull())
		return;

	ControlFontStyleRec fontStyle;
	memset(&fontStyle, 0, sizeof(fontStyle));
	fontStyle.flags = kControlUseFontMask | kControlUseSizeMask;
	fontStyle.font = fontNum;
	fontStyle.size = fontSize;
	m_rootControl.SetControlFontStyle(&fontStyle);
	m_browser.SetControlFontStyle(&fontStyle);
	m_view->m_scriptCode = FontToScript(fontNum);
	for (NTag *tag = m_view->m_tagList.GetTop(); tag != NULL; tag = tag->GetNext())
		m_view->m_titleBox.m_browser.UpdateDataBrowserItems(0, 1, (DataBrowserItemID *)&tag, kDataBrowserItemNoProperty, kDataBrowserNoItem);
}

void NTitleListBox::NewBox() {
	TSavePort savePort(m_parent);

	m_rootControl.CreateRootControl(*m_parent);

	m_browser.CreateDataBrowserControl(*m_parent, &m_boxRect, kDataBrowserListView);
	m_browser.SetControlReference((UInt32)this);

	Boolean frameAndFocus = false;
	m_browser.SetControlData(kControlNoPart, kControlDataBrowserIncludesFrameAndFocusTag, sizeof(frameAndFocus), &frameAndFocus);

	DataBrowserCallbacks callbacks;
	callbacks.version = kDataBrowserLatestCallbacks;
	InitDataBrowserCallbacks(&callbacks);
	callbacks.u.v1.itemDataCallback = NewDataBrowserItemDataUPP(NTitleListBox_GetSetItemDataCallback);
	callbacks.u.v1.itemNotificationCallback = NewDataBrowserItemNotificationUPP(NTitleListBox_ItemNotificationCallback);
	callbacks.u.v1.itemCompareCallback = NewDataBrowserItemCompareUPP(NTitleListBox_ItemCompareCallback);
	callbacks.u.v1.acceptDragCallback = NewDataBrowserAcceptDragUPP(NTitleListBox_AcceptDragCallback);
	callbacks.u.v1.receiveDragCallback = NewDataBrowserReceiveDragUPP(NTitleListBox_ReceiveDragCallback);

	m_browser.SetDataBrowserCallbacks(&callbacks);

	for (int i = 0; i <= COLMN_ID_LAST - COLMN_ID_FIRST; i++) {
		DataBrowserPropertyType pType = kDataBrowserTextType;
		if (thePref->m_columnOrder[i] == COLMN_ID_MODIFY)
			pType = kDataBrowserIconType;
		else if (thePref->m_columnOrder[i] == COLMN_ID_FILENAME)
			pType = kDataBrowserIconAndTextType;
		else
			pType = kDataBrowserTextType;

		DataBrowserPropertyFlags flags = kDataBrowserListViewDefaultColumnFlags;
		if (EnableDirectEdit() == FALSE && m_columnOrder[i]->m_editable)
			flags |= kDataBrowserListViewSelectionColumn;

		m_browser.AddColumn(m_columnOrder[i]->m_property, m_columnOrder[i]->m_title,
		                    thePref->m_columnWidth[i], pType, flags);
	}

	m_browser.SetDataBrowserSelectionFlags(kDataBrowserSelectOnlyOne);

	ChangeDirectEdit();
	m_view->SetAutomaticControlDragTrackingEnabledForWindow(TRUE);
	OnChangeFont(thePref->m_browseFont, thePref->m_browseFontSize);
}

void NTitleListBox::ChangeDirectEdit() {
	m_currentColumn = COLMN_ID_MODIFY;

	if (EnableDirectEdit() == FALSE)
		return;

	/*
		CarbonLib 1.5ȑOł͓IɃZNg̗LłȂB
	*/

	SetDataBrowserSelectedItems(m_browser, 0, NULL, kDataBrowserItemsRemove);
	if (thePref->m_directEdit != OFF) {
		for (int i = 0; i <= COLMN_ID_LAST - COLMN_ID_FIRST; i++) {
			DataBrowserPropertyFlags flags;
			GetDataBrowserPropertyFlags(m_browser, m_columnOrder[i]->m_property, &flags);
			flags &= (~(kDataBrowserListViewSelectionColumn | kDataBrowserPropertyIsMutable));
			SetDataBrowserPropertyFlags(m_browser, m_columnOrder[i]->m_property, flags);
		}
		//		m_currentColumn = COLMN_ID_MODIFY;
		DataBrowserPropertyFlags flags;
		GetDataBrowserPropertyFlags(m_browser, m_currentColumn, &flags);
		flags |= (kDataBrowserListViewSelectionColumn /*| kDataBrowserPropertyIsMutable*/);
		SetDataBrowserPropertyFlags(m_browser, m_currentColumn, flags);
	}
	else {
		for (int i = 0; i <= COLMN_ID_LAST - COLMN_ID_FIRST; i++) {
			if (m_columnOrder[i]->m_editable != false) {
				DataBrowserPropertyFlags flags;
				GetDataBrowserPropertyFlags(m_browser, m_columnOrder[i]->m_property, &flags);
				flags |= kDataBrowserListViewSelectionColumn;
				SetDataBrowserPropertyFlags(m_browser, m_columnOrder[i]->m_property, flags);
			}
		}
	}
}


#define	DRAGDROP_WIDTH			20

void NTitleListBox::OnContent(EventRecord *ev) {
	TPoint mousePt = ev->where;
	mousePt.GlobalToLocal();
	ControlPartCode part = m_browser.HandleControlClick(mousePt, ev->modifiers, NULL);
}

void NTitleListBox::OnMouseCursor(TPoint mousePt) {
	theCursor->Set(arrowCursor);
}

OSErr NTitleListBox::DragReceiveHandler(WindowPtr wp, void *refCon, DragReference dragRef) {
	TSavePort savePort(m_parent);
	TDrag drag(dragRef);
	if (m_dragCanAccept == FALSE)
		return dragNotAcceptedErr;

	DragAttributes attr = drag.GetDragAttributes();
	if (attr & kDragHasLeftSenderWindow && m_dragInContent) {
		HideDragHilite(dragRef);
		m_dragInContent = FALSE;
	}

	if (attr & kDragInsideSenderWindow) {
		return noErr;
	}

	unsigned short numItems, i, numFlavors, j;
	numItems = drag.CountDragItems();

	for (i = 1; i <= numItems; i++) {
		ItemReference item = drag.GetDragItemReferenceNumber(i);
		FlavorType tp = '    ';
		numFlavors = drag.CountDragItemFlavors(item);
		for (j = 1; j <= numFlavors; j++) {
			tp = drag.GetFlavorType(item, j);
			if (tp == 'hfs ')
				break;
		}
		if (tp == 'hfs ') {
			long sz = sizeof(HFSFlavor);
			HFSFlavor hfsf;
			drag.GetFlavorData(item, 'hfs ', &hfsf, &sz, 0);
			if (drag.IsGood() == FALSE)
				continue;

			FInfo info;
			TFSSpec spec(hfsf.fileSpec);
			spec.FSpGetFInfo(&info);
		}
	}
	return noErr;
}

OSErr NTitleListBox::DragTrackingHandler(DragTrackingMessage message, WindowPtr wp, void *refCon, DragReference dragRef) {
	TSavePort savePort(m_parent);
	TDrag drag(dragRef);

	/* handlerɓ */
	if (message == kDragTrackingEnterHandler)	/* drag has entered window */
	{
	}
	/* windowɓ */
	else if (message == kDragTrackingEnterWindow) {
		m_dragCanAccept = FALSE;
		m_dragInContent = FALSE;
		unsigned short numItems, i, numFlavors, j;
		numItems = drag.CountDragItems();
		for (i = 1; i <= numItems; i++) {
			ItemReference item;
			item = drag.GetDragItemReferenceNumber(i);
			FlavorType tp = '    ';
			numFlavors = drag.CountDragItemFlavors(item);
			for (j = 1; j <= numFlavors; j++) {
				tp = drag.GetFlavorType(item, j);
				if (tp == 'hfs ') {
					m_dragCanAccept = TRUE;
					break;
				}
			}
			if (m_dragCanAccept)
				break;
		}
	}
	/* windowŃhbO */
	else if (message == kDragTrackingInWindow)	/* drag is moving within window */
	{
		if (m_dragCanAccept == FALSE)
			return noErr;

		DragAttributes attr;
		attr = drag.GetDragAttributes();
		TPoint mousePt = drag.GetDragMouse();
		mousePt.GlobalToLocal();

		if ((attr & kDragHasLeftSenderWindow) != 0) {
			if (IsInside(mousePt)) {
				if (m_dragInContent == FALSE) {
					TRgn rgn(m_bgRect);
					drag.ShowDragHilite(rgn);
					m_dragInContent = TRUE;
				}
			}
			else {
				if (m_dragInContent) {
					HideDragHilite(dragRef);
					m_dragInContent = FALSE;
				}
			}
		}

		if (IsInside(mousePt)) {
		}
	}
	/* windowOꂽ */
	else if (message == kDragTrackingLeaveWindow)	/* drag has exited window */
	{
		if (m_dragInContent)
			HideDragHilite(dragRef);
		m_dragCanAccept = FALSE;
		m_dragInContent = FALSE;
	}
	/* handlerOꂽ */
	else if (message == kDragTrackingLeaveHandler) {
	}

	return noErr;
}

/*
	r[NX
*/

#define	VIEW_WINDOW_ID		128

NView::NView() {
	m_hasGrowIcon = TRUE;
//	TString name;
	SetName("");

	/* windowTCY̐ݒ */
	TRect wr = thePref->m_openBrowseAsDefault == OFF ? CalcNewWindowRect() : (TRect)thePref->m_defaultBrowseRect;
	if (thePref->m_zoomBrowseToDefault != OFF)
		m_zoomRect = thePref->m_defaultBrowseRect;

	/* view window̍쐬 */
	EnableDrag(FALSE);
	GetNewWindow(VIEW_WINDOW_ID);
	ChangeWindowTitle("Untitled", TRUE);
	SizeWindow(wr.GetWidth(), wr.GetHeight());
	MoveWindow(wr.left, wr.top);
	SetFont(thePref->m_browseFont);
	SetFontSize(thePref->m_browseFontSize);
	SetWindowUserState(wr);
	SetWindowStandardState(m_zoomRect);

	m_scriptCode = FontToScript(thePref->m_browseFont);
	m_uniEncInfo.Create(m_scriptCode);

	TSavePort savePort(this);

	/* EBhEƃRg[̊֘At */
	AppendChildControl(&m_titleBox);

	m_titleBox.m_view = this;

	m_tagList.SetContainer(this);
	m_tagList.m_view = this;

	/* eȋ傫̒ */
	OnChangeSize();

	/* i̍쐬 */
	m_titleBox.NewBox();

	/* \ */
	ShowWindow();

	// 2006.02.08
	m_saveBeforeStr.LoadSTRNum(128, 17);
}

NView::~NView() {
	if (theMWindow->GetCount() == 0)
		SavePref();
	if (theMEdit->m_undoTags.m_view == this) {
		theMEdit->m_undoTags.SetUndoNon();
	}
}

void NView::SavePref() {
	/* windowʒu̕ۑ */
	thePref->m_browseRect = GetPortRectGlobal();
	thePref->m_browseFont = GetFont();
	thePref->m_browseFontSize = GetFontSize();
}

TRect NView::CalcNewWindowRect() {
	return TWindow::CalcNewWindowRect(theMWindow->GetCount(), thePref->m_browseRect);
}

void NView::OnChangeFont(short fontNum, short fontSize) {
	TSavePort savePort(this);
	SetFont(fontNum);
	SetFontSize(fontSize);
	m_scriptCode = FontToScript(fontNum);
	m_uniEncInfo.Create(m_scriptCode);
	thePref->m_browseFont = fontNum;
	thePref->m_browseFontSize = fontSize;
	m_titleBox.OnChangeFont(fontNum, fontSize);
	OnChangeSize();
}

#define	CLOSE_CONFIRM_DLG		130
#define	DISCARD_DITEM			3
#define	MESSAGE_DITEM			4

class NCloseConfirmDlg : public TDialog {
public:
	NCloseConfirmDlg(short dialogID)
			: TDialog(dialogID) {
	}
	virtual Boolean DialogFilter(DialogRef dref, EventRecord *ev, short *itemHit);
};

Boolean NCloseConfirmDlg::DialogFilter(DialogRef dref, EventRecord *ev, short *itemHit) {
	TSavePort savePort(this);

	Boolean flg = FALSE;
	if (ev->what == keyDown) {
		flg = TRUE;
		Boolean command = (ev->modifiers & cmdKey) != 0;
		int code = (ev->message & charCodeMask);
		if ((command && code == '.') ||
		        (command && (code == 'c' || code == 'C')) ||
		        code == 0x1B)
			*itemHit = DEFAULT_CANCEL_DITEM;
		else if ((command && (code == 's' || code == 'S')) ||
		         code == 0x0D ||
		         code == 0x03)
			*itemHit = DEFAULT_OK_DITEM;
		else if (command && (code == 'd' || code == 'D'))
			*itemHit = DISCARD_DITEM;
		else
			flg = FALSE;
		if (flg)
			SetDIHilite(*itemHit, 1);
	}
	else if (ev->what == updateEvt) {
		if (dref == (DialogRef)ev->message)
			OnUpdate();
		else
			Update(ev->message);
	}

	return flg;
}

int NView::CloseConfirmDlg() {
	NCloseConfirmDlg dlg(CLOSE_CONFIRM_DLG);
	TString name(GetName());
	TCFString message;
	message = (TCFString)"\"" + GetName() + (TCFString)"\"" + (TCFString)"\r" + (TCFString)m_saveBeforeStr;
//	dlg.ParamText(name, "\p", "\p", "\p");
	dlg.SetDITextCFString(MESSAGE_DITEM, message);
	int itemHit;
	for (;;) {
		itemHit = dlg.ModalDialog();
		if (itemHit == DEFAULT_OK_DITEM || itemHit == DEFAULT_CANCEL_DITEM || itemHit == DISCARD_DITEM)
			break;
	}
	return itemHit;
}

Boolean NView::OnClose(const AppleEvent *aev) {
	Boolean confirm = FALSE;
	for (NTag *tag = m_tagList.GetTop(); tag != NULL; tag = tag->GetNext()) {
		if (tag->m_modify)
			confirm = TRUE;
	}
	if (confirm) {
		if (aev != NULL) {
			TAppleEvent ae(aev);
			ae.AEInteractWithUser();
		}

		int select = CloseConfirmDlg();
		if (select == DEFAULT_CANCEL_DITEM)
			return FALSE;
		if (select == DEFAULT_OK_DITEM)
			theMFile->OnSave(this);
	}

	return TRUE;
}

void NView::OnKey(CEvent *ev) {
	int data = (ev->message & charCodeMask);
	int code = (ev->message & keyCodeMask) >> 8;
	Boolean shift = (ev->modifiers & shiftKey) != 0;
	Boolean option = (ev->modifiers & optionKey) != 0;
	Boolean control = (ev->modifiers & controlKey) != 0;


	m_titleBox.OnKey(ev);
	return;
}

void NView::OnCopy() {
}

void NView::ChangeWindowTitle(TCFString name, Boolean untitled) {
	TCFString head = "ID3TagEdit : ";
	TCFString s = head + name;
//	TString s;
//	s.sprintf("ID3TagEdit : %s", (char *)name);
	if (untitled == FALSE)
		SetName(name);
	SetWindowTitleWithCFString(s);
//TUniString u = s;
	theMWindow->ChangeWindowName(this);
}

OSErr NView::DragReceiveHandler(WindowPtr wp, void *refCon, DragReference dragRef) {
	return m_titleBox.DragReceiveHandler(wp, refCon, dragRef);
}

OSErr NView::DragTrackingHandler(DragTrackingMessage message, WindowPtr wp, void *refCon, DragReference dragRef) {
	return m_titleBox.DragTrackingHandler(message, wp, refCon, dragRef);
}

TAppleObject *NView::GetObjectProperty(DescType desiredClass, DescType keyForm, const AEDesc *keyData) {
	return NULL;
}

OSErr NView::OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result) {
	if (eventID == kAESetData) {
		ChangeWindowTitle(GetName());
	}
	return noErr;
}

TAppleObject *NView::GetContainedObject(DescType desiredClass, DescType keyForm, const AEDesc *keyData) {
	return NULL;
}

long NView::CountContainedObjects(DescType desiredClass) {
	return 0;
}

OSErr NView::OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result) {
	return errAEEventNotHandled;
}
