/*
	NView.h
	NasuTenr[NX
 
	GripGrop
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.04.06	1.0			Takeshi Yoneki
*/

#ifndef	_NVIEW_H_
#define	_NVIEW_H_

class NTitleListBox;
class NUnderBarBox;
class NView;

#define	COLMN_ID_FIRST			5000
#define	COLMN_ID_MODIFY			5000
#define	COLMN_ID_TRACK			5001
#define	COLMN_ID_FILENAME		5002
#define	COLMN_ID_TITLE			5003
#define	COLMN_ID_ARTIST			5004
#define	COLMN_ID_ALBUM			5005
#define	COLMN_ID_YEAR			5006
#define	COLMN_ID_COMMENT		5007
#define	COLMN_ID_GENRE			5008
#define	COLMN_ID_VERSION		5009
#define	COLMN_ID_LOADENC		5010
#define	COLMN_ID_SAVEENC		5011
#define	COLMN_ID_LAST			5011

#define COLUMN_COUNT			(COLMN_ID_LAST - COLMN_ID_FIRST + 1)

/* for GetStringByPropertyID */
#define	COLMN_ID_TRACKNUM		5101
#define	COLMN_ID_TRACKMAX		5201

#define ICON_MODIFY_NOT			200
#define ICON_MODIFY_DONE		201
#define ICON_MODIFY_WARNING		202

class NGlobalData {
public:
	char m_Latin1ToMacRoman[256];
	char m_macRomanToLatin1[256];
	TString m_shiftJISStr;
	TString m_macRomanStr;
	TString m_asIsStr;
	TIconRef m_statusNotModifyIcon;
	TIconRef m_statusModifyIcon;
	TIconRef m_statusModifyWarningIcon;
	NGlobalData();
};

class NColumnEditable {
public:
	DataBrowserPropertyID m_property;
	Boolean m_editable;
	Boolean m_tsv;
	char *m_title;
	Boolean IsEnableTSV();
};

Boolean EnableDirectEdit();

/*
	NTitleListBox
	^CgXg{bNXNX
*/
class NTitleListBox : public TControlBase {
public:
	NView *m_view;
	int m_listLines;	/* ^CgXg̕\s */
	TDataBrowserControl m_browser;
	TControl m_rootControl;
	TRect m_boxRect;
	TRect m_vScrollRect;
	TRect m_bgRect;
	short m_fontHeight;
	short m_listCount;

	long m_currentColumn;
	Boolean m_editing;
	NColumnEditable *m_columnOrder[16];

	Boolean m_dragCanAccept;	/* D&D */
	Boolean m_dragInContent;

	NTitleListBox();
	~NTitleListBox();
	void NewBox();
	void ChangeDirectEdit();
	void SetAutoTrack();
	void OnChangeFont(short fontNum, short fontSize);
	void OnKey(CEvent *ev);
	int GetNextEditableColumn(int current);
	int GetPrevEditableColumn(int current);

	virtual OSErr DragReceiveHandler(WindowPtr wp, void *refCon, DragReference dragRef);
	virtual OSErr DragTrackingHandler(DragTrackingMessage message, WindowPtr wp, void *refCon, DragReference dragRef);
	/* TControlBasẻz֐ */
	short OnChangeSize(short top);
	void OnUpdate();
	void OnTask();
	void OnActivate(Boolean act);
	Boolean IsInside(TPoint mousePt);
	void OnContent(EventRecord *ev);
	void OnMouseCursor(TPoint mousePt);
};

/*
	NUnderBarBox
	A_[o[{bNXNX
*/
class NUnderBarBox : public TUnderBar {
public:
};

/*
	NView
	r[NX
*/
class NView : public TWindow {
public:
	NTitleListBox m_titleBox;
	short m_fontHeight;
	int m_scriptCode;
	TUnicodeTextEncodingInfo m_uniEncInfo;
	NTagList m_tagList;
	TString m_saveBeforeStr;
	NView();
	~NView();
	TRect CalcNewWindowRect();
	void SavePref();
	int CloseConfirmDlg();
	/* virtual Function*/
	Boolean OnClose(const AppleEvent *aev);
	/**/
	TextEncoding GetTextEncoding() {
		return m_uniEncInfo.m_textEncoding;
	}
	void OnChangeFont(short fontNum, short fontSize);
	void OnKey(CEvent *ev);
	void OnCopy();
	void ChangeWindowTitle(TCFString name, Boolean untitled = FALSE);
	Boolean IsUntitled() {
		return GetName().IsEmpty();
	}
	virtual OSErr DragReceiveHandler(WindowPtr wp, void *refCon, DragReference dragRef);
	virtual OSErr DragTrackingHandler(DragTrackingMessage message, WindowPtr wp, void *refCon, DragReference dragRef);

	NView *GetNext() {
		return (NView *)TWindow::GetNext();
	}

	/* TAppleObject̉z֐ */
	virtual CFStringRef GetObjectName() {
		return GetName();
	}
	virtual DescType GetObjectType() {
		return cWindow;
	}
	virtual TAppleObject *GetContainedObject(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	virtual TAppleObject *GetObjectProperty(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	virtual long CountContainedObjects(DescType desiredClass);
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual OSErr OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result);
};

#endif
